/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Hyper Visor Config</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.HyperVisorConfig#getHyperVisorSystem <em>Hyper Visor System</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.HyperVisorConfig#getVmSchedulers <em>Vm Schedulers</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.HyperVisorConfig#getVirtualCores <em>Virtual Cores</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getHyperVisorConfig()
 * @model
 * @generated
 */
public interface HyperVisorConfig extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Hyper Visor System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Hyper Visor System</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Hyper Visor System</em>' reference.
	 * @see #setHyperVisorSystem(com.inchron.realtime.root.model.System)
	 * @see com.inchron.realtime.root.model.ModelPackage#getHyperVisorConfig_HyperVisorSystem()
	 * @model
	 * @generated
	 */
	com.inchron.realtime.root.model.System getHyperVisorSystem();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.HyperVisorConfig#getHyperVisorSystem <em>Hyper Visor System</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Hyper Visor System</em>' reference.
	 * @see #getHyperVisorSystem()
	 * @generated
	 */
	void setHyperVisorSystem(com.inchron.realtime.root.model.System value);

	/**
	 * Returns the value of the '<em><b>Vm Schedulers</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Scheduler}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Vm Schedulers</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getHyperVisorConfig_VmSchedulers()
	 * @model containment="true"
	 * @generated
	 */
	EList<Scheduler> getVmSchedulers();

	/**
	 * Returns the value of the '<em><b>Virtual Cores</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.CpuCore}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Virtual Cores</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Virtual Cores</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getHyperVisorConfig_VirtualCores()
	 * @model containment="true"
	 * @generated
	 */
	EList<CpuCore> getVirtualCores();

} // HyperVisorConfig
