/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Scheduler</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getSchedulables <em>Schedulables</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getStrategy <em>Strategy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getTimeSlice <em>Time Slice</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getTdmaSchedule <em>Tdma Schedule</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getPeriod <em>Period</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#isSynchronized <em>Synchronized</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getMaxRetard <em>Max Retard</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getMaxAdvance <em>Max Advance</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getSyncSource <em>Sync Source</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getCycleStartProcess <em>Cycle Start Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#isPrioritiesPropagated <em>Priorities Propagated</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#isPriorityInversed <em>Priority Inversed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getCallbacks <em>Callbacks</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.Scheduler#getCallbackCoreAffinity <em>Callback Core Affinity</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler()
 * @model
 * @generated
 */
public interface Scheduler extends Schedulable {
	/**
	 * Returns the value of the '<em><b>Schedulables</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Schedulable}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Schedulables</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Schedulables</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_Schedulables()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<Schedulable> getSchedulables();

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Preemptive"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.SchedulerType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.SchedulerType
	 * @see #setType(SchedulerType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_Type()
	 * @model default="Preemptive" required="true" ordered="false"
	 * @generated
	 */
	SchedulerType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.SchedulerType
	 * @see #getType()
	 * @generated
	 */
	void setType(SchedulerType value);

	/**
	 * Returns the value of the '<em><b>Strategy</b></em>' attribute.
	 * The default value is <code>"FixedPriority"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.SchedulerStrategy}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Strategy</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Strategy</em>' attribute.
	 * @see com.inchron.realtime.root.model.SchedulerStrategy
	 * @see #setStrategy(SchedulerStrategy)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_Strategy()
	 * @model default="FixedPriority" required="true" ordered="false"
	 * @generated
	 */
	SchedulerStrategy getStrategy();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getStrategy <em>Strategy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Strategy</em>' attribute.
	 * @see com.inchron.realtime.root.model.SchedulerStrategy
	 * @see #getStrategy()
	 * @generated
	 */
	void setStrategy(SchedulerStrategy value);

	/**
	 * Returns the value of the '<em><b>Time Slice</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Time Slice</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Time Slice</em>' containment reference.
	 * @see #setTimeSlice(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_TimeSlice()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getTimeSlice();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getTimeSlice <em>Time Slice</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Time Slice</em>' containment reference.
	 * @see #getTimeSlice()
	 * @generated
	 */
	void setTimeSlice(Time value);

	/**
	 * Returns the value of the '<em><b>Tdma Schedule</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.SchedulingEntry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tdma Schedule</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Tdma Schedule</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_TdmaSchedule()
	 * @model containment="true"
	 * @generated
	 */
	EList<SchedulingEntry> getTdmaSchedule();

	/**
	 * Returns the value of the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' containment reference.
	 * @see #setPeriod(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_Period()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getPeriod();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getPeriod <em>Period</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' containment reference.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(Time value);

	/**
	 * Returns the value of the '<em><b>Synchronized</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Synchronized</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Synchronized</em>' attribute.
	 * @see #setSynchronized(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_Synchronized()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isSynchronized();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#isSynchronized <em>Synchronized</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Synchronized</em>' attribute.
	 * @see #isSynchronized()
	 * @generated
	 */
	void setSynchronized(boolean value);

	/**
	 * Returns the value of the '<em><b>Max Retard</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Retard</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Retard</em>' containment reference.
	 * @see #setMaxRetard(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_MaxRetard()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getMaxRetard();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getMaxRetard <em>Max Retard</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Retard</em>' containment reference.
	 * @see #getMaxRetard()
	 * @generated
	 */
	void setMaxRetard(Time value);

	/**
	 * Returns the value of the '<em><b>Max Advance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max Advance</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max Advance</em>' containment reference.
	 * @see #setMaxAdvance(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_MaxAdvance()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getMaxAdvance();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getMaxAdvance <em>Max Advance</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max Advance</em>' containment reference.
	 * @see #getMaxAdvance()
	 * @generated
	 */
	void setMaxAdvance(Time value);

	/**
	 * Returns the value of the '<em><b>Sync Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sync Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sync Source</em>' reference.
	 * @see #setSyncSource(ModelObject)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_SyncSource()
	 * @model
	 * @generated
	 */
	ModelObject getSyncSource();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getSyncSource <em>Sync Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sync Source</em>' reference.
	 * @see #getSyncSource()
	 * @generated
	 */
	void setSyncSource(ModelObject value);

	/**
	 * Returns the value of the '<em><b>Cycle Start Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Cycle Start Process</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cycle Start Process</em>' reference.
	 * @see #setCycleStartProcess(com.inchron.realtime.root.model.Process)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_CycleStartProcess()
	 * @model
	 * @generated
	 */
	com.inchron.realtime.root.model.Process getCycleStartProcess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#getCycleStartProcess <em>Cycle Start Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cycle Start Process</em>' reference.
	 * @see #getCycleStartProcess()
	 * @generated
	 */
	void setCycleStartProcess(com.inchron.realtime.root.model.Process value);

	/**
	 * Returns the value of the '<em><b>Priorities Propagated</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priorities Propagated</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priorities Propagated</em>' attribute.
	 * @see #setPrioritiesPropagated(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_PrioritiesPropagated()
	 * @model default="false"
	 * @generated
	 */
	boolean isPrioritiesPropagated();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#isPrioritiesPropagated <em>Priorities Propagated</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priorities Propagated</em>' attribute.
	 * @see #isPrioritiesPropagated()
	 * @generated
	 */
	void setPrioritiesPropagated(boolean value);

	/**
	 * Returns the value of the '<em><b>Priority Inversed</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Priority Inversed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Priority Inversed</em>' attribute.
	 * @see #setPriorityInversed(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_PriorityInversed()
	 * @model default="false"
	 * @generated
	 */
	boolean isPriorityInversed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.Scheduler#isPriorityInversed <em>Priority Inversed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Priority Inversed</em>' attribute.
	 * @see #isPriorityInversed()
	 * @generated
	 */
	void setPriorityInversed(boolean value);

	/**
	 * Returns the value of the '<em><b>Callbacks</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.CallbackFunction}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Callbacks</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Callbacks</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_Callbacks()
	 * @model containment="true"
	 * @generated
	 */
	EList<CallbackFunction> getCallbacks();

	/**
	 * Returns the value of the '<em><b>Callback Core Affinity</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.CpuCore}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Callback Core Affinity</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Callback Core Affinity</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getScheduler_CallbackCoreAffinity()
	 * @model
	 * @generated
	 */
	EList<CpuCore> getCallbackCoreAffinity();

} // Scheduler
