/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Set Event</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.SetEvent#getEvents <em>Events</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SetEvent#getTarget <em>Target</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SetEvent#isForAll <em>For All</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.SetEvent#isIsReset <em>Is Reset</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getSetEvent()
 * @model
 * @generated
 */
public interface SetEvent extends ActivationAction {
	/**
	 * Returns the value of the '<em><b>Events</b></em>' reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.Event}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Events</em>' reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getSetEvent_Events()
	 * @model required="true"
	 * @generated
	 */
	EList<Event> getEvents();

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(com.inchron.realtime.root.model.Process)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSetEvent_Target()
	 * @model
	 * @generated
	 */
	com.inchron.realtime.root.model.Process getTarget();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SetEvent#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(com.inchron.realtime.root.model.Process value);

	/**
	 * Returns the value of the '<em><b>For All</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>For All</em>' attribute.
	 * @see #setForAll(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSetEvent_ForAll()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isForAll();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SetEvent#isForAll <em>For All</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>For All</em>' attribute.
	 * @see #isForAll()
	 * @generated
	 */
	void setForAll(boolean value);

	/**
	 * Returns the value of the '<em><b>Is Reset</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Is Reset</em>' attribute.
	 * @see #setIsReset(boolean)
	 * @see com.inchron.realtime.root.model.ModelPackage#getSetEvent_IsReset()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isIsReset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.SetEvent#isIsReset <em>Is Reset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Is Reset</em>' attribute.
	 * @see #isIsReset()
	 * @generated
	 */
	void setIsReset(boolean value);

} // SetEvent
