/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Time Distribution</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getMin <em>Min</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getMax <em>Max</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getMean <em>Mean</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getSigma <em>Sigma</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getAlpha <em>Alpha</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getBeta <em>Beta</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getDiscreteDistribution <em>Discrete Distribution</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TimeDistribution#getType <em>Type</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution()
 * @model
 * @generated
 */
public interface TimeDistribution extends EObject {
	/**
	 * Returns the value of the '<em><b>Min</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Min</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Min</em>' containment reference.
	 * @see #setMin(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Min()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getMin();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getMin <em>Min</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Min</em>' containment reference.
	 * @see #getMin()
	 * @generated
	 */
	void setMin(Time value);

	/**
	 * Returns the value of the '<em><b>Max</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Max</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Max</em>' containment reference.
	 * @see #setMax(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Max()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getMax();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getMax <em>Max</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Max</em>' containment reference.
	 * @see #getMax()
	 * @generated
	 */
	void setMax(Time value);

	/**
	 * Returns the value of the '<em><b>Mean</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mean</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mean</em>' containment reference.
	 * @see #setMean(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Mean()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Time getMean();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getMean <em>Mean</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mean</em>' containment reference.
	 * @see #getMean()
	 * @generated
	 */
	void setMean(Time value);

	/**
	 * Returns the value of the '<em><b>Sigma</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sigma</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Sigma</em>' containment reference.
	 * @see #setSigma(Time)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Sigma()
	 * @model containment="true" required="true" ordered="false"
	 * @generated
	 */
	Time getSigma();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getSigma <em>Sigma</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Sigma</em>' containment reference.
	 * @see #getSigma()
	 * @generated
	 */
	void setSigma(Time value);

	/**
	 * Returns the value of the '<em><b>Alpha</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Alpha</em>' attribute.
	 * @see #setAlpha(double)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Alpha()
	 * @model default="1.0"
	 * @generated
	 */
	double getAlpha();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getAlpha <em>Alpha</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Alpha</em>' attribute.
	 * @see #getAlpha()
	 * @generated
	 */
	void setAlpha(double value);

	/**
	 * Returns the value of the '<em><b>Beta</b></em>' attribute.
	 * The default value is <code>"1.0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Beta</em>' attribute.
	 * @see #setBeta(double)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Beta()
	 * @model default="1.0"
	 * @generated
	 */
	double getBeta();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getBeta <em>Beta</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Beta</em>' attribute.
	 * @see #getBeta()
	 * @generated
	 */
	void setBeta(double value);

	/**
	 * Returns the value of the '<em><b>Discrete Distribution</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.DiscreteDistributionEntry}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Discrete Distribution</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Discrete Distribution</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_DiscreteDistribution()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<DiscreteDistributionEntry> getDiscreteDistribution();

	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"Max"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.TimeDistributionType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.TimeDistributionType
	 * @see #setType(TimeDistributionType)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTimeDistribution_Type()
	 * @model default="Max" required="true"
	 * @generated
	 */
	TimeDistributionType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TimeDistribution#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.TimeDistributionType
	 * @see #getType()
	 * @generated
	 */
	void setType(TimeDistributionType value);

} // TimeDistribution
