/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Translation Unit</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.TranslationUnit#getSourceFunctions <em>Source Functions</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.TranslationUnit#getSpecSettings <em>Spec Settings</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.ModelPackage#getTranslationUnit()
 * @model
 * @generated
 */
public interface TranslationUnit extends ModelObject {
	/**
	 * Returns the value of the '<em><b>Source Functions</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.SourceFunction}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source Functions</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source Functions</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.ModelPackage#getTranslationUnit_SourceFunctions()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	EList<SourceFunction> getSourceFunctions();

	/**
	 * Returns the value of the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Spec Settings</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Spec Settings</em>' containment reference.
	 * @see #setSpecSettings(SpecSettings)
	 * @see com.inchron.realtime.root.model.ModelPackage#getTranslationUnit_SpecSettings()
	 * @model containment="true" ordered="false"
	 * @generated
	 */
	SpecSettings getSpecSettings();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.TranslationUnit#getSpecSettings <em>Spec Settings</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Spec Settings</em>' containment reference.
	 * @see #getSpecSettings()
	 * @generated
	 */
	void setSpecSettings(SpecSettings value);

} // TranslationUnit
