/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.autosar;

import com.inchron.realtime.root.model.Spinlock;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Os Spinlock</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsSpinlock#getMethod <em>Method</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.autosar.OsSpinlock#getSuccessor <em>Successor</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsSpinlock()
 * @model
 * @generated
 */
public interface OsSpinlock extends Spinlock {
	/**
	 * Returns the value of the '<em><b>Method</b></em>' attribute.
	 * The default value is <code>"LockAllInterrupts"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Method</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Method</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod
	 * @see #setMethod(OsSpinlockLockMethod)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsSpinlock_Method()
	 * @model default="LockAllInterrupts"
	 * @generated
	 */
	OsSpinlockLockMethod getMethod();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsSpinlock#getMethod <em>Method</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Method</em>' attribute.
	 * @see com.inchron.realtime.root.model.autosar.OsSpinlockLockMethod
	 * @see #getMethod()
	 * @generated
	 */
	void setMethod(OsSpinlockLockMethod value);

	/**
	 * Returns the value of the '<em><b>Successor</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Successor</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Successor</em>' reference.
	 * @see #setSuccessor(OsSpinlock)
	 * @see com.inchron.realtime.root.model.autosar.AutosarPackage#getOsSpinlock_Successor()
	 * @model
	 * @generated
	 */
	OsSpinlock getSuccessor();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.autosar.OsSpinlock#getSuccessor <em>Successor</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Successor</em>' reference.
	 * @see #getSuccessor()
	 * @generated
	 */
	void setSuccessor(OsSpinlock value);

} // OsSpinlock
