/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.fmi.unit;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Base Unit</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getA <em>A</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getCd <em>Cd</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getFactor <em>Factor</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getK <em>K</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getKg <em>Kg</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getM <em>M</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getMol <em>Mol</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getOffset <em>Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getRad <em>Rad</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getS <em>S</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit()
 * @model
 * @generated
 */
public interface BaseUnit extends EObject {
	/**
	 * Returns the value of the '<em><b>A</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>A</em>' attribute.
	 * @see #setA(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_A()
	 * @model default="0"
	 * @generated
	 */
	int getA();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getA <em>A</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>A</em>' attribute.
	 * @see #getA()
	 * @generated
	 */
	void setA(int value);

	/**
	 * Returns the value of the '<em><b>Cd</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Cd</em>' attribute.
	 * @see #setCd(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_Cd()
	 * @model default="0"
	 * @generated
	 */
	int getCd();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getCd <em>Cd</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Cd</em>' attribute.
	 * @see #getCd()
	 * @generated
	 */
	void setCd(int value);

	/**
	 * Returns the value of the '<em><b>Factor</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Factor</em>' attribute.
	 * @see #setFactor(double)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_Factor()
	 * @model default="1"
	 * @generated
	 */
	double getFactor();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getFactor <em>Factor</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Factor</em>' attribute.
	 * @see #getFactor()
	 * @generated
	 */
	void setFactor(double value);

	/**
	 * Returns the value of the '<em><b>K</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>K</em>' attribute.
	 * @see #setK(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_K()
	 * @model default="0"
	 * @generated
	 */
	int getK();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getK <em>K</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>K</em>' attribute.
	 * @see #getK()
	 * @generated
	 */
	void setK(int value);

	/**
	 * Returns the value of the '<em><b>Kg</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Kg</em>' attribute.
	 * @see #setKg(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_Kg()
	 * @model default="0"
	 * @generated
	 */
	int getKg();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getKg <em>Kg</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Kg</em>' attribute.
	 * @see #getKg()
	 * @generated
	 */
	void setKg(int value);

	/**
	 * Returns the value of the '<em><b>M</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>M</em>' attribute.
	 * @see #setM(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_M()
	 * @model default="0"
	 * @generated
	 */
	int getM();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getM <em>M</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>M</em>' attribute.
	 * @see #getM()
	 * @generated
	 */
	void setM(int value);

	/**
	 * Returns the value of the '<em><b>Mol</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mol</em>' attribute.
	 * @see #setMol(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_Mol()
	 * @model default="0"
	 * @generated
	 */
	int getMol();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getMol <em>Mol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mol</em>' attribute.
	 * @see #getMol()
	 * @generated
	 */
	void setMol(int value);

	/**
	 * Returns the value of the '<em><b>Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Offset</em>' attribute.
	 * @see #setOffset(double)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_Offset()
	 * @model default="0"
	 * @generated
	 */
	double getOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getOffset <em>Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Offset</em>' attribute.
	 * @see #getOffset()
	 * @generated
	 */
	void setOffset(double value);

	/**
	 * Returns the value of the '<em><b>Rad</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Rad</em>' attribute.
	 * @see #setRad(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_Rad()
	 * @model default="0"
	 * @generated
	 */
	int getRad();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getRad <em>Rad</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Rad</em>' attribute.
	 * @see #getRad()
	 * @generated
	 */
	void setRad(int value);

	/**
	 * Returns the value of the '<em><b>S</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>S</em>' attribute.
	 * @see #setS(int)
	 * @see com.inchron.realtime.root.model.fmi.unit.UnitPackage#getBaseUnit_S()
	 * @model default="0"
	 * @generated
	 */
	int getS();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.fmi.unit.BaseUnit#getS <em>S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>S</em>' attribute.
	 * @see #getS()
	 * @generated
	 */
	void setS(int value);

} // BaseUnit
