/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.ActivationConnection;
import com.inchron.realtime.root.model.ActivationItem;
import com.inchron.realtime.root.model.ModelPackage;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Activation Connection</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.ActivationConnectionImpl#getActivators <em>Activators</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.ActivationConnectionImpl#isAndSemantic <em>And Semantic</em>}</li>
 * </ul>
 *
 * @generated
 */
public class ActivationConnectionImpl extends ConnectionImpl implements ActivationConnection {
	/**
	 * The cached value of the '{@link #getActivators() <em>Activators</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getActivators()
	 * @generated
	 * @ordered
	 */
	protected EList<ActivationItem> activators;

	/**
	 * The default value of the '{@link #isAndSemantic() <em>And Semantic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAndSemantic()
	 * @generated
	 * @ordered
	 */
	protected static final boolean AND_SEMANTIC_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isAndSemantic() <em>And Semantic</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isAndSemantic()
	 * @generated
	 * @ordered
	 */
	protected boolean andSemantic = AND_SEMANTIC_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ActivationConnectionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getActivationConnection();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ActivationItem> getActivators() {
		if (activators == null) {
			activators = new EObjectWithInverseResolvingEList<ActivationItem>(ActivationItem.class, this, ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS, ModelPackage.ACTIVATION_ITEM__CONNECTION);
		}
		return activators;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isAndSemantic() {
		return andSemantic;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setAndSemantic(boolean newAndSemantic) {
		boolean oldAndSemantic = andSemantic;
		andSemantic = newAndSemantic;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.ACTIVATION_CONNECTION__AND_SEMANTIC, oldAndSemantic, andSemantic));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS:
				return ((InternalEList<InternalEObject>)(InternalEList<?>)getActivators()).basicAdd(otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS:
				return ((InternalEList<?>)getActivators()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS:
				return getActivators();
			case ModelPackage.ACTIVATION_CONNECTION__AND_SEMANTIC:
				return isAndSemantic();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS:
				getActivators().clear();
				getActivators().addAll((Collection<? extends ActivationItem>)newValue);
				return;
			case ModelPackage.ACTIVATION_CONNECTION__AND_SEMANTIC:
				setAndSemantic((Boolean)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS:
				getActivators().clear();
				return;
			case ModelPackage.ACTIVATION_CONNECTION__AND_SEMANTIC:
				setAndSemantic(AND_SEMANTIC_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.ACTIVATION_CONNECTION__ACTIVATORS:
				return activators != null && !activators.isEmpty();
			case ModelPackage.ACTIVATION_CONNECTION__AND_SEMANTIC:
				return andSemantic != AND_SEMANTIC_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (andSemantic: ");
		result.append(andSemantic);
		result.append(')');
		return result.toString();
	}

} //ActivationConnectionImpl
