/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.CANBusMessage;
import com.inchron.realtime.root.model.CANBusMessageFormat;
import com.inchron.realtime.root.model.ModelPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>CAN Bus Message</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.CANBusMessageImpl#getFormat <em>Format</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CANBusMessageImpl#getCanId <em>Can Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.CANBusMessageImpl#getSize <em>Size</em>}</li>
 * </ul>
 *
 * @generated
 */
public class CANBusMessageImpl extends BusMessageImpl implements CANBusMessage {
	/**
	 * The default value of the '{@link #getFormat() <em>Format</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormat()
	 * @generated
	 * @ordered
	 */
	protected static final CANBusMessageFormat FORMAT_EDEFAULT = CANBusMessageFormat.STANDARD;

	/**
	 * The cached value of the '{@link #getFormat() <em>Format</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getFormat()
	 * @generated
	 * @ordered
	 */
	protected CANBusMessageFormat format = FORMAT_EDEFAULT;

	/**
	 * The default value of the '{@link #getCanId() <em>Can Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCanId()
	 * @generated
	 * @ordered
	 */
	protected static final int CAN_ID_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getCanId() <em>Can Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCanId()
	 * @generated
	 * @ordered
	 */
	protected int canId = CAN_ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getSize() <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSize()
	 * @generated
	 * @ordered
	 */
	protected static final int SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getSize() <em>Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSize()
	 * @generated
	 * @ordered
	 */
	protected int size = SIZE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CANBusMessageImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getCANBusMessage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CANBusMessageFormat getFormat() {
		return format;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setFormat(CANBusMessageFormat newFormat) {
		CANBusMessageFormat oldFormat = format;
		format = newFormat == null ? FORMAT_EDEFAULT : newFormat;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CAN_BUS_MESSAGE__FORMAT, oldFormat, format));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getCanId() {
		return canId;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCanId(int newCanId) {
		int oldCanId = canId;
		canId = newCanId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CAN_BUS_MESSAGE__CAN_ID, oldCanId, canId));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getSize() {
		return size;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSize(int newSize) {
		int oldSize = size;
		size = newSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.CAN_BUS_MESSAGE__SIZE, oldSize, size));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.CAN_BUS_MESSAGE__FORMAT:
				return getFormat();
			case ModelPackage.CAN_BUS_MESSAGE__CAN_ID:
				return getCanId();
			case ModelPackage.CAN_BUS_MESSAGE__SIZE:
				return getSize();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.CAN_BUS_MESSAGE__FORMAT:
				setFormat((CANBusMessageFormat)newValue);
				return;
			case ModelPackage.CAN_BUS_MESSAGE__CAN_ID:
				setCanId((Integer)newValue);
				return;
			case ModelPackage.CAN_BUS_MESSAGE__SIZE:
				setSize((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.CAN_BUS_MESSAGE__FORMAT:
				setFormat(FORMAT_EDEFAULT);
				return;
			case ModelPackage.CAN_BUS_MESSAGE__CAN_ID:
				setCanId(CAN_ID_EDEFAULT);
				return;
			case ModelPackage.CAN_BUS_MESSAGE__SIZE:
				setSize(SIZE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.CAN_BUS_MESSAGE__FORMAT:
				return format != FORMAT_EDEFAULT;
			case ModelPackage.CAN_BUS_MESSAGE__CAN_ID:
				return canId != CAN_ID_EDEFAULT;
			case ModelPackage.CAN_BUS_MESSAGE__SIZE:
				return size != SIZE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (format: ");
		result.append(format);
		result.append(", canId: ");
		result.append(canId);
		result.append(", size: ");
		result.append(size);
		result.append(')');
		return result.toString();
	}

} //CANBusMessageImpl
