/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.GraphEntryBase;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.TriggerToken;

import java.util.Collection;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Graph Entry Base</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.GraphEntryBaseImpl#getTriggerTokens <em>Trigger Tokens</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class GraphEntryBaseImpl extends ModelObjectImpl implements GraphEntryBase {
	/**
	 * The cached value of the '{@link #getTriggerTokens() <em>Trigger Tokens</em>}' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTriggerTokens()
	 * @generated
	 * @ordered
	 */
	protected EList<TriggerToken> triggerTokens;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected GraphEntryBaseImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getGraphEntryBase();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<TriggerToken> getTriggerTokens() {
		if (triggerTokens == null) {
			triggerTokens = new EObjectResolvingEList<TriggerToken>(TriggerToken.class, this, ModelPackage.GRAPH_ENTRY_BASE__TRIGGER_TOKENS);
		}
		return triggerTokens;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.GRAPH_ENTRY_BASE__TRIGGER_TOKENS:
				return getTriggerTokens();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.GRAPH_ENTRY_BASE__TRIGGER_TOKENS:
				getTriggerTokens().clear();
				getTriggerTokens().addAll((Collection<? extends TriggerToken>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.GRAPH_ENTRY_BASE__TRIGGER_TOKENS:
				getTriggerTokens().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.GRAPH_ENTRY_BASE__TRIGGER_TOKENS:
				return triggerTokens != null && !triggerTokens.isEmpty();
		}
		return super.eIsSet(featureID);
	}

} //GraphEntryBaseImpl
