/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.impl;

import com.inchron.realtime.root.model.DataFlowConnection;
import com.inchron.realtime.root.model.ModelPackage;
import com.inchron.realtime.root.model.VariableReadAccess;
import com.inchron.realtime.root.model.VariableReadAccessPolicy;
import com.inchron.realtime.root.model.VariableReadAccessType;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Variable Read Access</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl#getConnection <em>Connection</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl#isDataMustBeNew <em>Data Must Be New</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl#getIndex <em>Index</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl#getMinElements <em>Min Elements</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl#getPolicy <em>Policy</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl#getType <em>Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class VariableReadAccessImpl extends VariableAccessImpl implements VariableReadAccess {
	/**
	 * The cached value of the '{@link #getConnection() <em>Connection</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getConnection()
	 * @generated
	 * @ordered
	 */
	protected DataFlowConnection connection;

	/**
	 * The default value of the '{@link #isDataMustBeNew() <em>Data Must Be New</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDataMustBeNew()
	 * @generated
	 * @ordered
	 */
	protected static final boolean DATA_MUST_BE_NEW_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isDataMustBeNew() <em>Data Must Be New</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isDataMustBeNew()
	 * @generated
	 * @ordered
	 */
	protected boolean dataMustBeNew = DATA_MUST_BE_NEW_EDEFAULT;

	/**
	 * The default value of the '{@link #getIndex() <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected static final int INDEX_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getIndex() <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected int index = INDEX_EDEFAULT;

	/**
	 * The default value of the '{@link #getMinElements() <em>Min Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinElements()
	 * @generated
	 * @ordered
	 */
	protected static final int MIN_ELEMENTS_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getMinElements() <em>Min Elements</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMinElements()
	 * @generated
	 * @ordered
	 */
	protected int minElements = MIN_ELEMENTS_EDEFAULT;

	/**
	 * The default value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected static final VariableReadAccessPolicy POLICY_EDEFAULT = VariableReadAccessPolicy.FIFO_TAKE;

	/**
	 * The cached value of the '{@link #getPolicy() <em>Policy</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getPolicy()
	 * @generated
	 * @ordered
	 */
	protected VariableReadAccessPolicy policy = POLICY_EDEFAULT;

	/**
	 * The default value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected static final VariableReadAccessType TYPE_EDEFAULT = VariableReadAccessType.GENERIC;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected VariableReadAccessType type = TYPE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected VariableReadAccessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.eINSTANCE.getVariableReadAccess();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowConnection getConnection() {
		if (connection != null && connection.eIsProxy()) {
			InternalEObject oldConnection = (InternalEObject)connection;
			connection = (DataFlowConnection)eResolveProxy(oldConnection);
			if (connection != oldConnection) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, ModelPackage.VARIABLE_READ_ACCESS__CONNECTION, oldConnection, connection));
			}
		}
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DataFlowConnection basicGetConnection() {
		return connection;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetConnection(DataFlowConnection newConnection, NotificationChain msgs) {
		DataFlowConnection oldConnection = connection;
		connection = newConnection;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__CONNECTION, oldConnection, newConnection);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setConnection(DataFlowConnection newConnection) {
		if (newConnection != connection) {
			NotificationChain msgs = null;
			if (connection != null)
				msgs = ((InternalEObject)connection).eInverseRemove(this, ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS, DataFlowConnection.class, msgs);
			if (newConnection != null)
				msgs = ((InternalEObject)newConnection).eInverseAdd(this, ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS, DataFlowConnection.class, msgs);
			msgs = basicSetConnection(newConnection, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__CONNECTION, newConnection, newConnection));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableReadAccessType getType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setType(VariableReadAccessType newType) {
		VariableReadAccessType oldType = type;
		type = newType == null ? TYPE_EDEFAULT : newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.VARIABLE_READ_ACCESS__CONNECTION:
				if (connection != null)
					msgs = ((InternalEObject)connection).eInverseRemove(this, ModelPackage.DATA_FLOW_CONNECTION__REQUESTERS, DataFlowConnection.class, msgs);
				return basicSetConnection((DataFlowConnection)otherEnd, msgs);
		}
		return super.eInverseAdd(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getIndex() {
		return index;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIndex(int newIndex) {
		int oldIndex = index;
		index = newIndex;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__INDEX, oldIndex, index));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getMinElements() {
		return minElements;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMinElements(int newMinElements) {
		int oldMinElements = minElements;
		minElements = newMinElements;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__MIN_ELEMENTS, oldMinElements, minElements));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public VariableReadAccessPolicy getPolicy() {
		return policy;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPolicy(VariableReadAccessPolicy newPolicy) {
		VariableReadAccessPolicy oldPolicy = policy;
		policy = newPolicy == null ? POLICY_EDEFAULT : newPolicy;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__POLICY, oldPolicy, policy));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isDataMustBeNew() {
		return dataMustBeNew;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDataMustBeNew(boolean newDataMustBeNew) {
		boolean oldDataMustBeNew = dataMustBeNew;
		dataMustBeNew = newDataMustBeNew;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.VARIABLE_READ_ACCESS__DATA_MUST_BE_NEW, oldDataMustBeNew, dataMustBeNew));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.VARIABLE_READ_ACCESS__CONNECTION:
				return basicSetConnection(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.VARIABLE_READ_ACCESS__CONNECTION:
				if (resolve) return getConnection();
				return basicGetConnection();
			case ModelPackage.VARIABLE_READ_ACCESS__DATA_MUST_BE_NEW:
				return isDataMustBeNew();
			case ModelPackage.VARIABLE_READ_ACCESS__INDEX:
				return getIndex();
			case ModelPackage.VARIABLE_READ_ACCESS__MIN_ELEMENTS:
				return getMinElements();
			case ModelPackage.VARIABLE_READ_ACCESS__POLICY:
				return getPolicy();
			case ModelPackage.VARIABLE_READ_ACCESS__TYPE:
				return getType();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.VARIABLE_READ_ACCESS__CONNECTION:
				setConnection((DataFlowConnection)newValue);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__DATA_MUST_BE_NEW:
				setDataMustBeNew((Boolean)newValue);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__INDEX:
				setIndex((Integer)newValue);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__MIN_ELEMENTS:
				setMinElements((Integer)newValue);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__POLICY:
				setPolicy((VariableReadAccessPolicy)newValue);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__TYPE:
				setType((VariableReadAccessType)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.VARIABLE_READ_ACCESS__CONNECTION:
				setConnection((DataFlowConnection)null);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__DATA_MUST_BE_NEW:
				setDataMustBeNew(DATA_MUST_BE_NEW_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__INDEX:
				setIndex(INDEX_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__MIN_ELEMENTS:
				setMinElements(MIN_ELEMENTS_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__POLICY:
				setPolicy(POLICY_EDEFAULT);
				return;
			case ModelPackage.VARIABLE_READ_ACCESS__TYPE:
				setType(TYPE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.VARIABLE_READ_ACCESS__CONNECTION:
				return connection != null;
			case ModelPackage.VARIABLE_READ_ACCESS__DATA_MUST_BE_NEW:
				return dataMustBeNew != DATA_MUST_BE_NEW_EDEFAULT;
			case ModelPackage.VARIABLE_READ_ACCESS__INDEX:
				return index != INDEX_EDEFAULT;
			case ModelPackage.VARIABLE_READ_ACCESS__MIN_ELEMENTS:
				return minElements != MIN_ELEMENTS_EDEFAULT;
			case ModelPackage.VARIABLE_READ_ACCESS__POLICY:
				return policy != POLICY_EDEFAULT;
			case ModelPackage.VARIABLE_READ_ACCESS__TYPE:
				return type != TYPE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (dataMustBeNew: ");
		result.append(dataMustBeNew);
		result.append(", index: ");
		result.append(index);
		result.append(", minElements: ");
		result.append(minElements);
		result.append(", policy: ");
		result.append(policy);
		result.append(", type: ");
		result.append(type);
		result.append(')');
		return result.toString();
	}

} //VariableReadAccessImpl
