/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AFDX Ethernet</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getNetworkId <em>Network Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getEquipmentId <em>Equipment Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getPartitionId <em>Partition Id</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId1 <em>Interface Id1</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac1 <em>Mac1</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId2 <em>Interface Id2</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac2 <em>Mac2</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getAfdxPorts <em>Afdx Ports</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet()
 * @model annotation="http://www.eclipse.org/emf/2002/GenModel name='AFDX Ethernet Controller'"
 * @generated
 */
public interface AFDXEthernet extends AbstractEthernet {
	/**
	 * Returns the value of the '<em><b>Network Id</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Network Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Network Id</em>' attribute.
	 * @see #setNetworkId(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_NetworkId()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getNetworkId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getNetworkId <em>Network Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Network Id</em>' attribute.
	 * @see #getNetworkId()
	 * @generated
	 */
	void setNetworkId(int value);

	/**
	 * Returns the value of the '<em><b>Equipment Id</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Equipment Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Equipment Id</em>' attribute.
	 * @see #setEquipmentId(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_EquipmentId()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getEquipmentId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getEquipmentId <em>Equipment Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Equipment Id</em>' attribute.
	 * @see #getEquipmentId()
	 * @generated
	 */
	void setEquipmentId(int value);

	/**
	 * Returns the value of the '<em><b>Partition Id</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Partition Id</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Partition Id</em>' attribute.
	 * @see #setPartitionId(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_PartitionId()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getPartitionId();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getPartitionId <em>Partition Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Partition Id</em>' attribute.
	 * @see #getPartitionId()
	 * @generated
	 */
	void setPartitionId(int value);

	/**
	 * Returns the value of the '<em><b>Interface Id1</b></em>' attribute.
	 * The default value is <code>"1"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Id1</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Id1</em>' attribute.
	 * @see #setInterfaceId1(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_InterfaceId1()
	 * @model default="1" required="true"
	 * @generated
	 */
	int getInterfaceId1();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId1 <em>Interface Id1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface Id1</em>' attribute.
	 * @see #getInterfaceId1()
	 * @generated
	 */
	void setInterfaceId1(int value);

	/**
	 * Returns the value of the '<em><b>Mac1</b></em>' attribute.
	 * The default value is <code>"00:00:00:00:00:00"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mac1</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mac1</em>' attribute.
	 * @see #setMac1(String)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_Mac1()
	 * @model default="00:00:00:00:00:00" required="true"
	 * @generated
	 */
	String getMac1();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac1 <em>Mac1</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mac1</em>' attribute.
	 * @see #getMac1()
	 * @generated
	 */
	void setMac1(String value);

	/**
	 * Returns the value of the '<em><b>Interface Id2</b></em>' attribute.
	 * The default value is <code>"2"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interface Id2</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interface Id2</em>' attribute.
	 * @see #setInterfaceId2(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_InterfaceId2()
	 * @model default="2" required="true"
	 * @generated
	 */
	int getInterfaceId2();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getInterfaceId2 <em>Interface Id2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interface Id2</em>' attribute.
	 * @see #getInterfaceId2()
	 * @generated
	 */
	void setInterfaceId2(int value);

	/**
	 * Returns the value of the '<em><b>Mac2</b></em>' attribute.
	 * The default value is <code>"00:00:00:00:00:01"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Mac2</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Mac2</em>' attribute.
	 * @see #setMac2(String)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_Mac2()
	 * @model default="00:00:00:00:00:01" required="true"
	 * @generated
	 */
	String getMac2();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AFDXEthernet#getMac2 <em>Mac2</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Mac2</em>' attribute.
	 * @see #getMac2()
	 * @generated
	 */
	void setMac2(String value);

	/**
	 * Returns the value of the '<em><b>Afdx Ports</b></em>' containment reference list.
	 * The list contents are of type {@link com.inchron.realtime.root.model.peripheral.AFDXPort}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Afdx Ports</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Afdx Ports</em>' containment reference list.
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAFDXEthernet_AfdxPorts()
	 * @model containment="true"
	 * @generated
	 */
	EList<AFDXPort> getAfdxPorts();

} // AFDXEthernet
