/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>AS5643 Bus</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643Bus#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AS5643Bus#getFrameLength <em>Frame Length</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643Bus()
 * @model
 * @generated
 */
public interface AS5643Bus extends Bus {
	/**
	 * Returns the value of the '<em><b>Speed</b></em>' attribute.
	 * The default value is <code>"100000000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Speed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Speed</em>' attribute.
	 * @see #setSpeed(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643Bus_Speed()
	 * @model default="100000000" required="true"
	 * @generated
	 */
	int getSpeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643Bus#getSpeed <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Speed</em>' attribute.
	 * @see #getSpeed()
	 * @generated
	 */
	void setSpeed(int value);

	/**
	 * Returns the value of the '<em><b>Frame Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Frame Length</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Frame Length</em>' containment reference.
	 * @see #setFrameLength(Time)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAS5643Bus_FrameLength()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getFrameLength();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AS5643Bus#getFrameLength <em>Frame Length</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Frame Length</em>' containment reference.
	 * @see #getFrameLength()
	 * @generated
	 */
	void setFrameLength(Time value);

} // AS5643Bus
