/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Abstract Ethernet</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isAutoNegotiate <em>Auto Negotiate</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isFullDuplex <em>Full Duplex</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#getNumberOfPorts <em>Number Of Ports</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isSupportsQoS <em>Supports Qo S</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractEthernet()
 * @model abstract="true"
 * @generated
 */
public interface AbstractEthernet extends Peripheral {
	/**
	 * Returns the value of the '<em><b>Auto Negotiate</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Auto Negotiate</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Auto Negotiate</em>' attribute.
	 * @see #setAutoNegotiate(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractEthernet_AutoNegotiate()
	 * @model default="true"
	 * @generated
	 */
	boolean isAutoNegotiate();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isAutoNegotiate <em>Auto Negotiate</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Auto Negotiate</em>' attribute.
	 * @see #isAutoNegotiate()
	 * @generated
	 */
	void setAutoNegotiate(boolean value);

	/**
	 * Returns the value of the '<em><b>Full Duplex</b></em>' attribute.
	 * The default value is <code>"true"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Full Duplex</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Full Duplex</em>' attribute.
	 * @see #setFullDuplex(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractEthernet_FullDuplex()
	 * @model default="true"
	 * @generated
	 */
	boolean isFullDuplex();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isFullDuplex <em>Full Duplex</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Full Duplex</em>' attribute.
	 * @see #isFullDuplex()
	 * @generated
	 */
	void setFullDuplex(boolean value);

	/**
	 * Returns the value of the '<em><b>Number Of Ports</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Number Of Ports</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Number Of Ports</em>' attribute.
	 * @see #setNumberOfPorts(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractEthernet_NumberOfPorts()
	 * @model default="0"
	 * @generated
	 */
	int getNumberOfPorts();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#getNumberOfPorts <em>Number Of Ports</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Number Of Ports</em>' attribute.
	 * @see #getNumberOfPorts()
	 * @generated
	 */
	void setNumberOfPorts(int value);

	/**
	 * Returns the value of the '<em><b>Speed</b></em>' attribute.
	 * The default value is <code>"100000000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Speed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Speed</em>' attribute.
	 * @see #setSpeed(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractEthernet_Speed()
	 * @model default="100000000"
	 * @generated
	 */
	int getSpeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#getSpeed <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Speed</em>' attribute.
	 * @see #getSpeed()
	 * @generated
	 */
	void setSpeed(int value);

	/**
	 * Returns the value of the '<em><b>Supports Qo S</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Supports Qo S</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Supports Qo S</em>' attribute.
	 * @see #setSupportsQoS(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getAbstractEthernet_SupportsQoS()
	 * @model default="false"
	 * @generated
	 */
	boolean isSupportsQoS();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.AbstractEthernet#isSupportsQoS <em>Supports Qo S</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Supports Qo S</em>' attribute.
	 * @see #isSupportsQoS()
	 * @generated
	 */
	void setSupportsQoS(boolean value);

} // AbstractEthernet
