/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>CAN Bus</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.CANBus#isLogEnabled <em>Log Enabled</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.CANBus#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.CANBus#getDataSpeed <em>Data Speed</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCANBus()
 * @model
 * @generated
 */
public interface CANBus extends Bus {
	/**
	 * Returns the value of the '<em><b>Log Enabled</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Log Enabled</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Log Enabled</em>' attribute.
	 * @see #setLogEnabled(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCANBus_LogEnabled()
	 * @model default="false"
	 * @generated
	 */
	boolean isLogEnabled();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.CANBus#isLogEnabled <em>Log Enabled</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Log Enabled</em>' attribute.
	 * @see #isLogEnabled()
	 * @generated
	 */
	void setLogEnabled(boolean value);

	/**
	 * Returns the value of the '<em><b>Speed</b></em>' attribute.
	 * The default value is <code>"250000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Speed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Speed</em>' attribute.
	 * @see #setSpeed(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCANBus_Speed()
	 * @model default="250000"
	 * @generated
	 */
	int getSpeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.CANBus#getSpeed <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Speed</em>' attribute.
	 * @see #getSpeed()
	 * @generated
	 */
	void setSpeed(int value);

	/**
	 * Returns the value of the '<em><b>Data Speed</b></em>' attribute.
	 * The default value is <code>"250000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Data Speed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Data Speed</em>' attribute.
	 * @see #setDataSpeed(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getCANBus_DataSpeed()
	 * @model default="250000"
	 * @generated
	 */
	int getDataSpeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.CANBus#getDataSpeed <em>Data Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Data Speed</em>' attribute.
	 * @see #getDataSpeed()
	 * @generated
	 */
	void setDataSpeed(int value);

} // CANBus
