/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;

import com.inchron.realtime.root.model.Time;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Generic IO</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getType <em>Type</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getSpeed <em>Speed</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getBusWidth <em>Bus Width</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getBlockSize <em>Block Size</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getStartIRQOffset <em>Start IRQ Offset</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#isEmulateDMA <em>Emulate DMA</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getPreOverhead <em>Pre Overhead</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getPostOverhead <em>Post Overhead</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.GenericIO#getSlaveSetupTime <em>Slave Setup Time</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO()
 * @model
 * @generated
 */
public interface GenericIO extends Peripheral {
	/**
	 * Returns the value of the '<em><b>Type</b></em>' attribute.
	 * The default value is <code>"PtP"</code>.
	 * The literals are from the enumeration {@link com.inchron.realtime.root.model.peripheral.GenericIOType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIOType
	 * @see #setType(GenericIOType)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_Type()
	 * @model default="PtP" required="true"
	 * @generated
	 */
	GenericIOType getType();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getType <em>Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Type</em>' attribute.
	 * @see com.inchron.realtime.root.model.peripheral.GenericIOType
	 * @see #getType()
	 * @generated
	 */
	void setType(GenericIOType value);

	/**
	 * Returns the value of the '<em><b>Speed</b></em>' attribute.
	 * The default value is <code>"10000000"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Speed</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Speed</em>' attribute.
	 * @see #setSpeed(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_Speed()
	 * @model default="10000000" required="true"
	 * @generated
	 */
	int getSpeed();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getSpeed <em>Speed</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Speed</em>' attribute.
	 * @see #getSpeed()
	 * @generated
	 */
	void setSpeed(int value);

	/**
	 * Returns the value of the '<em><b>Bus Width</b></em>' attribute.
	 * The default value is <code>"8"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Bus Width</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Bus Width</em>' attribute.
	 * @see #setBusWidth(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_BusWidth()
	 * @model default="8" required="true"
	 * @generated
	 */
	int getBusWidth();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getBusWidth <em>Bus Width</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Bus Width</em>' attribute.
	 * @see #getBusWidth()
	 * @generated
	 */
	void setBusWidth(int value);

	/**
	 * Returns the value of the '<em><b>Block Size</b></em>' attribute.
	 * The default value is <code>"64"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Block Size</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Block Size</em>' attribute.
	 * @see #setBlockSize(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_BlockSize()
	 * @model default="64" required="true"
	 * @generated
	 */
	int getBlockSize();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getBlockSize <em>Block Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Block Size</em>' attribute.
	 * @see #getBlockSize()
	 * @generated
	 */
	void setBlockSize(int value);

	/**
	 * Returns the value of the '<em><b>Start IRQ Offset</b></em>' attribute.
	 * The default value is <code>"0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start IRQ Offset</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start IRQ Offset</em>' attribute.
	 * @see #setStartIRQOffset(int)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_StartIRQOffset()
	 * @model default="0" required="true"
	 * @generated
	 */
	int getStartIRQOffset();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getStartIRQOffset <em>Start IRQ Offset</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start IRQ Offset</em>' attribute.
	 * @see #getStartIRQOffset()
	 * @generated
	 */
	void setStartIRQOffset(int value);

	/**
	 * Returns the value of the '<em><b>Emulate DMA</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Emulate DMA</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Emulate DMA</em>' attribute.
	 * @see #setEmulateDMA(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_EmulateDMA()
	 * @model default="false" required="true"
	 * @generated
	 */
	boolean isEmulateDMA();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#isEmulateDMA <em>Emulate DMA</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Emulate DMA</em>' attribute.
	 * @see #isEmulateDMA()
	 * @generated
	 */
	void setEmulateDMA(boolean value);

	/**
	 * Returns the value of the '<em><b>Pre Overhead</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pre Overhead</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pre Overhead</em>' containment reference.
	 * @see #setPreOverhead(Time)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_PreOverhead()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getPreOverhead();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getPreOverhead <em>Pre Overhead</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pre Overhead</em>' containment reference.
	 * @see #getPreOverhead()
	 * @generated
	 */
	void setPreOverhead(Time value);

	/**
	 * Returns the value of the '<em><b>Post Overhead</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Post Overhead</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Post Overhead</em>' containment reference.
	 * @see #setPostOverhead(Time)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_PostOverhead()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getPostOverhead();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getPostOverhead <em>Post Overhead</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Post Overhead</em>' containment reference.
	 * @see #getPostOverhead()
	 * @generated
	 */
	void setPostOverhead(Time value);

	/**
	 * Returns the value of the '<em><b>Slave Setup Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Slave Setup Time</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Slave Setup Time</em>' containment reference.
	 * @see #setSlaveSetupTime(Time)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getGenericIO_SlaveSetupTime()
	 * @model containment="true" required="true"
	 * @generated
	 */
	Time getSlaveSetupTime();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.GenericIO#getSlaveSetupTime <em>Slave Setup Time</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Slave Setup Time</em>' containment reference.
	 * @see #getSlaveSetupTime()
	 * @generated
	 */
	void setSlaveSetupTime(Time value);

} // GenericIO
