/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>LIN</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.LIN#isMaster <em>Master</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.LIN#getProtocol <em>Protocol</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getLIN()
 * @model
 * @generated
 */
public interface LIN extends Peripheral {
	/**
	 * Returns the value of the '<em><b>Master</b></em>' attribute.
	 * The default value is <code>"false"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Master</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Master</em>' attribute.
	 * @see #setMaster(boolean)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getLIN_Master()
	 * @model default="false"
	 * @generated
	 */
	boolean isMaster();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.LIN#isMaster <em>Master</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Master</em>' attribute.
	 * @see #isMaster()
	 * @generated
	 */
	void setMaster(boolean value);

	/**
	 * Returns the value of the '<em><b>Protocol</b></em>' attribute.
	 * The default value is <code>"2.0"</code>.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Protocol</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Protocol</em>' attribute.
	 * @see #setProtocol(String)
	 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage#getLIN_Protocol()
	 * @model default="2.0"
	 * @generated
	 */
	String getProtocol();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.peripheral.LIN#getProtocol <em>Protocol</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Protocol</em>' attribute.
	 * @see #getProtocol()
	 * @generated
	 */
	void setProtocol(String value);

} // LIN
