/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.impl;

import com.inchron.realtime.root.model.peripheral.Ethernet;
import com.inchron.realtime.root.model.peripheral.PeripheralPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Ethernet</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.EthernetImpl#getMacAddress <em>Mac Address</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.EthernetImpl#isCrossOver <em>Cross Over</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.peripheral.impl.EthernetImpl#getRxQueueSize <em>Rx Queue Size</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EthernetImpl extends AbstractEthernetImpl implements Ethernet {
	/**
	 * The default value of the '{@link #getMacAddress() <em>Mac Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMacAddress()
	 * @generated
	 * @ordered
	 */
	protected static final String MAC_ADDRESS_EDEFAULT = "00:00:00:00:00:00";

	/**
	 * The cached value of the '{@link #getMacAddress() <em>Mac Address</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMacAddress()
	 * @generated
	 * @ordered
	 */
	protected String macAddress = MAC_ADDRESS_EDEFAULT;

	/**
	 * The default value of the '{@link #isCrossOver() <em>Cross Over</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCrossOver()
	 * @generated
	 * @ordered
	 */
	protected static final boolean CROSS_OVER_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isCrossOver() <em>Cross Over</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isCrossOver()
	 * @generated
	 * @ordered
	 */
	protected boolean crossOver = CROSS_OVER_EDEFAULT;

	/**
	 * The default value of the '{@link #getRxQueueSize() <em>Rx Queue Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRxQueueSize()
	 * @generated
	 * @ordered
	 */
	protected static final int RX_QUEUE_SIZE_EDEFAULT = 0;

	/**
	 * The cached value of the '{@link #getRxQueueSize() <em>Rx Queue Size</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getRxQueueSize()
	 * @generated
	 * @ordered
	 */
	protected int rxQueueSize = RX_QUEUE_SIZE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EthernetImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return PeripheralPackage.Literals.ETHERNET;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getMacAddress() {
		return macAddress;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setMacAddress(String newMacAddress) {
		String oldMacAddress = macAddress;
		macAddress = newMacAddress;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ETHERNET__MAC_ADDRESS, oldMacAddress, macAddress));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isCrossOver() {
		return crossOver;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCrossOver(boolean newCrossOver) {
		boolean oldCrossOver = crossOver;
		crossOver = newCrossOver;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ETHERNET__CROSS_OVER, oldCrossOver, crossOver));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public int getRxQueueSize() {
		return rxQueueSize;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRxQueueSize(int newRxQueueSize) {
		int oldRxQueueSize = rxQueueSize;
		rxQueueSize = newRxQueueSize;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, PeripheralPackage.ETHERNET__RX_QUEUE_SIZE, oldRxQueueSize, rxQueueSize));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET__MAC_ADDRESS:
				return getMacAddress();
			case PeripheralPackage.ETHERNET__CROSS_OVER:
				return isCrossOver();
			case PeripheralPackage.ETHERNET__RX_QUEUE_SIZE:
				return getRxQueueSize();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET__MAC_ADDRESS:
				setMacAddress((String)newValue);
				return;
			case PeripheralPackage.ETHERNET__CROSS_OVER:
				setCrossOver((Boolean)newValue);
				return;
			case PeripheralPackage.ETHERNET__RX_QUEUE_SIZE:
				setRxQueueSize((Integer)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET__MAC_ADDRESS:
				setMacAddress(MAC_ADDRESS_EDEFAULT);
				return;
			case PeripheralPackage.ETHERNET__CROSS_OVER:
				setCrossOver(CROSS_OVER_EDEFAULT);
				return;
			case PeripheralPackage.ETHERNET__RX_QUEUE_SIZE:
				setRxQueueSize(RX_QUEUE_SIZE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case PeripheralPackage.ETHERNET__MAC_ADDRESS:
				return MAC_ADDRESS_EDEFAULT == null ? macAddress != null : !MAC_ADDRESS_EDEFAULT.equals(macAddress);
			case PeripheralPackage.ETHERNET__CROSS_OVER:
				return crossOver != CROSS_OVER_EDEFAULT;
			case PeripheralPackage.ETHERNET__RX_QUEUE_SIZE:
				return rxQueueSize != RX_QUEUE_SIZE_EDEFAULT;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (macAddress: ");
		result.append(macAddress);
		result.append(", crossOver: ");
		result.append(crossOver);
		result.append(", rxQueueSize: ");
		result.append(rxQueueSize);
		result.append(')');
		return result.toString();
	}

} //EthernetImpl
