/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.peripheral.util;

import com.inchron.realtime.root.Referrable;

import com.inchron.realtime.root.model.LoadResource;
import com.inchron.realtime.root.model.ModelObject;
import com.inchron.realtime.root.model.TraceObject;

import com.inchron.realtime.root.model.peripheral.*;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.Switch;

/**
 * <!-- begin-user-doc -->
 * The <b>Switch</b> for the model's inheritance hierarchy.
 * It supports the call {@link #doSwitch(EObject) doSwitch(object)}
 * to invoke the <code>caseXXX</code> method for each class of the model,
 * starting with the actual class of the object
 * and proceeding up the inheritance hierarchy
 * until a non-null result is returned,
 * which is the result of the switch.
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.peripheral.PeripheralPackage
 * @generated
 */
public class PeripheralSwitch<T> extends Switch<T> {
	/**
	 * The cached model package
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static PeripheralPackage modelPackage;

	/**
	 * Creates an instance of the switch.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PeripheralSwitch() {
		if (modelPackage == null) {
			modelPackage = PeripheralPackage.eINSTANCE;
		}
	}

	/**
	 * Checks whether this is a switch for the given package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param ePackage the package in question.
	 * @return whether this is a switch for the given package.
	 * @generated
	 */
	@Override
	protected boolean isSwitchFor(EPackage ePackage) {
		return ePackage == modelPackage;
	}

	/**
	 * Calls <code>caseXXX</code> for each class of the model until one returns a non null result; it yields that result.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the first non-null result returned by a <code>caseXXX</code> call.
	 * @generated
	 */
	@Override
	protected T doSwitch(int classifierID, EObject theEObject) {
		switch (classifierID) {
			case PeripheralPackage.ABSTRACT_PORT: {
				AbstractPort abstractPort = (AbstractPort)theEObject;
				T result = caseAbstractPort(abstractPort);
				if (result == null) result = caseModelObject(abstractPort);
				if (result == null) result = caseTraceObject(abstractPort);
				if (result == null) result = caseLoadResource(abstractPort);
				if (result == null) result = caseReferrable(abstractPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.BUS_MASTER_PORT: {
				BusMasterPort busMasterPort = (BusMasterPort)theEObject;
				T result = caseBusMasterPort(busMasterPort);
				if (result == null) result = caseAbstractPort(busMasterPort);
				if (result == null) result = caseModelObject(busMasterPort);
				if (result == null) result = caseTraceObject(busMasterPort);
				if (result == null) result = caseLoadResource(busMasterPort);
				if (result == null) result = caseReferrable(busMasterPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.BUS_SLAVE_PORT: {
				BusSlavePort busSlavePort = (BusSlavePort)theEObject;
				T result = caseBusSlavePort(busSlavePort);
				if (result == null) result = caseAbstractPort(busSlavePort);
				if (result == null) result = caseModelObject(busSlavePort);
				if (result == null) result = caseTraceObject(busSlavePort);
				if (result == null) result = caseLoadResource(busSlavePort);
				if (result == null) result = caseReferrable(busSlavePort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.INTERRUPT_PORT: {
				InterruptPort interruptPort = (InterruptPort)theEObject;
				T result = caseInterruptPort(interruptPort);
				if (result == null) result = caseAbstractPort(interruptPort);
				if (result == null) result = caseModelObject(interruptPort);
				if (result == null) result = caseTraceObject(interruptPort);
				if (result == null) result = caseLoadResource(interruptPort);
				if (result == null) result = caseReferrable(interruptPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.INPUT_PORT: {
				InputPort inputPort = (InputPort)theEObject;
				T result = caseInputPort(inputPort);
				if (result == null) result = caseAbstractPort(inputPort);
				if (result == null) result = caseModelObject(inputPort);
				if (result == null) result = caseTraceObject(inputPort);
				if (result == null) result = caseLoadResource(inputPort);
				if (result == null) result = caseReferrable(inputPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.OUTPUT_PORT: {
				OutputPort outputPort = (OutputPort)theEObject;
				T result = caseOutputPort(outputPort);
				if (result == null) result = caseAbstractPort(outputPort);
				if (result == null) result = caseModelObject(outputPort);
				if (result == null) result = caseTraceObject(outputPort);
				if (result == null) result = caseLoadResource(outputPort);
				if (result == null) result = caseReferrable(outputPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.BI_DIR_PORT: {
				BiDirPort biDirPort = (BiDirPort)theEObject;
				T result = caseBiDirPort(biDirPort);
				if (result == null) result = caseAbstractPort(biDirPort);
				if (result == null) result = caseModelObject(biDirPort);
				if (result == null) result = caseTraceObject(biDirPort);
				if (result == null) result = caseLoadResource(biDirPort);
				if (result == null) result = caseReferrable(biDirPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.PORT_CONNECTION: {
				PortConnection portConnection = (PortConnection)theEObject;
				T result = casePortConnection(portConnection);
				if (result == null) result = caseModelObject(portConnection);
				if (result == null) result = caseReferrable(portConnection);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.ABSTRACT_PERIPHERAL: {
				AbstractPeripheral abstractPeripheral = (AbstractPeripheral)theEObject;
				T result = caseAbstractPeripheral(abstractPeripheral);
				if (result == null) result = caseModelObject(abstractPeripheral);
				if (result == null) result = caseTraceObject(abstractPeripheral);
				if (result == null) result = caseReferrable(abstractPeripheral);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.PERIPHERAL: {
				Peripheral peripheral = (Peripheral)theEObject;
				T result = casePeripheral(peripheral);
				if (result == null) result = caseAbstractPeripheral(peripheral);
				if (result == null) result = caseModelObject(peripheral);
				if (result == null) result = caseTraceObject(peripheral);
				if (result == null) result = caseReferrable(peripheral);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.BUS: {
				Bus bus = (Bus)theEObject;
				T result = caseBus(bus);
				if (result == null) result = caseAbstractPeripheral(bus);
				if (result == null) result = caseModelObject(bus);
				if (result == null) result = caseTraceObject(bus);
				if (result == null) result = caseReferrable(bus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.ABSTRACT_ETHERNET: {
				AbstractEthernet abstractEthernet = (AbstractEthernet)theEObject;
				T result = caseAbstractEthernet(abstractEthernet);
				if (result == null) result = casePeripheral(abstractEthernet);
				if (result == null) result = caseAbstractPeripheral(abstractEthernet);
				if (result == null) result = caseModelObject(abstractEthernet);
				if (result == null) result = caseTraceObject(abstractEthernet);
				if (result == null) result = caseReferrable(abstractEthernet);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.AFDX_PORT: {
				AFDXPort afdxPort = (AFDXPort)theEObject;
				T result = caseAFDXPort(afdxPort);
				if (result == null) result = caseModelObject(afdxPort);
				if (result == null) result = caseReferrable(afdxPort);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.AFDX_ETHERNET: {
				AFDXEthernet afdxEthernet = (AFDXEthernet)theEObject;
				T result = caseAFDXEthernet(afdxEthernet);
				if (result == null) result = caseAbstractEthernet(afdxEthernet);
				if (result == null) result = casePeripheral(afdxEthernet);
				if (result == null) result = caseAbstractPeripheral(afdxEthernet);
				if (result == null) result = caseModelObject(afdxEthernet);
				if (result == null) result = caseTraceObject(afdxEthernet);
				if (result == null) result = caseReferrable(afdxEthernet);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.AS5643: {
				AS5643 as5643 = (AS5643)theEObject;
				T result = caseAS5643(as5643);
				if (result == null) result = casePeripheral(as5643);
				if (result == null) result = caseAbstractPeripheral(as5643);
				if (result == null) result = caseModelObject(as5643);
				if (result == null) result = caseTraceObject(as5643);
				if (result == null) result = caseReferrable(as5643);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.AS5643_BUS: {
				AS5643Bus as5643Bus = (AS5643Bus)theEObject;
				T result = caseAS5643Bus(as5643Bus);
				if (result == null) result = caseBus(as5643Bus);
				if (result == null) result = caseAbstractPeripheral(as5643Bus);
				if (result == null) result = caseModelObject(as5643Bus);
				if (result == null) result = caseTraceObject(as5643Bus);
				if (result == null) result = caseReferrable(as5643Bus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.CAN: {
				CAN can = (CAN)theEObject;
				T result = caseCAN(can);
				if (result == null) result = casePeripheral(can);
				if (result == null) result = caseAbstractPeripheral(can);
				if (result == null) result = caseModelObject(can);
				if (result == null) result = caseTraceObject(can);
				if (result == null) result = caseReferrable(can);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.CAN_BUS: {
				CANBus canBus = (CANBus)theEObject;
				T result = caseCANBus(canBus);
				if (result == null) result = caseBus(canBus);
				if (result == null) result = caseAbstractPeripheral(canBus);
				if (result == null) result = caseModelObject(canBus);
				if (result == null) result = caseTraceObject(canBus);
				if (result == null) result = caseReferrable(canBus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.CONSOLE: {
				Console console = (Console)theEObject;
				T result = caseConsole(console);
				if (result == null) result = casePeripheral(console);
				if (result == null) result = caseAbstractPeripheral(console);
				if (result == null) result = caseModelObject(console);
				if (result == null) result = caseTraceObject(console);
				if (result == null) result = caseReferrable(console);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.ETHERNET: {
				Ethernet ethernet = (Ethernet)theEObject;
				T result = caseEthernet(ethernet);
				if (result == null) result = caseAbstractEthernet(ethernet);
				if (result == null) result = casePeripheral(ethernet);
				if (result == null) result = caseAbstractPeripheral(ethernet);
				if (result == null) result = caseModelObject(ethernet);
				if (result == null) result = caseTraceObject(ethernet);
				if (result == null) result = caseReferrable(ethernet);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.ETHERNET_SWITCH: {
				EthernetSwitch ethernetSwitch = (EthernetSwitch)theEObject;
				T result = caseEthernetSwitch(ethernetSwitch);
				if (result == null) result = caseAbstractEthernet(ethernetSwitch);
				if (result == null) result = casePeripheral(ethernetSwitch);
				if (result == null) result = caseAbstractPeripheral(ethernetSwitch);
				if (result == null) result = caseModelObject(ethernetSwitch);
				if (result == null) result = caseTraceObject(ethernetSwitch);
				if (result == null) result = caseReferrable(ethernetSwitch);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.FLEX_RAY: {
				FlexRay flexRay = (FlexRay)theEObject;
				T result = caseFlexRay(flexRay);
				if (result == null) result = casePeripheral(flexRay);
				if (result == null) result = caseAbstractPeripheral(flexRay);
				if (result == null) result = caseModelObject(flexRay);
				if (result == null) result = caseTraceObject(flexRay);
				if (result == null) result = caseReferrable(flexRay);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.FLEX_RAY_BUS: {
				FlexRayBus flexRayBus = (FlexRayBus)theEObject;
				T result = caseFlexRayBus(flexRayBus);
				if (result == null) result = caseBus(flexRayBus);
				if (result == null) result = caseAbstractPeripheral(flexRayBus);
				if (result == null) result = caseModelObject(flexRayBus);
				if (result == null) result = caseTraceObject(flexRayBus);
				if (result == null) result = caseReferrable(flexRayBus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.GENERIC_IO: {
				GenericIO genericIO = (GenericIO)theEObject;
				T result = caseGenericIO(genericIO);
				if (result == null) result = casePeripheral(genericIO);
				if (result == null) result = caseAbstractPeripheral(genericIO);
				if (result == null) result = caseModelObject(genericIO);
				if (result == null) result = caseTraceObject(genericIO);
				if (result == null) result = caseReferrable(genericIO);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.IRQ: {
				IRQ irq = (IRQ)theEObject;
				T result = caseIRQ(irq);
				if (result == null) result = casePeripheral(irq);
				if (result == null) result = caseAbstractPeripheral(irq);
				if (result == null) result = caseModelObject(irq);
				if (result == null) result = caseTraceObject(irq);
				if (result == null) result = caseReferrable(irq);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.LIN: {
				LIN lin = (LIN)theEObject;
				T result = caseLIN(lin);
				if (result == null) result = casePeripheral(lin);
				if (result == null) result = caseAbstractPeripheral(lin);
				if (result == null) result = caseModelObject(lin);
				if (result == null) result = caseTraceObject(lin);
				if (result == null) result = caseReferrable(lin);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.REST_BUS: {
				RestBus restBus = (RestBus)theEObject;
				T result = caseRestBus(restBus);
				if (result == null) result = caseBus(restBus);
				if (result == null) result = caseAbstractPeripheral(restBus);
				if (result == null) result = caseModelObject(restBus);
				if (result == null) result = caseTraceObject(restBus);
				if (result == null) result = caseReferrable(restBus);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.REST_BUS_CAN: {
				RestBusCAN restBusCAN = (RestBusCAN)theEObject;
				T result = caseRestBusCAN(restBusCAN);
				if (result == null) result = caseBus(restBusCAN);
				if (result == null) result = caseAbstractPeripheral(restBusCAN);
				if (result == null) result = caseModelObject(restBusCAN);
				if (result == null) result = caseTraceObject(restBusCAN);
				if (result == null) result = caseReferrable(restBusCAN);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.REST_BUS_FLEX_RAY: {
				RestBusFlexRay restBusFlexRay = (RestBusFlexRay)theEObject;
				T result = caseRestBusFlexRay(restBusFlexRay);
				if (result == null) result = caseBus(restBusFlexRay);
				if (result == null) result = caseAbstractPeripheral(restBusFlexRay);
				if (result == null) result = caseModelObject(restBusFlexRay);
				if (result == null) result = caseTraceObject(restBusFlexRay);
				if (result == null) result = caseReferrable(restBusFlexRay);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			case PeripheralPackage.TIMER: {
				Timer timer = (Timer)theEObject;
				T result = caseTimer(timer);
				if (result == null) result = casePeripheral(timer);
				if (result == null) result = caseAbstractPeripheral(timer);
				if (result == null) result = caseModelObject(timer);
				if (result == null) result = caseTraceObject(timer);
				if (result == null) result = caseReferrable(timer);
				if (result == null) result = defaultCase(theEObject);
				return result;
			}
			default: return defaultCase(theEObject);
		}
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractPort(AbstractPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Bus Master Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Bus Master Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBusMasterPort(BusMasterPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Bus Slave Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Bus Slave Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBusSlavePort(BusSlavePort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Interrupt Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Interrupt Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInterruptPort(InterruptPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Input Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Input Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseInputPort(InputPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Output Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Output Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseOutputPort(OutputPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Bi Dir Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Bi Dir Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBiDirPort(BiDirPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Port Connection</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Port Connection</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePortConnection(PortConnection object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Peripheral</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Peripheral</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractPeripheral(AbstractPeripheral object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Peripheral</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Peripheral</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T casePeripheral(Peripheral object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Bus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Bus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseBus(Bus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Abstract Ethernet</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Abstract Ethernet</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAbstractEthernet(AbstractEthernet object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>AFDX Port</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>AFDX Port</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAFDXPort(AFDXPort object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>AFDX Ethernet</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>AFDX Ethernet</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAFDXEthernet(AFDXEthernet object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>AS5643</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>AS5643</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAS5643(AS5643 object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>AS5643 Bus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>AS5643 Bus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseAS5643Bus(AS5643Bus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>CAN</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>CAN</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCAN(CAN object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>CAN Bus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>CAN Bus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseCANBus(CANBus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Console</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Console</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseConsole(Console object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Ethernet</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ethernet</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEthernet(Ethernet object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Ethernet Switch</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Ethernet Switch</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseEthernetSwitch(EthernetSwitch object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Flex Ray</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Flex Ray</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlexRay(FlexRay object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Flex Ray Bus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Flex Ray Bus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseFlexRayBus(FlexRayBus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Generic IO</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Generic IO</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseGenericIO(GenericIO object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>IRQ</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>IRQ</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseIRQ(IRQ object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>LIN</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>LIN</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLIN(LIN object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rest Bus</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rest Bus</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRestBus(RestBus object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rest Bus CAN</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rest Bus CAN</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRestBusCAN(RestBusCAN object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Rest Bus Flex Ray</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Rest Bus Flex Ray</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseRestBusFlexRay(RestBusFlexRay object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Timer</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Timer</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTimer(Timer object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Referrable</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Referrable</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseReferrable(Referrable object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Object</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseModelObject(ModelObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Trace Object</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Trace Object</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseTraceObject(TraceObject object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>Load Resource</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>Load Resource</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject) doSwitch(EObject)
	 * @generated
	 */
	public T caseLoadResource(LoadResource object) {
		return null;
	}

	/**
	 * Returns the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * <!-- begin-user-doc -->
	 * This implementation returns null;
	 * returning a non-null result will terminate the switch, but this is the last case anyway.
	 * <!-- end-user-doc -->
	 * @param object the target of the switch.
	 * @return the result of interpreting the object as an instance of '<em>EObject</em>'.
	 * @see #doSwitch(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	@Override
	public T defaultCase(EObject object) {
		return null;
	}

} //PeripheralSwitch
