/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement;

import com.inchron.realtime.root.model.TraceEvent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Event Net Exec Time Requirement</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getEnd <em>End</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getProcess <em>Process</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getStart <em>Start</em>}</li>
 * </ul>
 *
 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventNetExecTimeRequirement()
 * @model
 * @generated
 */
public interface EventNetExecTimeRequirement extends TimingRequirement {
	/**
	 * Returns the value of the '<em><b>End</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>End</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>End</em>' reference.
	 * @see #setEnd(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventNetExecTimeRequirement_End()
	 * @model required="true"
	 * @generated
	 */
	TraceEvent getEnd();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getEnd <em>End</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>End</em>' reference.
	 * @see #getEnd()
	 * @generated
	 */
	void setEnd(TraceEvent value);

	/**
	 * Returns the value of the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Process</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Process</em>' reference.
	 * @see #setProcess(com.inchron.realtime.root.model.Process)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventNetExecTimeRequirement_Process()
	 * @model required="true"
	 * @generated
	 */
	com.inchron.realtime.root.model.Process getProcess();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getProcess <em>Process</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Process</em>' reference.
	 * @see #getProcess()
	 * @generated
	 */
	void setProcess(com.inchron.realtime.root.model.Process value);

	/**
	 * Returns the value of the '<em><b>Start</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Start</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Start</em>' reference.
	 * @see #setStart(TraceEvent)
	 * @see com.inchron.realtime.root.model.requirement.RequirementPackage#getEventNetExecTimeRequirement_Start()
	 * @model required="true"
	 * @generated
	 */
	TraceEvent getStart();

	/**
	 * Sets the value of the '{@link com.inchron.realtime.root.model.requirement.EventNetExecTimeRequirement#getStart <em>Start</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Start</em>' reference.
	 * @see #getStart()
	 * @generated
	 */
	void setStart(TraceEvent value);

} // EventNetExecTimeRequirement
