/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.requirement.impl;

import com.inchron.realtime.root.model.EventChain;

import com.inchron.realtime.root.model.requirement.EventChainMultipleProcessingRequirement;
import com.inchron.realtime.root.model.requirement.RequirementPackage;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Event Chain Multiple Processing Requirement</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.requirement.impl.EventChainMultipleProcessingRequirementImpl#getEventChain <em>Event Chain</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EventChainMultipleProcessingRequirementImpl extends RequirementImpl implements EventChainMultipleProcessingRequirement {
	/**
	 * The cached value of the '{@link #getEventChain() <em>Event Chain</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEventChain()
	 * @generated
	 * @ordered
	 */
	protected EventChain eventChain;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EventChainMultipleProcessingRequirementImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RequirementPackage.Literals.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChain getEventChain() {
		if (eventChain != null && eventChain.eIsProxy()) {
			InternalEObject oldEventChain = (InternalEObject)eventChain;
			eventChain = (EventChain)eResolveProxy(oldEventChain);
			if (eventChain != oldEventChain) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN, oldEventChain, eventChain));
			}
		}
		return eventChain;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EventChain basicGetEventChain() {
		return eventChain;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEventChain(EventChain newEventChain) {
		EventChain oldEventChain = eventChain;
		eventChain = newEventChain;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN, oldEventChain, eventChain));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN:
				if (resolve) return getEventChain();
				return basicGetEventChain();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN:
				setEventChain((EventChain)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN:
				setEventChain((EventChain)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RequirementPackage.EVENT_CHAIN_MULTIPLE_PROCESSING_REQUIREMENT__EVENT_CHAIN:
				return eventChain != null;
		}
		return super.eIsSet(featureID);
	}

} //EventChainMultipleProcessingRequirementImpl
