/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model.stimulation.impl;

import com.inchron.realtime.root.model.TimeDistribution;

import com.inchron.realtime.root.model.stimulation.EliminationFilter;
import com.inchron.realtime.root.model.stimulation.StimulationPackage;
import com.inchron.realtime.root.model.stimulation.StimuliGenerator;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Elimination Filter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.EliminationFilterImpl#getSourceGenerator <em>Source Generator</em>}</li>
 *   <li>{@link com.inchron.realtime.root.model.stimulation.impl.EliminationFilterImpl#getTimeFrame <em>Time Frame</em>}</li>
 * </ul>
 *
 * @generated
 */
public class EliminationFilterImpl extends StimulationFilterImpl implements EliminationFilter {
	/**
	 * The cached value of the '{@link #getSourceGenerator() <em>Source Generator</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSourceGenerator()
	 * @generated
	 * @ordered
	 */
	protected StimuliGenerator sourceGenerator;

	/**
	 * The cached value of the '{@link #getTimeFrame() <em>Time Frame</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTimeFrame()
	 * @generated
	 * @ordered
	 */
	protected TimeDistribution timeFrame;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EliminationFilterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return StimulationPackage.Literals.ELIMINATION_FILTER;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimuliGenerator getSourceGenerator() {
		if (sourceGenerator != null && sourceGenerator.eIsProxy()) {
			InternalEObject oldSourceGenerator = (InternalEObject)sourceGenerator;
			sourceGenerator = (StimuliGenerator)eResolveProxy(oldSourceGenerator);
			if (sourceGenerator != oldSourceGenerator) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, StimulationPackage.ELIMINATION_FILTER__SOURCE_GENERATOR, oldSourceGenerator, sourceGenerator));
			}
		}
		return sourceGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public StimuliGenerator basicGetSourceGenerator() {
		return sourceGenerator;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setSourceGenerator(StimuliGenerator newSourceGenerator) {
		StimuliGenerator oldSourceGenerator = sourceGenerator;
		sourceGenerator = newSourceGenerator;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.ELIMINATION_FILTER__SOURCE_GENERATOR, oldSourceGenerator, sourceGenerator));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public TimeDistribution getTimeFrame() {
		return timeFrame;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetTimeFrame(TimeDistribution newTimeFrame, NotificationChain msgs) {
		TimeDistribution oldTimeFrame = timeFrame;
		timeFrame = newTimeFrame;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, StimulationPackage.ELIMINATION_FILTER__TIME_FRAME, oldTimeFrame, newTimeFrame);
			if (msgs == null) msgs = notification; else msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setTimeFrame(TimeDistribution newTimeFrame) {
		if (newTimeFrame != timeFrame) {
			NotificationChain msgs = null;
			if (timeFrame != null)
				msgs = ((InternalEObject)timeFrame).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.ELIMINATION_FILTER__TIME_FRAME, null, msgs);
			if (newTimeFrame != null)
				msgs = ((InternalEObject)newTimeFrame).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - StimulationPackage.ELIMINATION_FILTER__TIME_FRAME, null, msgs);
			msgs = basicSetTimeFrame(newTimeFrame, msgs);
			if (msgs != null) msgs.dispatch();
		}
		else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, StimulationPackage.ELIMINATION_FILTER__TIME_FRAME, newTimeFrame, newTimeFrame));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case StimulationPackage.ELIMINATION_FILTER__TIME_FRAME:
				return basicSetTimeFrame(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case StimulationPackage.ELIMINATION_FILTER__SOURCE_GENERATOR:
				if (resolve) return getSourceGenerator();
				return basicGetSourceGenerator();
			case StimulationPackage.ELIMINATION_FILTER__TIME_FRAME:
				return getTimeFrame();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case StimulationPackage.ELIMINATION_FILTER__SOURCE_GENERATOR:
				setSourceGenerator((StimuliGenerator)newValue);
				return;
			case StimulationPackage.ELIMINATION_FILTER__TIME_FRAME:
				setTimeFrame((TimeDistribution)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case StimulationPackage.ELIMINATION_FILTER__SOURCE_GENERATOR:
				setSourceGenerator((StimuliGenerator)null);
				return;
			case StimulationPackage.ELIMINATION_FILTER__TIME_FRAME:
				setTimeFrame((TimeDistribution)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case StimulationPackage.ELIMINATION_FILTER__SOURCE_GENERATOR:
				return sourceGenerator != null;
			case StimulationPackage.ELIMINATION_FILTER__TIME_FRAME:
				return timeFrame != null;
		}
		return super.eIsSet(featureID);
	}

} //EliminationFilterImpl
