/*******************************************************************************
 * Copyright (c) 2019 Dortmund University of Applied Sciences and Arts.
 *
 * This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License 2.0
 * which accompanies this distribution, and is available at
 * https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Contributors:
 *     FH Dortmund - initial API and implementation
 *******************************************************************************/
package org.eclipse.app4mc.gsoc_rta;

import org.eclipse.app4mc.amalthea.model.util.RuntimeUtil.TimeType;

public class SharedConsts {
	/*-----------Measurement Configuration--------------–*/
	public static TimeType timeType = TimeType.WCET;
	public static boolean onlyWrittenLabelsCE = true;
	public static boolean synchronousOffloading = false;
	public static boolean useModelTimeSlices = false;
	public static boolean ignoreInfeasibility = true;
	public static int[] timeSlices;
	public static long timeSliceLengthPS = 1000000000l;
	public static final boolean levelIBusyPeriod = false;
	public static TS_DERIV tsDeriv = TS_DERIV.TSxPrio;
	public static OPT_TYPE optimize = OPT_TYPE.RESPONSETIMESUM;
	public static int comParadigm = 0;
	/*-----------End Measur. Configuration--------------–*/

	/* Arbitrary Integer Array (GA scenario) */
	public static final int[] defaultIAMapping = new int[] { 4, 1, 1, 3, 4, 0, 1, 3, 3, 0, 6, 2, 5, 6 };

	public enum OPT_TYPE {
		TASKCHAINS, RESPONSETIMESUM, LOADBALANCING
	}

	public enum TS_DERIV {
		TS, TSxPrio, TSxUtil, TSxUtilxNbTasks
	}

	public enum MAPPINGS {
		EV, RTS, TCS, LB, RND
	}
}