/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2014, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF THIS ECLIPSE PUBLIC
 * LICENSE ("AGREEMENT"). [Eclipse Public License - v 1.0]
 * 
 * ANY USE, REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
 * RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.
 * 
 * You may obtain a copy of the License at
 * 
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.cucadiagram.dot;

import java.io.File;

class OSLinux extends OS {

	@Override
	File getExecutable(GraphvizLayoutStrategy strategy) {
		final File result = strategy.getSystemForcedExecutable();
		if (result != null) {
			return result;
		}
		final String fileName = getFileName(strategy);
		final File usrLocalBin = new File("/usr/local/bin/" + fileName);

		if (usrLocalBin.exists()) {
			return usrLocalBin;
		}
		final File usrBin = new File("/usr/bin/" + fileName);
		return usrBin;
	}

	@Override
	String getFileName(GraphvizLayoutStrategy strategy) {
		return strategy.name().toLowerCase();
	}

	@Override
	public String getCommand(GraphvizLayoutStrategy strategy) {
		return getExecutable(strategy).getAbsolutePath();
	}

}
