/**
 * Copyright (c) 2017-2018 INCHRON GmbH
 * 
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 * 
 * SPDX-License-Identifier: EPL-2.0
 * 
 * Contributors:
 *     INCHRON GmbH - Meta Model design and implementation
 */
package com.inchron.realtime.root.model;

import com.inchron.realtime.root.RootPackage;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see com.inchron.realtime.root.model.ModelFactory
 * @model kind="package"
 * @generated
 */
public interface ModelPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "model";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://inchron.com/realtime/root/2.98.5/model";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "model";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ModelPackage eINSTANCE = com.inchron.realtime.root.model.impl.ModelPackageImpl.init();

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.AbstractCpuModelImpl <em>Abstract Cpu Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.AbstractCpuModelImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getAbstractCpuModel()
	 * @generated
	 */
	int ABSTRACT_CPU_MODEL = 0;

	/**
	 * The number of structural features of the '<em>Abstract Cpu Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CPU_MODEL_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Abstract Cpu Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ABSTRACT_CPU_MODEL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ActivationActionImpl <em>Activation Action</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ActivationActionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getActivationAction()
	 * @generated
	 */
	int ACTIVATION_ACTION = 4;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ACTION__OFFSET = 0;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ACTION__PERIOD = 1;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ACTION__DELAY = 2;

	/**
	 * The number of structural features of the '<em>Activation Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ACTION_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Activation Action</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ACTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ActivateProcessImpl <em>Activate Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ActivateProcessImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getActivateProcess()
	 * @generated
	 */
	int ACTIVATE_PROCESS = 1;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_PROCESS__OFFSET = ACTIVATION_ACTION__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_PROCESS__PERIOD = ACTIVATION_ACTION__PERIOD;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_PROCESS__DELAY = ACTIVATION_ACTION__DELAY;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_PROCESS__TARGET = ACTIVATION_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Activate Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_PROCESS_FEATURE_COUNT = ACTIVATION_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Activate Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATE_PROCESS_OPERATION_COUNT = ACTIVATION_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModelObjectImpl <em>Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModelObjectImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModelObject()
	 * @generated
	 */
	int MODEL_OBJECT = 52;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT__INTRINSIC_ID = RootPackage.REFERRABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT__NAME = RootPackage.REFERRABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT_FEATURE_COUNT = RootPackage.REFERRABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OBJECT_OPERATION_COUNT = RootPackage.REFERRABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ConnectionImpl <em>Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ConnectionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getConnection()
	 * @generated
	 */
	int CONNECTION = 20;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Activations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION__ACTIVATIONS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONNECTION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ActivationConnectionImpl <em>Activation Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ActivationConnectionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getActivationConnection()
	 * @generated
	 */
	int ACTIVATION_CONNECTION = 2;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION__INTRINSIC_ID = CONNECTION__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Activations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION__ACTIVATIONS = CONNECTION__ACTIVATIONS;

	/**
	 * The feature id for the '<em><b>Activators</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION__ACTIVATORS = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>And Semantic</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION__AND_SEMANTIC = CONNECTION_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Activation Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Activation Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_CONNECTION_OPERATION_COUNT = CONNECTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CallSequenceItemImpl <em>Call Sequence Item</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CallSequenceItemImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCallSequenceItem()
	 * @generated
	 */
	int CALL_SEQUENCE_ITEM = 11;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_ITEM__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_ITEM__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_ITEM__OFFSET = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_ITEM__PERIOD = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Call Sequence Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_ITEM_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Call Sequence Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_ITEM_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ActivationItemImpl <em>Activation Item</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ActivationItemImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getActivationItem()
	 * @generated
	 */
	int ACTIVATION_ITEM = 3;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM__CONNECTION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM__DELAY = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Activation Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Activation Item</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACTIVATION_ITEM_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.AddressRangeImpl <em>Address Range</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.AddressRangeImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getAddressRange()
	 * @generated
	 */
	int ADDRESS_RANGE = 5;

	/**
	 * The feature id for the '<em><b>Base</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_RANGE__BASE = 0;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_RANGE__SIZE = 1;

	/**
	 * The number of structural features of the '<em>Address Range</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_RANGE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Address Range</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADDRESS_RANGE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SystemImpl <em>System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SystemImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSystem()
	 * @generated
	 */
	int SYSTEM = 79;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Compiler Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__COMPILER_SETTINGS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__COMPONENTS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Mode Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__MODE_CONDITIONS = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Mode Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__MODE_GROUPS = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Rtos Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__RTOS_MODEL = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__SPEC_SETTINGS = MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM__TRANSLATION_UNITS = MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SYSTEM_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ArincSystemImpl <em>Arinc System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ArincSystemImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getArincSystem()
	 * @generated
	 */
	int ARINC_SYSTEM = 6;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__INTRINSIC_ID = SYSTEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__NAME = SYSTEM__NAME;

	/**
	 * The feature id for the '<em><b>Compiler Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__COMPILER_SETTINGS = SYSTEM__COMPILER_SETTINGS;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__COMPONENTS = SYSTEM__COMPONENTS;

	/**
	 * The feature id for the '<em><b>Mode Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__MODE_CONDITIONS = SYSTEM__MODE_CONDITIONS;

	/**
	 * The feature id for the '<em><b>Mode Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__MODE_GROUPS = SYSTEM__MODE_GROUPS;

	/**
	 * The feature id for the '<em><b>Rtos Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__RTOS_MODEL = SYSTEM__RTOS_MODEL;

	/**
	 * The feature id for the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__SPEC_SETTINGS = SYSTEM__SPEC_SETTINGS;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM__TRANSLATION_UNITS = SYSTEM__TRANSLATION_UNITS;

	/**
	 * The number of structural features of the '<em>Arinc System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM_FEATURE_COUNT = SYSTEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Arinc System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ARINC_SYSTEM_OPERATION_COUNT = SYSTEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.BusMessageImpl <em>Bus Message</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.BusMessageImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getBusMessage()
	 * @generated
	 */
	int BUS_MESSAGE = 7;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Full Messages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE__FULL_MESSAGES = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE__EVENTS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>In Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE__IN_CALL_GRAPH = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Out Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE__OUT_CALL_GRAPH = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Bus Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Bus Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BUS_MESSAGE_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CallbackFunctionImpl <em>Callback Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CallbackFunctionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCallbackFunction()
	 * @generated
	 */
	int CALLBACK_FUNCTION = 8;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLBACK_FUNCTION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLBACK_FUNCTION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Entry Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLBACK_FUNCTION__ENTRY_FUNCTION = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLBACK_FUNCTION__TYPE = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Callback Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLBACK_FUNCTION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Callback Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALLBACK_FUNCTION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CallGraphImpl <em>Call Graph</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CallGraphImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCallGraph()
	 * @generated
	 */
	int CALL_GRAPH = 9;

	/**
	 * The feature id for the '<em><b>Endless Loop</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_GRAPH__ENDLESS_LOOP = 0;

	/**
	 * The feature id for the '<em><b>Graph Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_GRAPH__GRAPH_ENTRIES = 1;

	/**
	 * The number of structural features of the '<em>Call Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_GRAPH_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Call Graph</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_GRAPH_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.GraphEntryBaseImpl <em>Graph Entry Base</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.GraphEntryBaseImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getGraphEntryBase()
	 * @generated
	 */
	int GRAPH_ENTRY_BASE = 37;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_ENTRY_BASE__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_ENTRY_BASE__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Trigger Tokens</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_ENTRY_BASE__TRIGGER_TOKENS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Graph Entry Base</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_ENTRY_BASE_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Graph Entry Base</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GRAPH_ENTRY_BASE_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CallSequenceImpl <em>Call Sequence</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CallSequenceImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCallSequence()
	 * @generated
	 */
	int CALL_SEQUENCE = 10;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE__INTRINSIC_ID = GRAPH_ENTRY_BASE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE__NAME = GRAPH_ENTRY_BASE__NAME;

	/**
	 * The feature id for the '<em><b>Trigger Tokens</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE__TRIGGER_TOKENS = GRAPH_ENTRY_BASE__TRIGGER_TOKENS;

	/**
	 * The feature id for the '<em><b>Calls</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE__CALLS = GRAPH_ENTRY_BASE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Call Sequence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_FEATURE_COUNT = GRAPH_ENTRY_BASE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Call Sequence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CALL_SEQUENCE_OPERATION_COUNT = GRAPH_ENTRY_BASE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CANBusMessageImpl <em>CAN Bus Message</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CANBusMessageImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCANBusMessage()
	 * @generated
	 */
	int CAN_BUS_MESSAGE = 12;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__INTRINSIC_ID = BUS_MESSAGE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__NAME = BUS_MESSAGE__NAME;

	/**
	 * The feature id for the '<em><b>Full Messages</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__FULL_MESSAGES = BUS_MESSAGE__FULL_MESSAGES;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__EVENTS = BUS_MESSAGE__EVENTS;

	/**
	 * The feature id for the '<em><b>In Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__IN_CALL_GRAPH = BUS_MESSAGE__IN_CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Out Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__OUT_CALL_GRAPH = BUS_MESSAGE__OUT_CALL_GRAPH;

	/**
	 * The feature id for the '<em><b>Format</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__FORMAT = BUS_MESSAGE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Can Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__CAN_ID = BUS_MESSAGE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE__SIZE = BUS_MESSAGE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>CAN Bus Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE_FEATURE_COUNT = BUS_MESSAGE_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>CAN Bus Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CAN_BUS_MESSAGE_OPERATION_COUNT = BUS_MESSAGE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ClockImpl <em>Clock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ClockImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getClock()
	 * @generated
	 */
	int CLOCK = 13;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Frequency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__FREQUENCY = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__PERIOD = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Drift</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__DRIFT = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Range</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__RANGE = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Start Time Fixed</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__START_TIME_FIXED = MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Start Time Is Random</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__START_TIME_IS_RANDOM = MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Start Time Min</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__START_TIME_MIN = MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Start Time Max</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__START_TIME_MAX = MODEL_OBJECT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Start Value</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__START_VALUE = MODEL_OBJECT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Users</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK__USERS = MODEL_OBJECT_FEATURE_COUNT + 10;

	/**
	 * The number of structural features of the '<em>Clock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 11;

	/**
	 * The number of operations of the '<em>Clock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ClockUserImpl <em>Clock User</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ClockUserImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getClockUser()
	 * @generated
	 */
	int CLOCK_USER = 14;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_USER__CLOCK = 0;

	/**
	 * The number of structural features of the '<em>Clock User</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_USER_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Clock User</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CLOCK_USER_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ContainerImpl <em>Container</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ContainerImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getContainer()
	 * @generated
	 */
	int CONTAINER = 15;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Contents</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER__CONTENTS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Container</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ContainerElementImpl <em>Container Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ContainerElementImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getContainerElement()
	 * @generated
	 */
	int CONTAINER_ELEMENT = 16;

	/**
	 * The number of structural features of the '<em>Container Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_ELEMENT_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Container Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTAINER_ELEMENT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CompilerSettingsImpl <em>Compiler Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CompilerSettingsImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCompilerSettings()
	 * @generated
	 */
	int COMPILER_SETTINGS = 17;

	/**
	 * The feature id for the '<em><b>Is Target Compiler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS__IS_TARGET_COMPILER = 0;

	/**
	 * The feature id for the '<em><b>Is Target Compiler Override Values</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS__IS_TARGET_COMPILER_OVERRIDE_VALUES = 1;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS__TYPE = 2;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS__VERSION = 3;

	/**
	 * The feature id for the '<em><b>Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS__PATH = 4;

	/**
	 * The feature id for the '<em><b>Args</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS__ARGS = 5;

	/**
	 * The number of structural features of the '<em>Compiler Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Compiler Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPILER_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ComponentImpl <em>Component</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ComponentImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getComponent()
	 * @generated
	 */
	int COMPONENT = 18;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Variables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__VARIABLES = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__FUNCTIONS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT__TRANSLATION_UNITS = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Component</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPONENT_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.EventChainStepImpl <em>Event Chain Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.EventChainStepImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEventChainStep()
	 * @generated
	 */
	int EVENT_CHAIN_STEP = 32;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_STEP__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_STEP__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_STEP__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_STEP__LABEL = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Event Chain Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_STEP_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Event Chain Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_STEP_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ConditionalTraceEventImpl <em>Conditional Trace Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ConditionalTraceEventImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getConditionalTraceEvent()
	 * @generated
	 */
	int CONDITIONAL_TRACE_EVENT = 19;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__INTRINSIC_ID = EVENT_CHAIN_STEP__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__NAME = EVENT_CHAIN_STEP__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__OBJECT_ID = EVENT_CHAIN_STEP__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__LABEL = EVENT_CHAIN_STEP__LABEL;

	/**
	 * The feature id for the '<em><b>Trace Event</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__TRACE_EVENT = EVENT_CHAIN_STEP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__PROCESS = EVENT_CHAIN_STEP_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Value Constraint</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT__VALUE_CONSTRAINT = EVENT_CHAIN_STEP_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Conditional Trace Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT_FEATURE_COUNT = EVENT_CHAIN_STEP_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Conditional Trace Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONDITIONAL_TRACE_EVENT_OPERATION_COUNT = EVENT_CHAIN_STEP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CpuImpl <em>Cpu</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CpuImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCpu()
	 * @generated
	 */
	int CPU = 21;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Clock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__CLOCK = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Cores</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__CORES = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Cpu Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__CPU_MODEL = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Reload Cpu Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__RELOAD_CPU_MODEL = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Hypervisor</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__HYPERVISOR = MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Interconnects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__INTERCONNECTS = MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Memories</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__MEMORIES = MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Memory Regions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__MEMORY_REGIONS = MODEL_OBJECT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Partitions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__PARTITIONS = MODEL_OBJECT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Peripherals</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU__PERIPHERALS = MODEL_OBJECT_FEATURE_COUNT + 10;

	/**
	 * The number of structural features of the '<em>Cpu</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 11;

	/**
	 * The number of operations of the '<em>Cpu</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.CpuCoreImpl <em>Cpu Core</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.CpuCoreImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCpuCore()
	 * @generated
	 */
	int CPU_CORE = 22;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Prescaler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE__PRESCALER = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Bit Width</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE__BIT_WIDTH = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Connected Slave</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE__CONNECTED_SLAVE = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Cpu Core</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Cpu Core</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CPU_CORE_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.EventChainImpl <em>Event Chain</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.EventChainImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEventChain()
	 * @generated
	 */
	int EVENT_CHAIN = 31;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Event Chain</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Event Chain</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_CHAIN_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.DataFlowImpl <em>Data Flow</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.DataFlowImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getDataFlow()
	 * @generated
	 */
	int DATA_FLOW = 23;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__INTRINSIC_ID = EVENT_CHAIN__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__NAME = EVENT_CHAIN__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__OBJECT_ID = EVENT_CHAIN__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__EDGES = EVENT_CHAIN_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>References</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW__REFERENCES = EVENT_CHAIN_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Data Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_FEATURE_COUNT = EVENT_CHAIN_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Data Flow</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_OPERATION_COUNT = EVENT_CHAIN_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.DataFlowConnectionImpl <em>Data Flow Connection</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.DataFlowConnectionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getDataFlowConnection()
	 * @generated
	 */
	int DATA_FLOW_CONNECTION = 24;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__INTRINSIC_ID = CONNECTION__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__NAME = CONNECTION__NAME;

	/**
	 * The feature id for the '<em><b>Activations</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__ACTIVATIONS = CONNECTION__ACTIVATIONS;

	/**
	 * The feature id for the '<em><b>Communication Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__COMMUNICATION_TYPE = CONNECTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Initial Elements</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__INITIAL_ELEMENTS = CONNECTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Max Elements</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__MAX_ELEMENTS = CONNECTION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Multi Queued</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__MULTI_QUEUED = CONNECTION_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Provider</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__PROVIDER = CONNECTION_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Requesters</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION__REQUESTERS = CONNECTION_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Data Flow Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION_FEATURE_COUNT = CONNECTION_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Data Flow Connection</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_CONNECTION_OPERATION_COUNT = CONNECTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.DataFlowEdgeImpl <em>Data Flow Edge</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.DataFlowEdgeImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getDataFlowEdge()
	 * @generated
	 */
	int DATA_FLOW_EDGE = 25;

	/**
	 * The feature id for the '<em><b>Stimulus</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_EDGE__STIMULUS = 0;

	/**
	 * The feature id for the '<em><b>Response</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_EDGE__RESPONSE = 1;

	/**
	 * The number of structural features of the '<em>Data Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_EDGE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Data Flow Edge</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_EDGE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.DataFlowReferenceImpl <em>Data Flow Reference</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.DataFlowReferenceImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getDataFlowReference()
	 * @generated
	 */
	int DATA_FLOW_REFERENCE = 26;

	/**
	 * The feature id for the '<em><b>Data Flow</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_REFERENCE__DATA_FLOW = 0;

	/**
	 * The feature id for the '<em><b>Stimulus</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_REFERENCE__STIMULUS = 1;

	/**
	 * The feature id for the '<em><b>Response</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_REFERENCE__RESPONSE = 2;

	/**
	 * The number of structural features of the '<em>Data Flow Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_REFERENCE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Data Flow Reference</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DATA_FLOW_REFERENCE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.DiscreteDistributionEntryImpl <em>Discrete Distribution Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.DiscreteDistributionEntryImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getDiscreteDistributionEntry()
	 * @generated
	 */
	int DISCRETE_DISTRIBUTION_ENTRY = 27;

	/**
	 * The feature id for the '<em><b>Count</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_DISTRIBUTION_ENTRY__COUNT = 0;

	/**
	 * The feature id for the '<em><b>Exec Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_DISTRIBUTION_ENTRY__EXEC_TIME = 1;

	/**
	 * The number of structural features of the '<em>Discrete Distribution Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_DISTRIBUTION_ENTRY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Discrete Distribution Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DISCRETE_DISTRIBUTION_ENTRY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.EnforcedMigrationImpl <em>Enforced Migration</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.EnforcedMigrationImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEnforcedMigration()
	 * @generated
	 */
	int ENFORCED_MIGRATION = 28;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENFORCED_MIGRATION__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENFORCED_MIGRATION__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENFORCED_MIGRATION__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENFORCED_MIGRATION__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The number of structural features of the '<em>Enforced Migration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENFORCED_MIGRATION_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Enforced Migration</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ENFORCED_MIGRATION_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.EstimatorSettingsImpl <em>Estimator Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.EstimatorSettingsImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEstimatorSettings()
	 * @generated
	 */
	int ESTIMATOR_SETTINGS = 29;

	/**
	 * The feature id for the '<em><b>Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS__MODEL = 0;

	/**
	 * The feature id for the '<em><b>Opt Compiler</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS__OPT_COMPILER = 1;

	/**
	 * The feature id for the '<em><b>Opt Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS__OPT_VERSION = 2;

	/**
	 * The feature id for the '<em><b>Opt Labels</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS__OPT_LABELS = 3;

	/**
	 * The feature id for the '<em><b>Opt Flags</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS__OPT_FLAGS = 4;

	/**
	 * The feature id for the '<em><b>Selected Opt</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS__SELECTED_OPT = 5;

	/**
	 * The number of structural features of the '<em>Estimator Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS_FEATURE_COUNT = 6;

	/**
	 * The number of operations of the '<em>Estimator Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ESTIMATOR_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.EventImpl <em>Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.EventImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEvent()
	 * @generated
	 */
	int EVENT = 30;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT__NAME = MODEL_OBJECT__NAME;

	/**
	 * The number of structural features of the '<em>Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.EventSequenceImpl <em>Event Sequence</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.EventSequenceImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEventSequence()
	 * @generated
	 */
	int EVENT_SEQUENCE = 33;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE__INTRINSIC_ID = EVENT_CHAIN__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE__NAME = EVENT_CHAIN__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE__OBJECT_ID = EVENT_CHAIN__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Out Of Order Reset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE__OUT_OF_ORDER_RESET = EVENT_CHAIN_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Sequence</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE__SEQUENCE = EVENT_CHAIN_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Event Sequence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE_FEATURE_COUNT = EVENT_CHAIN_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Event Sequence</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EVENT_SEQUENCE_OPERATION_COUNT = EVENT_CHAIN_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.FrequencyImpl <em>Frequency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.FrequencyImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getFrequency()
	 * @generated
	 */
	int FREQUENCY = 34;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FREQUENCY__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FREQUENCY__UNIT = 1;

	/**
	 * The number of structural features of the '<em>Frequency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FREQUENCY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Frequency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FREQUENCY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.FunctionImpl <em>Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.FunctionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getFunction()
	 * @generated
	 */
	int FUNCTION = 35;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__CALL_GRAPH = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION__TRACE_EVENTS = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.FunctionCallImpl <em>Function Call</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.FunctionCallImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getFunctionCall()
	 * @generated
	 */
	int FUNCTION_CALL = 36;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__FUNCTION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Guards</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__GUARDS = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__EVENTS = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Event Conjunction Operator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL__EVENT_CONJUNCTION_OPERATOR = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Function Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Function Call</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FUNCTION_CALL_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.GeneralInfoImpl <em>General Info</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.GeneralInfoImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getGeneralInfo()
	 * @generated
	 */
	int GENERAL_INFO = 38;

	/**
	 * The feature id for the '<em><b>Author</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__AUTHOR = 0;

	/**
	 * The feature id for the '<em><b>Creator</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__CREATOR = 1;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__DESCRIPTION = 2;

	/**
	 * The feature id for the '<em><b>Email</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__EMAIL = 3;

	/**
	 * The feature id for the '<em><b>Modified Date</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__MODIFIED_DATE = 4;

	/**
	 * The feature id for the '<em><b>Project File</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__PROJECT_FILE = 5;

	/**
	 * The feature id for the '<em><b>Project Path</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__PROJECT_PATH = 6;

	/**
	 * The feature id for the '<em><b>Save Dir</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__SAVE_DIR = 7;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO__VERSION = 8;

	/**
	 * The number of structural features of the '<em>General Info</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO_FEATURE_COUNT = 9;

	/**
	 * The number of operations of the '<em>General Info</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERAL_INFO_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.GenericSystemImpl <em>Generic System</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.GenericSystemImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getGenericSystem()
	 * @generated
	 */
	int GENERIC_SYSTEM = 39;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__INTRINSIC_ID = SYSTEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__NAME = SYSTEM__NAME;

	/**
	 * The feature id for the '<em><b>Compiler Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__COMPILER_SETTINGS = SYSTEM__COMPILER_SETTINGS;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__COMPONENTS = SYSTEM__COMPONENTS;

	/**
	 * The feature id for the '<em><b>Mode Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__MODE_CONDITIONS = SYSTEM__MODE_CONDITIONS;

	/**
	 * The feature id for the '<em><b>Mode Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__MODE_GROUPS = SYSTEM__MODE_GROUPS;

	/**
	 * The feature id for the '<em><b>Rtos Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__RTOS_MODEL = SYSTEM__RTOS_MODEL;

	/**
	 * The feature id for the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__SPEC_SETTINGS = SYSTEM__SPEC_SETTINGS;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__TRANSLATION_UNITS = SYSTEM__TRANSLATION_UNITS;

	/**
	 * The feature id for the '<em><b>Rtos Config</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM__RTOS_CONFIG = SYSTEM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Generic System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM_FEATURE_COUNT = SYSTEM_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Generic System</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int GENERIC_SYSTEM_OPERATION_COUNT = SYSTEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.HyperVisorConfigImpl <em>Hyper Visor Config</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.HyperVisorConfigImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getHyperVisorConfig()
	 * @generated
	 */
	int HYPER_VISOR_CONFIG = 40;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Hyper Visor System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG__HYPER_VISOR_SYSTEM = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Vm Schedulers</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG__VM_SCHEDULERS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Virtual Cores</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG__VIRTUAL_CORES = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Hyper Visor Config</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Hyper Visor Config</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_CONFIG_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SchedulableImpl <em>Schedulable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SchedulableImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSchedulable()
	 * @generated
	 */
	int SCHEDULABLE = 65;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE__CPU_CORES = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE__PRIORITY = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Schedulable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Schedulable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULABLE_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.HyperVisorSystemSchedulableImpl <em>Hyper Visor System Schedulable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.HyperVisorSystemSchedulableImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getHyperVisorSystemSchedulable()
	 * @generated
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE = 41;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE__INTRINSIC_ID = SCHEDULABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE__NAME = SCHEDULABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE__OBJECT_ID = SCHEDULABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE__CPU_CORES = SCHEDULABLE__CPU_CORES;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE__PRIORITY = SCHEDULABLE__PRIORITY;

	/**
	 * The feature id for the '<em><b>Virtual System</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE__VIRTUAL_SYSTEM = SCHEDULABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Hyper Visor System Schedulable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE_FEATURE_COUNT = SCHEDULABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Hyper Visor System Schedulable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_SYSTEM_SCHEDULABLE_OPERATION_COUNT = SCHEDULABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.HyperVisorVirtualCoreSchedulableImpl <em>Hyper Visor Virtual Core Schedulable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.HyperVisorVirtualCoreSchedulableImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getHyperVisorVirtualCoreSchedulable()
	 * @generated
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE = 42;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__INTRINSIC_ID = SCHEDULABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__NAME = SCHEDULABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__OBJECT_ID = SCHEDULABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__CPU_CORES = SCHEDULABLE__CPU_CORES;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__PRIORITY = SCHEDULABLE__PRIORITY;

	/**
	 * The feature id for the '<em><b>Virtual Core</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE__VIRTUAL_CORE = SCHEDULABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Hyper Visor Virtual Core Schedulable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE_FEATURE_COUNT = SCHEDULABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Hyper Visor Virtual Core Schedulable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HYPER_VISOR_VIRTUAL_CORE_SCHEDULABLE_OPERATION_COUNT = SCHEDULABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.LoadResourceImpl <em>Load Resource</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.LoadResourceImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getLoadResource()
	 * @generated
	 */
	int LOAD_RESOURCE = 43;

	/**
	 * The number of structural features of the '<em>Load Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_RESOURCE_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Load Resource</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LOAD_RESOURCE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.MemoryRegionImpl <em>Memory Region</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.MemoryRegionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getMemoryRegion()
	 * @generated
	 */
	int MEMORY_REGION = 44;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Base</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__BASE = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>File</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__FILE = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Flags</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__FLAGS = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Pages</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__PAGES = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Page Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__PAGE_SIZE = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Sections</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__SECTIONS = MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Shared Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION__SHARED_NAME = MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The number of structural features of the '<em>Memory Region</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The number of operations of the '<em>Memory Region</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MEMORY_REGION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.MessageDataImpl <em>Message Data</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.MessageDataImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getMessageData()
	 * @generated
	 */
	int MESSAGE_DATA = 45;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_DATA__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_DATA__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Size</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_DATA__SIZE = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Message Data</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_DATA_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Message Data</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MESSAGE_DATA_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeImpl <em>Mode</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getMode()
	 * @generated
	 */
	int MODE = 46;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE__VALUE = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Mode</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Mode</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeConditionImpl <em>Mode Condition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeConditionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeCondition()
	 * @generated
	 */
	int MODE_CONDITION = 47;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Conjunctions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION__CONJUNCTIONS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Mode Condition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Mode Condition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeConditionEvaluationImpl <em>Mode Condition Evaluation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeConditionEvaluationImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeConditionEvaluation()
	 * @generated
	 */
	int MODE_CONDITION_EVALUATION = 48;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION__CONDITION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Mode Condition Evaluation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Mode Condition Evaluation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONDITION_EVALUATION_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeConjunctionImpl <em>Mode Conjunction</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeConjunctionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeConjunction()
	 * @generated
	 */
	int MODE_CONJUNCTION = 49;

	/**
	 * The feature id for the '<em><b>Modes</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONJUNCTION__MODES = 0;

	/**
	 * The number of structural features of the '<em>Mode Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONJUNCTION_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Mode Conjunction</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_CONJUNCTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeGroupImpl <em>Mode Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeGroupImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeGroup()
	 * @generated
	 */
	int MODE_GROUP = 50;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_GROUP__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_GROUP__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Modes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_GROUP__MODES = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Initial Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_GROUP__INITIAL_MODE = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Mode Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_GROUP_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Mode Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_GROUP_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModelImpl <em>Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModelImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModel()
	 * @generated
	 */
	int MODEL = 51;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Bus Peripherals</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__BUS_PERIPHERALS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Clocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__CLOCKS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Cpus</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__CPUS = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__CONNECTIONS = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Event Chains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__EVENT_CHAINS = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__EVENTS = MODEL_OBJECT_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Fmi</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__FMI = MODEL_OBJECT_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>General Info</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__GENERAL_INFO = MODEL_OBJECT_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Global Mode Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__GLOBAL_MODE_CONDITIONS = MODEL_OBJECT_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Global Mode Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__GLOBAL_MODE_GROUPS = MODEL_OBJECT_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Interconnects</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__INTERCONNECTS = MODEL_OBJECT_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Memories</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__MEMORIES = MODEL_OBJECT_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Omit Call Nesting Diagram</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__OMIT_CALL_NESTING_DIAGRAM = MODEL_OBJECT_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Omit Implicit Event Chains</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__OMIT_IMPLICIT_EVENT_CHAINS = MODEL_OBJECT_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Omit Stack Diagram</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__OMIT_STACK_DIAGRAM = MODEL_OBJECT_FEATURE_COUNT + 14;

	/**
	 * The feature id for the '<em><b>Peripheral Port Connections</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__PERIPHERAL_PORT_CONNECTIONS = MODEL_OBJECT_FEATURE_COUNT + 15;

	/**
	 * The feature id for the '<em><b>Requirements</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__REQUIREMENTS = MODEL_OBJECT_FEATURE_COUNT + 16;

	/**
	 * The feature id for the '<em><b>Stimulation Scenarios</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__STIMULATION_SCENARIOS = MODEL_OBJECT_FEATURE_COUNT + 17;

	/**
	 * The feature id for the '<em><b>Default Scenario</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__DEFAULT_SCENARIO = MODEL_OBJECT_FEATURE_COUNT + 18;

	/**
	 * The feature id for the '<em><b>Systems</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__SYSTEMS = MODEL_OBJECT_FEATURE_COUNT + 19;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__TRACE_EVENTS = MODEL_OBJECT_FEATURE_COUNT + 20;

	/**
	 * The number of structural features of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 21;

	/**
	 * The number of operations of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeSwitchImpl <em>Mode Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeSwitchImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeSwitch()
	 * @generated
	 */
	int MODE_SWITCH = 53;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH__INTRINSIC_ID = GRAPH_ENTRY_BASE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH__NAME = GRAPH_ENTRY_BASE__NAME;

	/**
	 * The feature id for the '<em><b>Trigger Tokens</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH__TRIGGER_TOKENS = GRAPH_ENTRY_BASE__TRIGGER_TOKENS;

	/**
	 * The feature id for the '<em><b>Default Entry</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH__DEFAULT_ENTRY = GRAPH_ENTRY_BASE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH__ENTRIES = GRAPH_ENTRY_BASE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Evaluate Conditions On Entry</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH__EVALUATE_CONDITIONS_ON_ENTRY = GRAPH_ENTRY_BASE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Mode Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_FEATURE_COUNT = GRAPH_ENTRY_BASE_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Mode Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_OPERATION_COUNT = GRAPH_ENTRY_BASE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeSwitchDefaultImpl <em>Mode Switch Default</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeSwitchDefaultImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeSwitchDefault()
	 * @generated
	 */
	int MODE_SWITCH_DEFAULT = 54;

	/**
	 * The feature id for the '<em><b>Graph Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_DEFAULT__GRAPH_ENTRIES = 0;

	/**
	 * The number of structural features of the '<em>Mode Switch Default</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_DEFAULT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Mode Switch Default</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_DEFAULT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeSwitchEntryImpl <em>Mode Switch Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeSwitchEntryImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeSwitchEntry()
	 * @generated
	 */
	int MODE_SWITCH_ENTRY = 55;

	/**
	 * The feature id for the '<em><b>Condition</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_ENTRY__CONDITION = 0;

	/**
	 * The feature id for the '<em><b>Graph Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_ENTRY__GRAPH_ENTRIES = 1;

	/**
	 * The feature id for the '<em><b>Negated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_ENTRY__NEGATED = 2;

	/**
	 * The number of structural features of the '<em>Mode Switch Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_ENTRY_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Mode Switch Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_ENTRY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ModeSwitchPointImpl <em>Mode Switch Point</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ModeSwitchPointImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getModeSwitchPoint()
	 * @generated
	 */
	int MODE_SWITCH_POINT = 56;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Mode</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT__MODE = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Mode Switch Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Mode Switch Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODE_SWITCH_POINT_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.PartitionImpl <em>Partition</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.PartitionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getPartition()
	 * @generated
	 */
	int PARTITION = 57;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTITION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTITION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The number of structural features of the '<em>Partition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTITION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Partition</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARTITION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ProbabilitySwitchImpl <em>Probability Switch</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ProbabilitySwitchImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getProbabilitySwitch()
	 * @generated
	 */
	int PROBABILITY_SWITCH = 58;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH__INTRINSIC_ID = GRAPH_ENTRY_BASE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH__NAME = GRAPH_ENTRY_BASE__NAME;

	/**
	 * The feature id for the '<em><b>Trigger Tokens</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH__TRIGGER_TOKENS = GRAPH_ENTRY_BASE__TRIGGER_TOKENS;

	/**
	 * The feature id for the '<em><b>Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH__ENTRIES = GRAPH_ENTRY_BASE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Probability Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH_FEATURE_COUNT = GRAPH_ENTRY_BASE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Probability Switch</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH_OPERATION_COUNT = GRAPH_ENTRY_BASE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ProbabilitySwitchEntryImpl <em>Probability Switch Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ProbabilitySwitchEntryImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getProbabilitySwitchEntry()
	 * @generated
	 */
	int PROBABILITY_SWITCH_ENTRY = 59;

	/**
	 * The feature id for the '<em><b>Probability</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH_ENTRY__PROBABILITY = 0;

	/**
	 * The feature id for the '<em><b>Graph Entries</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH_ENTRY__GRAPH_ENTRIES = 1;

	/**
	 * The number of structural features of the '<em>Probability Switch Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH_ENTRY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Probability Switch Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROBABILITY_SWITCH_ENTRY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ProcessImpl <em>Process</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ProcessImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getProcess()
	 * @generated
	 */
	int PROCESS = 60;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__INTRINSIC_ID = SCHEDULABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__NAME = SCHEDULABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__OBJECT_ID = SCHEDULABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__CPU_CORES = SCHEDULABLE__CPU_CORES;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__PRIORITY = SCHEDULABLE__PRIORITY;

	/**
	 * The feature id for the '<em><b>Activation Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__ACTIVATION_LIMIT = SCHEDULABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Active At Boot</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__ACTIVE_AT_BOOT = SCHEDULABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Call Graph</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__CALL_GRAPH = SCHEDULABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Deadline</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__DEADLINE = SCHEDULABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Extended Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__EXTENDED_TASK = SCHEDULABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__TRACE_EVENTS = SCHEDULABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Idle Task</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__IDLE_TASK = SCHEDULABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Isr</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__ISR = SCHEDULABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Preemptable</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__PREEMPTABLE = SCHEDULABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Stack Limit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__STACK_LIMIT = SCHEDULABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Triggering Port</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS__TRIGGERING_PORT = SCHEDULABLE_FEATURE_COUNT + 10;

	/**
	 * The number of structural features of the '<em>Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_FEATURE_COUNT = SCHEDULABLE_FEATURE_COUNT + 11;

	/**
	 * The number of operations of the '<em>Process</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROCESS_OPERATION_COUNT = SCHEDULABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ResourceConsumptionImpl <em>Resource Consumption</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ResourceConsumptionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getResourceConsumption()
	 * @generated
	 */
	int RESOURCE_CONSUMPTION = 61;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Data Access</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__DATA_ACCESS = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Entry Function</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__ENTRY_FUNCTION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Stack Usage</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__STACK_USAGE = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Time Distribution</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__TIME_DISTRIBUTION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Use Entry Function</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION__USE_ENTRY_FUNCTION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 4;

	/**
	 * The number of structural features of the '<em>Resource Consumption</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 5;

	/**
	 * The number of operations of the '<em>Resource Consumption</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESOURCE_CONSUMPTION_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ResumeAllInterruptsImpl <em>Resume All Interrupts</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ResumeAllInterruptsImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getResumeAllInterrupts()
	 * @generated
	 */
	int RESUME_ALL_INTERRUPTS = 62;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_ALL_INTERRUPTS__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_ALL_INTERRUPTS__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_ALL_INTERRUPTS__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_ALL_INTERRUPTS__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The number of structural features of the '<em>Resume All Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_ALL_INTERRUPTS_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Resume All Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RESUME_ALL_INTERRUPTS_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.RtosConfigImpl <em>Rtos Config</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.RtosConfigImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getRtosConfig()
	 * @generated
	 */
	int RTOS_CONFIG = 63;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Schedulables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG__SCHEDULABLES = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Semaphores</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG__SEMAPHORES = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Spinlocks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG__SPINLOCKS = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG__EVENTS = MODEL_OBJECT_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Rtos Config</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Rtos Config</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_CONFIG_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.RtosModelImpl <em>Rtos Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.RtosModelImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getRtosModel()
	 * @generated
	 */
	int RTOS_MODEL = 64;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__NAME = 0;

	/**
	 * The feature id for the '<em><b>Reload Rtos Model</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__RELOAD_RTOS_MODEL = 1;

	/**
	 * The feature id for the '<em><b>Version</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__VERSION = 2;

	/**
	 * The feature id for the '<em><b>Rtos Properties</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__RTOS_PROPERTIES = 3;

	/**
	 * The feature id for the '<em><b>Return Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__RETURN_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Library</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__LIBRARY = 5;

	/**
	 * The feature id for the '<em><b>Header</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__HEADER = 6;

	/**
	 * The feature id for the '<em><b>Name Space</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__NAME_SPACE = 7;

	/**
	 * The feature id for the '<em><b>User Header</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__USER_HEADER = 8;

	/**
	 * The feature id for the '<em><b>State Names</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__STATE_NAMES = 9;

	/**
	 * The feature id for the '<em><b>Api Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__API_PREFIX = 10;

	/**
	 * The feature id for the '<em><b>Rtos Api Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL__RTOS_API_TYPE = 11;

	/**
	 * The number of structural features of the '<em>Rtos Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL_FEATURE_COUNT = 12;

	/**
	 * The number of operations of the '<em>Rtos Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RTOS_MODEL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SchedulerImpl <em>Scheduler</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SchedulerImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getScheduler()
	 * @generated
	 */
	int SCHEDULER = 66;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__INTRINSIC_ID = SCHEDULABLE__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__NAME = SCHEDULABLE__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__OBJECT_ID = SCHEDULABLE__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Cpu Cores</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__CPU_CORES = SCHEDULABLE__CPU_CORES;

	/**
	 * The feature id for the '<em><b>Priority</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__PRIORITY = SCHEDULABLE__PRIORITY;

	/**
	 * The feature id for the '<em><b>Schedulables</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__SCHEDULABLES = SCHEDULABLE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__TYPE = SCHEDULABLE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Strategy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__STRATEGY = SCHEDULABLE_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Time Slice</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__TIME_SLICE = SCHEDULABLE_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Tdma Schedule</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__TDMA_SCHEDULE = SCHEDULABLE_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Period</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__PERIOD = SCHEDULABLE_FEATURE_COUNT + 5;

	/**
	 * The feature id for the '<em><b>Synchronized</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__SYNCHRONIZED = SCHEDULABLE_FEATURE_COUNT + 6;

	/**
	 * The feature id for the '<em><b>Max Retard</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__MAX_RETARD = SCHEDULABLE_FEATURE_COUNT + 7;

	/**
	 * The feature id for the '<em><b>Max Advance</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__MAX_ADVANCE = SCHEDULABLE_FEATURE_COUNT + 8;

	/**
	 * The feature id for the '<em><b>Sync Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__SYNC_SOURCE = SCHEDULABLE_FEATURE_COUNT + 9;

	/**
	 * The feature id for the '<em><b>Cycle Start Process</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__CYCLE_START_PROCESS = SCHEDULABLE_FEATURE_COUNT + 10;

	/**
	 * The feature id for the '<em><b>Priorities Propagated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__PRIORITIES_PROPAGATED = SCHEDULABLE_FEATURE_COUNT + 11;

	/**
	 * The feature id for the '<em><b>Priority Inversed</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__PRIORITY_INVERSED = SCHEDULABLE_FEATURE_COUNT + 12;

	/**
	 * The feature id for the '<em><b>Callbacks</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__CALLBACKS = SCHEDULABLE_FEATURE_COUNT + 13;

	/**
	 * The feature id for the '<em><b>Callback Core Affinity</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER__CALLBACK_CORE_AFFINITY = SCHEDULABLE_FEATURE_COUNT + 14;

	/**
	 * The number of structural features of the '<em>Scheduler</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER_FEATURE_COUNT = SCHEDULABLE_FEATURE_COUNT + 15;

	/**
	 * The number of operations of the '<em>Scheduler</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULER_OPERATION_COUNT = SCHEDULABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SchedulingEntryImpl <em>Scheduling Entry</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SchedulingEntryImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSchedulingEntry()
	 * @generated
	 */
	int SCHEDULING_ENTRY = 67;

	/**
	 * The feature id for the '<em><b>Item</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULING_ENTRY__ITEM = 0;

	/**
	 * The feature id for the '<em><b>Slot Length</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULING_ENTRY__SLOT_LENGTH = 1;

	/**
	 * The number of structural features of the '<em>Scheduling Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULING_ENTRY_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Scheduling Entry</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULING_ENTRY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SchedulePointImpl <em>Schedule Point</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SchedulePointImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSchedulePoint()
	 * @generated
	 */
	int SCHEDULE_POINT = 68;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULE_POINT__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULE_POINT__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULE_POINT__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULE_POINT__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The number of structural features of the '<em>Schedule Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULE_POINT_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Schedule Point</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SCHEDULE_POINT_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SemaphoreImpl <em>Semaphore</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SemaphoreImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSemaphore()
	 * @generated
	 */
	int SEMAPHORE = 69;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Initial Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__INITIAL_VALUE = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Max Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE__MAX_VALUE = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Semaphore</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Semaphore</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SemaphoreAccessImpl <em>Semaphore Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SemaphoreAccessImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSemaphoreAccess()
	 * @generated
	 */
	int SEMAPHORE_ACCESS = 70;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Semaphore</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS__SEMAPHORE = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS__TYPE = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Semaphore Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Semaphore Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEMAPHORE_ACCESS_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SendMessageImpl <em>Send Message</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SendMessageImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSendMessage()
	 * @generated
	 */
	int SEND_MESSAGE = 71;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_MESSAGE__OFFSET = ACTIVATION_ACTION__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_MESSAGE__PERIOD = ACTIVATION_ACTION__PERIOD;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_MESSAGE__DELAY = ACTIVATION_ACTION__DELAY;

	/**
	 * The feature id for the '<em><b>Message</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_MESSAGE__MESSAGE = ACTIVATION_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Send Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_MESSAGE_FEATURE_COUNT = ACTIVATION_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Send Message</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SEND_MESSAGE_OPERATION_COUNT = ACTIVATION_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SetEventImpl <em>Set Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SetEventImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSetEvent()
	 * @generated
	 */
	int SET_EVENT = 72;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__OFFSET = ACTIVATION_ACTION__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__PERIOD = ACTIVATION_ACTION__PERIOD;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__DELAY = ACTIVATION_ACTION__DELAY;

	/**
	 * The feature id for the '<em><b>Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__EVENTS = ACTIVATION_ACTION_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__TARGET = ACTIVATION_ACTION_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>For All</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__FOR_ALL = ACTIVATION_ACTION_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Is Reset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT__IS_RESET = ACTIVATION_ACTION_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Set Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT_FEATURE_COUNT = ACTIVATION_ACTION_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Set Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_EVENT_OPERATION_COUNT = ACTIVATION_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SetGuardImpl <em>Set Guard</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SetGuardImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSetGuard()
	 * @generated
	 */
	int SET_GUARD = 73;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_GUARD__OFFSET = ACTIVATION_ACTION__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_GUARD__PERIOD = ACTIVATION_ACTION__PERIOD;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_GUARD__DELAY = ACTIVATION_ACTION__DELAY;

	/**
	 * The feature id for the '<em><b>Function Call</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_GUARD__FUNCTION_CALL = ACTIVATION_ACTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Set Guard</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_GUARD_FEATURE_COUNT = ACTIVATION_ACTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Set Guard</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SET_GUARD_OPERATION_COUNT = ACTIVATION_ACTION_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SourceFunctionImpl <em>Source Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SourceFunctionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSourceFunction()
	 * @generated
	 */
	int SOURCE_FUNCTION = 74;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCE_FUNCTION__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCE_FUNCTION__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCE_FUNCTION__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Trace Events</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCE_FUNCTION__TRACE_EVENTS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Source Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCE_FUNCTION_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Source Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SOURCE_FUNCTION_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SpecSettingsImpl <em>Spec Settings</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SpecSettingsImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSpecSettings()
	 * @generated
	 */
	int SPEC_SETTINGS = 75;

	/**
	 * The feature id for the '<em><b>Includes</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEC_SETTINGS__INCLUDES = 0;

	/**
	 * The feature id for the '<em><b>Macros</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEC_SETTINGS__MACROS = 1;

	/**
	 * The feature id for the '<em><b>Prepend Settings</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEC_SETTINGS__PREPEND_SETTINGS = 2;

	/**
	 * The number of structural features of the '<em>Spec Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEC_SETTINGS_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Spec Settings</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPEC_SETTINGS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SpinlockImpl <em>Spinlock</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SpinlockImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSpinlock()
	 * @generated
	 */
	int SPINLOCK = 76;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Spinlock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Spinlock</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SpinlockOperationImpl <em>Spinlock Operation</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SpinlockOperationImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSpinlockOperation()
	 * @generated
	 */
	int SPINLOCK_OPERATION = 77;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Operation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION__OPERATION = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Spinlock</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION__SPINLOCK = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Spinlock Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Spinlock Operation</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SPINLOCK_OPERATION_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.SuspendAllInterruptsImpl <em>Suspend All Interrupts</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.SuspendAllInterruptsImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSuspendAllInterrupts()
	 * @generated
	 */
	int SUSPEND_ALL_INTERRUPTS = 78;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_ALL_INTERRUPTS__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_ALL_INTERRUPTS__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_ALL_INTERRUPTS__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_ALL_INTERRUPTS__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The number of structural features of the '<em>Suspend All Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_ALL_INTERRUPTS_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Suspend All Interrupts</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUSPEND_ALL_INTERRUPTS_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.ThreadXSystemImpl <em>Thread XSystem</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.ThreadXSystemImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getThreadXSystem()
	 * @generated
	 */
	int THREAD_XSYSTEM = 80;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__INTRINSIC_ID = SYSTEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__NAME = SYSTEM__NAME;

	/**
	 * The feature id for the '<em><b>Compiler Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__COMPILER_SETTINGS = SYSTEM__COMPILER_SETTINGS;

	/**
	 * The feature id for the '<em><b>Components</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__COMPONENTS = SYSTEM__COMPONENTS;

	/**
	 * The feature id for the '<em><b>Mode Conditions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__MODE_CONDITIONS = SYSTEM__MODE_CONDITIONS;

	/**
	 * The feature id for the '<em><b>Mode Groups</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__MODE_GROUPS = SYSTEM__MODE_GROUPS;

	/**
	 * The feature id for the '<em><b>Rtos Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__RTOS_MODEL = SYSTEM__RTOS_MODEL;

	/**
	 * The feature id for the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__SPEC_SETTINGS = SYSTEM__SPEC_SETTINGS;

	/**
	 * The feature id for the '<em><b>Translation Units</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM__TRANSLATION_UNITS = SYSTEM__TRANSLATION_UNITS;

	/**
	 * The number of structural features of the '<em>Thread XSystem</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM_FEATURE_COUNT = SYSTEM_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Thread XSystem</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int THREAD_XSYSTEM_OPERATION_COUNT = SYSTEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TimeImpl <em>Time</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TimeImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTime()
	 * @generated
	 */
	int TIME = 81;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Unit</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME__UNIT = 1;

	/**
	 * The number of structural features of the '<em>Time</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_FEATURE_COUNT = 2;

	/**
	 * The operation id for the '<em>Denormalize</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME___DENORMALIZE = 0;

	/**
	 * The number of operations of the '<em>Time</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TimeDistributionImpl <em>Time Distribution</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TimeDistributionImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTimeDistribution()
	 * @generated
	 */
	int TIME_DISTRIBUTION = 82;

	/**
	 * The feature id for the '<em><b>Min</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__MIN = 0;

	/**
	 * The feature id for the '<em><b>Max</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__MAX = 1;

	/**
	 * The feature id for the '<em><b>Mean</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__MEAN = 2;

	/**
	 * The feature id for the '<em><b>Sigma</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__SIGMA = 3;

	/**
	 * The feature id for the '<em><b>Alpha</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__ALPHA = 4;

	/**
	 * The feature id for the '<em><b>Beta</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__BETA = 5;

	/**
	 * The feature id for the '<em><b>Discrete Distribution</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__DISCRETE_DISTRIBUTION = 6;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION__TYPE = 7;

	/**
	 * The number of structural features of the '<em>Time Distribution</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION_FEATURE_COUNT = 8;

	/**
	 * The number of operations of the '<em>Time Distribution</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_DISTRIBUTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TimeIntervalImpl <em>Time Interval</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TimeIntervalImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTimeInterval()
	 * @generated
	 */
	int TIME_INTERVAL = 83;

	/**
	 * The feature id for the '<em><b>Lower Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL__LOWER_LIMIT = 0;

	/**
	 * The feature id for the '<em><b>Upper Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL__UPPER_LIMIT = 1;

	/**
	 * The feature id for the '<em><b>Lower Limit Included</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL__LOWER_LIMIT_INCLUDED = 2;

	/**
	 * The feature id for the '<em><b>Upper Limit Included</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL__UPPER_LIMIT_INCLUDED = 3;

	/**
	 * The number of structural features of the '<em>Time Interval</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Time Interval</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TIME_INTERVAL_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TraceEventImpl <em>Trace Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TraceEventImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTraceEvent()
	 * @generated
	 */
	int TRACE_EVENT = 84;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT__OBJECT_ID = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT__TYPE = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Trace Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Trace Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_EVENT_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TraceObjectImpl <em>Trace Object</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TraceObjectImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTraceObject()
	 * @generated
	 */
	int TRACE_OBJECT = 85;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_OBJECT__OBJECT_ID = 0;

	/**
	 * The number of structural features of the '<em>Trace Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_OBJECT_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Trace Object</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRACE_OBJECT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TranslationUnitImpl <em>Translation Unit</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TranslationUnitImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTranslationUnit()
	 * @generated
	 */
	int TRANSLATION_UNIT = 86;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSLATION_UNIT__INTRINSIC_ID = MODEL_OBJECT__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSLATION_UNIT__NAME = MODEL_OBJECT__NAME;

	/**
	 * The feature id for the '<em><b>Source Functions</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSLATION_UNIT__SOURCE_FUNCTIONS = MODEL_OBJECT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Spec Settings</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSLATION_UNIT__SPEC_SETTINGS = MODEL_OBJECT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Translation Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSLATION_UNIT_FEATURE_COUNT = MODEL_OBJECT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Translation Unit</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSLATION_UNIT_OPERATION_COUNT = MODEL_OBJECT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.TriggerTokenImpl <em>Trigger Token</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.TriggerTokenImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTriggerToken()
	 * @generated
	 */
	int TRIGGER_TOKEN = 87;

	/**
	 * The number of structural features of the '<em>Trigger Token</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_TOKEN_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Trigger Token</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRIGGER_TOKEN_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.UserCodeEventChainImpl <em>User Code Event Chain</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.UserCodeEventChainImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getUserCodeEventChain()
	 * @generated
	 */
	int USER_CODE_EVENT_CHAIN = 88;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN__INTRINSIC_ID = EVENT_CHAIN__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN__NAME = EVENT_CHAIN__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN__OBJECT_ID = EVENT_CHAIN__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Steps</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN__STEPS = EVENT_CHAIN_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>User Code Event Chain</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_FEATURE_COUNT = EVENT_CHAIN_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>User Code Event Chain</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_OPERATION_COUNT = EVENT_CHAIN_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.UserCodeEventChainStepImpl <em>User Code Event Chain Step</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.UserCodeEventChainStepImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getUserCodeEventChainStep()
	 * @generated
	 */
	int USER_CODE_EVENT_CHAIN_STEP = 89;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP__INTRINSIC_ID = EVENT_CHAIN_STEP__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP__NAME = EVENT_CHAIN_STEP__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP__OBJECT_ID = EVENT_CHAIN_STEP__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP__LABEL = EVENT_CHAIN_STEP__LABEL;

	/**
	 * The feature id for the '<em><b>Number</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP__NUMBER = EVENT_CHAIN_STEP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>User Code Event Chain Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP_FEATURE_COUNT = EVENT_CHAIN_STEP_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>User Code Event Chain Step</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int USER_CODE_EVENT_CHAIN_STEP_OPERATION_COUNT = EVENT_CHAIN_STEP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.VariableAccessImpl <em>Variable Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.VariableAccessImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableAccess()
	 * @generated
	 */
	int VARIABLE_ACCESS = 90;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__INTRINSIC_ID = EVENT_CHAIN_STEP__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__NAME = EVENT_CHAIN_STEP__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__OBJECT_ID = EVENT_CHAIN_STEP__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__LABEL = EVENT_CHAIN_STEP__LABEL;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__OFFSET = EVENT_CHAIN_STEP_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__PERIOD = EVENT_CHAIN_STEP_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Data Access</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__DATA_ACCESS = EVENT_CHAIN_STEP_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Elements</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS__ELEMENTS = EVENT_CHAIN_STEP_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Variable Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_FEATURE_COUNT = EVENT_CHAIN_STEP_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Variable Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_ACCESS_OPERATION_COUNT = EVENT_CHAIN_STEP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.VariableReadAccessImpl <em>Variable Read Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.VariableReadAccessImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableReadAccess()
	 * @generated
	 */
	int VARIABLE_READ_ACCESS = 91;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__INTRINSIC_ID = VARIABLE_ACCESS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__NAME = VARIABLE_ACCESS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__OBJECT_ID = VARIABLE_ACCESS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__LABEL = VARIABLE_ACCESS__LABEL;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__OFFSET = VARIABLE_ACCESS__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__PERIOD = VARIABLE_ACCESS__PERIOD;

	/**
	 * The feature id for the '<em><b>Data Access</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__DATA_ACCESS = VARIABLE_ACCESS__DATA_ACCESS;

	/**
	 * The feature id for the '<em><b>Elements</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__ELEMENTS = VARIABLE_ACCESS__ELEMENTS;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__CONNECTION = VARIABLE_ACCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Data Must Be New</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__DATA_MUST_BE_NEW = VARIABLE_ACCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Index</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__INDEX = VARIABLE_ACCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Min Elements</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__MIN_ELEMENTS = VARIABLE_ACCESS_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Policy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__POLICY = VARIABLE_ACCESS_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS__TYPE = VARIABLE_ACCESS_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Variable Read Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS_FEATURE_COUNT = VARIABLE_ACCESS_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Variable Read Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_READ_ACCESS_OPERATION_COUNT = VARIABLE_ACCESS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.VariableWriteAccessImpl <em>Variable Write Access</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.VariableWriteAccessImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableWriteAccess()
	 * @generated
	 */
	int VARIABLE_WRITE_ACCESS = 92;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__INTRINSIC_ID = VARIABLE_ACCESS__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__NAME = VARIABLE_ACCESS__NAME;

	/**
	 * The feature id for the '<em><b>Object Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__OBJECT_ID = VARIABLE_ACCESS__OBJECT_ID;

	/**
	 * The feature id for the '<em><b>Label</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__LABEL = VARIABLE_ACCESS__LABEL;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__OFFSET = VARIABLE_ACCESS__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__PERIOD = VARIABLE_ACCESS__PERIOD;

	/**
	 * The feature id for the '<em><b>Data Access</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__DATA_ACCESS = VARIABLE_ACCESS__DATA_ACCESS;

	/**
	 * The feature id for the '<em><b>Elements</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__ELEMENTS = VARIABLE_ACCESS__ELEMENTS;

	/**
	 * The feature id for the '<em><b>Connection</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__CONNECTION = VARIABLE_ACCESS_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__DELAY = VARIABLE_ACCESS_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__TYPE = VARIABLE_ACCESS_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Policy</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS__POLICY = VARIABLE_ACCESS_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Variable Write Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS_FEATURE_COUNT = VARIABLE_ACCESS_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Variable Write Access</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VARIABLE_WRITE_ACCESS_OPERATION_COUNT = VARIABLE_ACCESS_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.impl.WaitEventImpl <em>Wait Event</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.impl.WaitEventImpl
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getWaitEvent()
	 * @generated
	 */
	int WAIT_EVENT = 93;

	/**
	 * The feature id for the '<em><b>Intrinsic Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__INTRINSIC_ID = CALL_SEQUENCE_ITEM__INTRINSIC_ID;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__NAME = CALL_SEQUENCE_ITEM__NAME;

	/**
	 * The feature id for the '<em><b>Offset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__OFFSET = CALL_SEQUENCE_ITEM__OFFSET;

	/**
	 * The feature id for the '<em><b>Period</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__PERIOD = CALL_SEQUENCE_ITEM__PERIOD;

	/**
	 * The feature id for the '<em><b>Events</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__EVENTS = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Timeout</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__TIMEOUT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>For Reset</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT__FOR_RESET = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Wait Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT_FEATURE_COUNT = CALL_SEQUENCE_ITEM_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Wait Event</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int WAIT_EVENT_OPERATION_COUNT = CALL_SEQUENCE_ITEM_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.BufferStrategy <em>Buffer Strategy</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.BufferStrategy
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getBufferStrategy()
	 * @generated
	 */
	int BUFFER_STRATEGY = 94;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.CallbackFunctionType <em>Callback Function Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.CallbackFunctionType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCallbackFunctionType()
	 * @generated
	 */
	int CALLBACK_FUNCTION_TYPE = 95;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.CANBusMessageFormat <em>CAN Bus Message Format</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.CANBusMessageFormat
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getCANBusMessageFormat()
	 * @generated
	 */
	int CAN_BUS_MESSAGE_FORMAT = 96;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.DataFlowCommunicationType <em>Data Flow Communication Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.DataFlowCommunicationType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getDataFlowCommunicationType()
	 * @generated
	 */
	int DATA_FLOW_COMMUNICATION_TYPE = 97;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.EventConjunctionOperatorType <em>Event Conjunction Operator Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.EventConjunctionOperatorType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getEventConjunctionOperatorType()
	 * @generated
	 */
	int EVENT_CONJUNCTION_OPERATOR_TYPE = 98;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.FrequencyUnit <em>Frequency Unit</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.FrequencyUnit
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getFrequencyUnit()
	 * @generated
	 */
	int FREQUENCY_UNIT = 99;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.MemoryRegionFlags <em>Memory Region Flags</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.MemoryRegionFlags
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getMemoryRegionFlags()
	 * @generated
	 */
	int MEMORY_REGION_FLAGS = 100;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.RtosApiType <em>Rtos Api Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.RtosApiType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getRtosApiType()
	 * @generated
	 */
	int RTOS_API_TYPE = 101;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.RtosProperty <em>Rtos Property</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.RtosProperty
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getRtosProperty()
	 * @generated
	 */
	int RTOS_PROPERTY = 102;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.SchedulerStrategy <em>Scheduler Strategy</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.SchedulerStrategy
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSchedulerStrategy()
	 * @generated
	 */
	int SCHEDULER_STRATEGY = 103;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.SchedulerType <em>Scheduler Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.SchedulerType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSchedulerType()
	 * @generated
	 */
	int SCHEDULER_TYPE = 104;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.SemaphoreAccessType <em>Semaphore Access Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.SemaphoreAccessType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSemaphoreAccessType()
	 * @generated
	 */
	int SEMAPHORE_ACCESS_TYPE = 105;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.SpinlockOperationType <em>Spinlock Operation Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.SpinlockOperationType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getSpinlockOperationType()
	 * @generated
	 */
	int SPINLOCK_OPERATION_TYPE = 106;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.TimeDistributionType <em>Time Distribution Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.TimeDistributionType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTimeDistributionType()
	 * @generated
	 */
	int TIME_DISTRIBUTION_TYPE = 107;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.TimeUnit <em>Time Unit</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.TimeUnit
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTimeUnit()
	 * @generated
	 */
	int TIME_UNIT = 108;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.TraceEventType <em>Trace Event Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.TraceEventType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getTraceEventType()
	 * @generated
	 */
	int TRACE_EVENT_TYPE = 109;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.VariableReadAccessPolicy <em>Variable Read Access Policy</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.VariableReadAccessPolicy
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableReadAccessPolicy()
	 * @generated
	 */
	int VARIABLE_READ_ACCESS_POLICY = 110;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.VariableReadAccessType <em>Variable Read Access Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.VariableReadAccessType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableReadAccessType()
	 * @generated
	 */
	int VARIABLE_READ_ACCESS_TYPE = 111;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.VariableWriteAccessPolicy <em>Variable Write Access Policy</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.VariableWriteAccessPolicy
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableWriteAccessPolicy()
	 * @generated
	 */
	int VARIABLE_WRITE_ACCESS_POLICY = 112;

	/**
	 * The meta object id for the '{@link com.inchron.realtime.root.model.VariableWriteAccessType <em>Variable Write Access Type</em>}' enum.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see com.inchron.realtime.root.model.VariableWriteAccessType
	 * @see com.inchron.realtime.root.model.impl.ModelPackageImpl#getVariableWriteAccessType()
	 * @generated
	 */
	int VARIABLE_WRITE_ACCESS_TYPE = 113;


	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.AbstractCpuModel <em>Abstract Cpu Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Abstract Cpu Model</em>'.
	 * @see com.inchron.realtime.root.model.AbstractCpuModel
	 * @generated
	 */
	EClass getAbstractCpuModel();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ActivateProcess <em>Activate Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activate Process</em>'.
	 * @see com.inchron.realtime.root.model.ActivateProcess
	 * @generated
	 */
	EClass getActivateProcess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ActivateProcess#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see com.inchron.realtime.root.model.ActivateProcess#getTarget()
	 * @see #getActivateProcess()
	 * @generated
	 */
	EReference getActivateProcess_Target();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ActivationConnection <em>Activation Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activation Connection</em>'.
	 * @see com.inchron.realtime.root.model.ActivationConnection
	 * @generated
	 */
	EClass getActivationConnection();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.ActivationConnection#getActivators <em>Activators</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Activators</em>'.
	 * @see com.inchron.realtime.root.model.ActivationConnection#getActivators()
	 * @see #getActivationConnection()
	 * @generated
	 */
	EReference getActivationConnection_Activators();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ActivationConnection#isAndSemantic <em>And Semantic</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>And Semantic</em>'.
	 * @see com.inchron.realtime.root.model.ActivationConnection#isAndSemantic()
	 * @see #getActivationConnection()
	 * @generated
	 */
	EAttribute getActivationConnection_AndSemantic();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ActivationItem <em>Activation Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activation Item</em>'.
	 * @see com.inchron.realtime.root.model.ActivationItem
	 * @generated
	 */
	EClass getActivationItem();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ActivationItem#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Connection</em>'.
	 * @see com.inchron.realtime.root.model.ActivationItem#getConnection()
	 * @see #getActivationItem()
	 * @generated
	 */
	EReference getActivationItem_Connection();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.ActivationItem#getDelay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delay</em>'.
	 * @see com.inchron.realtime.root.model.ActivationItem#getDelay()
	 * @see #getActivationItem()
	 * @generated
	 */
	EReference getActivationItem_Delay();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ActivationAction <em>Activation Action</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Activation Action</em>'.
	 * @see com.inchron.realtime.root.model.ActivationAction
	 * @generated
	 */
	EClass getActivationAction();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ActivationAction#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.ActivationAction#getOffset()
	 * @see #getActivationAction()
	 * @generated
	 */
	EAttribute getActivationAction_Offset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ActivationAction#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.ActivationAction#getPeriod()
	 * @see #getActivationAction()
	 * @generated
	 */
	EAttribute getActivationAction_Period();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.ActivationAction#getDelay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delay</em>'.
	 * @see com.inchron.realtime.root.model.ActivationAction#getDelay()
	 * @see #getActivationAction()
	 * @generated
	 */
	EReference getActivationAction_Delay();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.AddressRange <em>Address Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Address Range</em>'.
	 * @see com.inchron.realtime.root.model.AddressRange
	 * @generated
	 */
	EClass getAddressRange();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.AddressRange#getBase <em>Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Base</em>'.
	 * @see com.inchron.realtime.root.model.AddressRange#getBase()
	 * @see #getAddressRange()
	 * @generated
	 */
	EAttribute getAddressRange_Base();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.AddressRange#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see com.inchron.realtime.root.model.AddressRange#getSize()
	 * @see #getAddressRange()
	 * @generated
	 */
	EAttribute getAddressRange_Size();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ArincSystem <em>Arinc System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Arinc System</em>'.
	 * @see com.inchron.realtime.root.model.ArincSystem
	 * @generated
	 */
	EClass getArincSystem();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.BusMessage <em>Bus Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bus Message</em>'.
	 * @see com.inchron.realtime.root.model.BusMessage
	 * @generated
	 */
	EClass getBusMessage();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.BusMessage#getFullMessages <em>Full Messages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Full Messages</em>'.
	 * @see com.inchron.realtime.root.model.BusMessage#getFullMessages()
	 * @see #getBusMessage()
	 * @generated
	 */
	EReference getBusMessage_FullMessages();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.BusMessage#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.BusMessage#getEvents()
	 * @see #getBusMessage()
	 * @generated
	 */
	EReference getBusMessage_Events();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.BusMessage#getInCallGraph <em>In Call Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>In Call Graph</em>'.
	 * @see com.inchron.realtime.root.model.BusMessage#getInCallGraph()
	 * @see #getBusMessage()
	 * @generated
	 */
	EReference getBusMessage_InCallGraph();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.BusMessage#getOutCallGraph <em>Out Call Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Out Call Graph</em>'.
	 * @see com.inchron.realtime.root.model.BusMessage#getOutCallGraph()
	 * @see #getBusMessage()
	 * @generated
	 */
	EReference getBusMessage_OutCallGraph();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CallbackFunction <em>Callback Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Callback Function</em>'.
	 * @see com.inchron.realtime.root.model.CallbackFunction
	 * @generated
	 */
	EClass getCallbackFunction();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.CallbackFunction#getEntryFunction <em>Entry Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entry Function</em>'.
	 * @see com.inchron.realtime.root.model.CallbackFunction#getEntryFunction()
	 * @see #getCallbackFunction()
	 * @generated
	 */
	EReference getCallbackFunction_EntryFunction();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CallbackFunction#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.CallbackFunction#getType()
	 * @see #getCallbackFunction()
	 * @generated
	 */
	EAttribute getCallbackFunction_Type();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CallGraph <em>Call Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Graph</em>'.
	 * @see com.inchron.realtime.root.model.CallGraph
	 * @generated
	 */
	EClass getCallGraph();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CallGraph#isEndlessLoop <em>Endless Loop</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Endless Loop</em>'.
	 * @see com.inchron.realtime.root.model.CallGraph#isEndlessLoop()
	 * @see #getCallGraph()
	 * @generated
	 */
	EAttribute getCallGraph_EndlessLoop();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.CallGraph#getGraphEntries <em>Graph Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Graph Entries</em>'.
	 * @see com.inchron.realtime.root.model.CallGraph#getGraphEntries()
	 * @see #getCallGraph()
	 * @generated
	 */
	EReference getCallGraph_GraphEntries();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CallSequence <em>Call Sequence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Sequence</em>'.
	 * @see com.inchron.realtime.root.model.CallSequence
	 * @generated
	 */
	EClass getCallSequence();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.CallSequence#getCalls <em>Calls</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Calls</em>'.
	 * @see com.inchron.realtime.root.model.CallSequence#getCalls()
	 * @see #getCallSequence()
	 * @generated
	 */
	EReference getCallSequence_Calls();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CallSequenceItem <em>Call Sequence Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Call Sequence Item</em>'.
	 * @see com.inchron.realtime.root.model.CallSequenceItem
	 * @generated
	 */
	EClass getCallSequenceItem();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CallSequenceItem#getOffset <em>Offset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Offset</em>'.
	 * @see com.inchron.realtime.root.model.CallSequenceItem#getOffset()
	 * @see #getCallSequenceItem()
	 * @generated
	 */
	EAttribute getCallSequenceItem_Offset();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CallSequenceItem#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.CallSequenceItem#getPeriod()
	 * @see #getCallSequenceItem()
	 * @generated
	 */
	EAttribute getCallSequenceItem_Period();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CANBusMessage <em>CAN Bus Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>CAN Bus Message</em>'.
	 * @see com.inchron.realtime.root.model.CANBusMessage
	 * @generated
	 */
	EClass getCANBusMessage();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CANBusMessage#getFormat <em>Format</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Format</em>'.
	 * @see com.inchron.realtime.root.model.CANBusMessage#getFormat()
	 * @see #getCANBusMessage()
	 * @generated
	 */
	EAttribute getCANBusMessage_Format();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CANBusMessage#getCanId <em>Can Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Can Id</em>'.
	 * @see com.inchron.realtime.root.model.CANBusMessage#getCanId()
	 * @see #getCANBusMessage()
	 * @generated
	 */
	EAttribute getCANBusMessage_CanId();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CANBusMessage#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see com.inchron.realtime.root.model.CANBusMessage#getSize()
	 * @see #getCANBusMessage()
	 * @generated
	 */
	EAttribute getCANBusMessage_Size();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Clock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock</em>'.
	 * @see com.inchron.realtime.root.model.Clock
	 * @generated
	 */
	EClass getClock();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getFrequency <em>Frequency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Frequency</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getFrequency()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_Frequency();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getPeriod()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_Period();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Clock#getDrift <em>Drift</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Drift</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getDrift()
	 * @see #getClock()
	 * @generated
	 */
	EAttribute getClock_Drift();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getRange <em>Range</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Range</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getRange()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_Range();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getStartTimeFixed <em>Start Time Fixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Time Fixed</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getStartTimeFixed()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_StartTimeFixed();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Clock#isStartTimeIsRandom <em>Start Time Is Random</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Start Time Is Random</em>'.
	 * @see com.inchron.realtime.root.model.Clock#isStartTimeIsRandom()
	 * @see #getClock()
	 * @generated
	 */
	EAttribute getClock_StartTimeIsRandom();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getStartTimeMin <em>Start Time Min</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Time Min</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getStartTimeMin()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_StartTimeMin();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getStartTimeMax <em>Start Time Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Time Max</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getStartTimeMax()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_StartTimeMax();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Clock#getStartValue <em>Start Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Start Value</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getStartValue()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_StartValue();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.Clock#getUsers <em>Users</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Users</em>'.
	 * @see com.inchron.realtime.root.model.Clock#getUsers()
	 * @see #getClock()
	 * @generated
	 */
	EReference getClock_Users();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ClockUser <em>Clock User</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Clock User</em>'.
	 * @see com.inchron.realtime.root.model.ClockUser
	 * @generated
	 */
	EClass getClockUser();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ClockUser#getClock <em>Clock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Clock</em>'.
	 * @see com.inchron.realtime.root.model.ClockUser#getClock()
	 * @see #getClockUser()
	 * @generated
	 */
	EReference getClockUser_Clock();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Container <em>Container</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Container</em>'.
	 * @see com.inchron.realtime.root.model.Container
	 * @generated
	 */
	EClass getContainer();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Container#getContents <em>Contents</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contents</em>'.
	 * @see com.inchron.realtime.root.model.Container#getContents()
	 * @see #getContainer()
	 * @generated
	 */
	EReference getContainer_Contents();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ContainerElement <em>Container Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Container Element</em>'.
	 * @see com.inchron.realtime.root.model.ContainerElement
	 * @generated
	 */
	EClass getContainerElement();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CompilerSettings <em>Compiler Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Compiler Settings</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings
	 * @generated
	 */
	EClass getCompilerSettings();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompiler <em>Is Target Compiler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Target Compiler</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompiler()
	 * @see #getCompilerSettings()
	 * @generated
	 */
	EAttribute getCompilerSettings_IsTargetCompiler();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompilerOverrideValues <em>Is Target Compiler Override Values</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Target Compiler Override Values</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings#isIsTargetCompilerOverrideValues()
	 * @see #getCompilerSettings()
	 * @generated
	 */
	EAttribute getCompilerSettings_IsTargetCompilerOverrideValues();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CompilerSettings#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings#getType()
	 * @see #getCompilerSettings()
	 * @generated
	 */
	EAttribute getCompilerSettings_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CompilerSettings#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings#getVersion()
	 * @see #getCompilerSettings()
	 * @generated
	 */
	EAttribute getCompilerSettings_Version();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CompilerSettings#getPath <em>Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Path</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings#getPath()
	 * @see #getCompilerSettings()
	 * @generated
	 */
	EAttribute getCompilerSettings_Path();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CompilerSettings#getArgs <em>Args</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Args</em>'.
	 * @see com.inchron.realtime.root.model.CompilerSettings#getArgs()
	 * @see #getCompilerSettings()
	 * @generated
	 */
	EAttribute getCompilerSettings_Args();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Component <em>Component</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Component</em>'.
	 * @see com.inchron.realtime.root.model.Component
	 * @generated
	 */
	EClass getComponent();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Component#getVariables <em>Variables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Variables</em>'.
	 * @see com.inchron.realtime.root.model.Component#getVariables()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_Variables();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Component#getFunctions <em>Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Functions</em>'.
	 * @see com.inchron.realtime.root.model.Component#getFunctions()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_Functions();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.Component#getTranslationUnits <em>Translation Units</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Translation Units</em>'.
	 * @see com.inchron.realtime.root.model.Component#getTranslationUnits()
	 * @see #getComponent()
	 * @generated
	 */
	EReference getComponent_TranslationUnits();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ConditionalTraceEvent <em>Conditional Trace Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Conditional Trace Event</em>'.
	 * @see com.inchron.realtime.root.model.ConditionalTraceEvent
	 * @generated
	 */
	EClass getConditionalTraceEvent();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getTraceEvent <em>Trace Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Trace Event</em>'.
	 * @see com.inchron.realtime.root.model.ConditionalTraceEvent#getTraceEvent()
	 * @see #getConditionalTraceEvent()
	 * @generated
	 */
	EReference getConditionalTraceEvent_TraceEvent();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getProcess <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Process</em>'.
	 * @see com.inchron.realtime.root.model.ConditionalTraceEvent#getProcess()
	 * @see #getConditionalTraceEvent()
	 * @generated
	 */
	EReference getConditionalTraceEvent_Process();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ConditionalTraceEvent#getValueConstraint <em>Value Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value Constraint</em>'.
	 * @see com.inchron.realtime.root.model.ConditionalTraceEvent#getValueConstraint()
	 * @see #getConditionalTraceEvent()
	 * @generated
	 */
	EAttribute getConditionalTraceEvent_ValueConstraint();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Connection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Connection</em>'.
	 * @see com.inchron.realtime.root.model.Connection
	 * @generated
	 */
	EClass getConnection();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Connection#getActivations <em>Activations</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Activations</em>'.
	 * @see com.inchron.realtime.root.model.Connection#getActivations()
	 * @see #getConnection()
	 * @generated
	 */
	EReference getConnection_Activations();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Cpu <em>Cpu</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cpu</em>'.
	 * @see com.inchron.realtime.root.model.Cpu
	 * @generated
	 */
	EClass getCpu();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Cpu#getCores <em>Cores</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cores</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getCores()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_Cores();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Cpu#getCpuModel <em>Cpu Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cpu Model</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getCpuModel()
	 * @see #getCpu()
	 * @generated
	 */
	EAttribute getCpu_CpuModel();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Cpu#isReloadCpuModel <em>Reload Cpu Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Reload Cpu Model</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#isReloadCpuModel()
	 * @see #getCpu()
	 * @generated
	 */
	EAttribute getCpu_ReloadCpuModel();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Cpu#getHypervisor <em>Hypervisor</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Hypervisor</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getHypervisor()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_Hypervisor();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Cpu#getInterconnects <em>Interconnects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interconnects</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getInterconnects()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_Interconnects();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Cpu#getMemories <em>Memories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Memories</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getMemories()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_Memories();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Cpu#getMemoryRegions <em>Memory Regions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Memory Regions</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getMemoryRegions()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_MemoryRegions();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Cpu#getPartitions <em>Partitions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Partitions</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getPartitions()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_Partitions();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Cpu#getPeripherals <em>Peripherals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Peripherals</em>'.
	 * @see com.inchron.realtime.root.model.Cpu#getPeripherals()
	 * @see #getCpu()
	 * @generated
	 */
	EReference getCpu_Peripherals();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.CpuCore <em>Cpu Core</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cpu Core</em>'.
	 * @see com.inchron.realtime.root.model.CpuCore
	 * @generated
	 */
	EClass getCpuCore();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CpuCore#getPrescaler <em>Prescaler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prescaler</em>'.
	 * @see com.inchron.realtime.root.model.CpuCore#getPrescaler()
	 * @see #getCpuCore()
	 * @generated
	 */
	EAttribute getCpuCore_Prescaler();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.CpuCore#getBitWidth <em>Bit Width</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Bit Width</em>'.
	 * @see com.inchron.realtime.root.model.CpuCore#getBitWidth()
	 * @see #getCpuCore()
	 * @generated
	 */
	EAttribute getCpuCore_BitWidth();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.CpuCore#getConnectedSlave <em>Connected Slave</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Connected Slave</em>'.
	 * @see com.inchron.realtime.root.model.CpuCore#getConnectedSlave()
	 * @see #getCpuCore()
	 * @generated
	 */
	EReference getCpuCore_ConnectedSlave();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.DataFlow <em>Data Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Flow</em>'.
	 * @see com.inchron.realtime.root.model.DataFlow
	 * @generated
	 */
	EClass getDataFlow();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.DataFlow#getEdges <em>Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Edges</em>'.
	 * @see com.inchron.realtime.root.model.DataFlow#getEdges()
	 * @see #getDataFlow()
	 * @generated
	 */
	EReference getDataFlow_Edges();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.DataFlow#getReferences <em>References</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>References</em>'.
	 * @see com.inchron.realtime.root.model.DataFlow#getReferences()
	 * @see #getDataFlow()
	 * @generated
	 */
	EReference getDataFlow_References();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.DataFlowConnection <em>Data Flow Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Flow Connection</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection
	 * @generated
	 */
	EClass getDataFlowConnection();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.DataFlowConnection#getCommunicationType <em>Communication Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Communication Type</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getCommunicationType()
	 * @see #getDataFlowConnection()
	 * @generated
	 */
	EAttribute getDataFlowConnection_CommunicationType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.DataFlowConnection#getInitialElements <em>Initial Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial Elements</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getInitialElements()
	 * @see #getDataFlowConnection()
	 * @generated
	 */
	EAttribute getDataFlowConnection_InitialElements();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.DataFlowConnection#getMaxElements <em>Max Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Elements</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getMaxElements()
	 * @see #getDataFlowConnection()
	 * @generated
	 */
	EAttribute getDataFlowConnection_MaxElements();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.DataFlowConnection#isMultiQueued <em>Multi Queued</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Multi Queued</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection#isMultiQueued()
	 * @see #getDataFlowConnection()
	 * @generated
	 */
	EAttribute getDataFlowConnection_MultiQueued();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.DataFlowConnection#getProvider <em>Provider</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Provider</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getProvider()
	 * @see #getDataFlowConnection()
	 * @generated
	 */
	EReference getDataFlowConnection_Provider();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.DataFlowConnection#getRequesters <em>Requesters</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Requesters</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowConnection#getRequesters()
	 * @see #getDataFlowConnection()
	 * @generated
	 */
	EReference getDataFlowConnection_Requesters();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.DataFlowEdge <em>Data Flow Edge</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Flow Edge</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowEdge
	 * @generated
	 */
	EClass getDataFlowEdge();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.DataFlowEdge#getStimulus <em>Stimulus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Stimulus</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowEdge#getStimulus()
	 * @see #getDataFlowEdge()
	 * @generated
	 */
	EReference getDataFlowEdge_Stimulus();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.DataFlowEdge#getResponse <em>Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Response</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowEdge#getResponse()
	 * @see #getDataFlowEdge()
	 * @generated
	 */
	EReference getDataFlowEdge_Response();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.DataFlowReference <em>Data Flow Reference</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Data Flow Reference</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowReference
	 * @generated
	 */
	EClass getDataFlowReference();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.DataFlowReference#getDataFlow <em>Data Flow</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Data Flow</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowReference#getDataFlow()
	 * @see #getDataFlowReference()
	 * @generated
	 */
	EReference getDataFlowReference_DataFlow();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.DataFlowReference#getStimulus <em>Stimulus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Stimulus</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowReference#getStimulus()
	 * @see #getDataFlowReference()
	 * @generated
	 */
	EReference getDataFlowReference_Stimulus();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.DataFlowReference#getResponse <em>Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Response</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowReference#getResponse()
	 * @see #getDataFlowReference()
	 * @generated
	 */
	EReference getDataFlowReference_Response();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.DiscreteDistributionEntry <em>Discrete Distribution Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Discrete Distribution Entry</em>'.
	 * @see com.inchron.realtime.root.model.DiscreteDistributionEntry
	 * @generated
	 */
	EClass getDiscreteDistributionEntry();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.DiscreteDistributionEntry#getCount <em>Count</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Count</em>'.
	 * @see com.inchron.realtime.root.model.DiscreteDistributionEntry#getCount()
	 * @see #getDiscreteDistributionEntry()
	 * @generated
	 */
	EAttribute getDiscreteDistributionEntry_Count();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.DiscreteDistributionEntry#getExecTime <em>Exec Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Exec Time</em>'.
	 * @see com.inchron.realtime.root.model.DiscreteDistributionEntry#getExecTime()
	 * @see #getDiscreteDistributionEntry()
	 * @generated
	 */
	EReference getDiscreteDistributionEntry_ExecTime();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.EnforcedMigration <em>Enforced Migration</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Enforced Migration</em>'.
	 * @see com.inchron.realtime.root.model.EnforcedMigration
	 * @generated
	 */
	EClass getEnforcedMigration();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.EstimatorSettings <em>Estimator Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Estimator Settings</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings
	 * @generated
	 */
	EClass getEstimatorSettings();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.EstimatorSettings#getModel <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Model</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings#getModel()
	 * @see #getEstimatorSettings()
	 * @generated
	 */
	EReference getEstimatorSettings_Model();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.EstimatorSettings#getOptCompiler <em>Opt Compiler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Opt Compiler</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings#getOptCompiler()
	 * @see #getEstimatorSettings()
	 * @generated
	 */
	EAttribute getEstimatorSettings_OptCompiler();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.EstimatorSettings#getOptVersion <em>Opt Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Opt Version</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings#getOptVersion()
	 * @see #getEstimatorSettings()
	 * @generated
	 */
	EAttribute getEstimatorSettings_OptVersion();

	/**
	 * Returns the meta object for the attribute list '{@link com.inchron.realtime.root.model.EstimatorSettings#getOptLabels <em>Opt Labels</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Opt Labels</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings#getOptLabels()
	 * @see #getEstimatorSettings()
	 * @generated
	 */
	EAttribute getEstimatorSettings_OptLabels();

	/**
	 * Returns the meta object for the attribute list '{@link com.inchron.realtime.root.model.EstimatorSettings#getOptFlags <em>Opt Flags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Opt Flags</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings#getOptFlags()
	 * @see #getEstimatorSettings()
	 * @generated
	 */
	EAttribute getEstimatorSettings_OptFlags();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.EstimatorSettings#getSelectedOpt <em>Selected Opt</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Selected Opt</em>'.
	 * @see com.inchron.realtime.root.model.EstimatorSettings#getSelectedOpt()
	 * @see #getEstimatorSettings()
	 * @generated
	 */
	EAttribute getEstimatorSettings_SelectedOpt();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Event <em>Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event</em>'.
	 * @see com.inchron.realtime.root.model.Event
	 * @generated
	 */
	EClass getEvent();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.EventChain <em>Event Chain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Chain</em>'.
	 * @see com.inchron.realtime.root.model.EventChain
	 * @generated
	 */
	EClass getEventChain();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.EventChainStep <em>Event Chain Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Chain Step</em>'.
	 * @see com.inchron.realtime.root.model.EventChainStep
	 * @generated
	 */
	EClass getEventChainStep();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.EventChainStep#getLabel <em>Label</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Label</em>'.
	 * @see com.inchron.realtime.root.model.EventChainStep#getLabel()
	 * @see #getEventChainStep()
	 * @generated
	 */
	EAttribute getEventChainStep_Label();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.EventSequence <em>Event Sequence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Event Sequence</em>'.
	 * @see com.inchron.realtime.root.model.EventSequence
	 * @generated
	 */
	EClass getEventSequence();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.EventSequence#isOutOfOrderReset <em>Out Of Order Reset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Out Of Order Reset</em>'.
	 * @see com.inchron.realtime.root.model.EventSequence#isOutOfOrderReset()
	 * @see #getEventSequence()
	 * @generated
	 */
	EAttribute getEventSequence_OutOfOrderReset();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.EventSequence#getSequence <em>Sequence</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sequence</em>'.
	 * @see com.inchron.realtime.root.model.EventSequence#getSequence()
	 * @see #getEventSequence()
	 * @generated
	 */
	EReference getEventSequence_Sequence();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Frequency <em>Frequency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Frequency</em>'.
	 * @see com.inchron.realtime.root.model.Frequency
	 * @generated
	 */
	EClass getFrequency();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Frequency#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see com.inchron.realtime.root.model.Frequency#getValue()
	 * @see #getFrequency()
	 * @generated
	 */
	EAttribute getFrequency_Value();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Frequency#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see com.inchron.realtime.root.model.Frequency#getUnit()
	 * @see #getFrequency()
	 * @generated
	 */
	EAttribute getFrequency_Unit();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Function <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function</em>'.
	 * @see com.inchron.realtime.root.model.Function
	 * @generated
	 */
	EClass getFunction();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Function#getCallGraph <em>Call Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Call Graph</em>'.
	 * @see com.inchron.realtime.root.model.Function#getCallGraph()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_CallGraph();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Function#getTraceEvents <em>Trace Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Trace Events</em>'.
	 * @see com.inchron.realtime.root.model.Function#getTraceEvents()
	 * @see #getFunction()
	 * @generated
	 */
	EReference getFunction_TraceEvents();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.FunctionCall <em>Function Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Function Call</em>'.
	 * @see com.inchron.realtime.root.model.FunctionCall
	 * @generated
	 */
	EClass getFunctionCall();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.FunctionCall#getFunction <em>Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Function</em>'.
	 * @see com.inchron.realtime.root.model.FunctionCall#getFunction()
	 * @see #getFunctionCall()
	 * @generated
	 */
	EReference getFunctionCall_Function();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.FunctionCall#getGuards <em>Guards</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Guards</em>'.
	 * @see com.inchron.realtime.root.model.FunctionCall#getGuards()
	 * @see #getFunctionCall()
	 * @generated
	 */
	EReference getFunctionCall_Guards();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.FunctionCall#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.FunctionCall#getEvents()
	 * @see #getFunctionCall()
	 * @generated
	 */
	EReference getFunctionCall_Events();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.FunctionCall#getEventConjunctionOperator <em>Event Conjunction Operator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Event Conjunction Operator</em>'.
	 * @see com.inchron.realtime.root.model.FunctionCall#getEventConjunctionOperator()
	 * @see #getFunctionCall()
	 * @generated
	 */
	EAttribute getFunctionCall_EventConjunctionOperator();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.GraphEntryBase <em>Graph Entry Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Graph Entry Base</em>'.
	 * @see com.inchron.realtime.root.model.GraphEntryBase
	 * @generated
	 */
	EClass getGraphEntryBase();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.GraphEntryBase#getTriggerTokens <em>Trigger Tokens</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Trigger Tokens</em>'.
	 * @see com.inchron.realtime.root.model.GraphEntryBase#getTriggerTokens()
	 * @see #getGraphEntryBase()
	 * @generated
	 */
	EReference getGraphEntryBase_TriggerTokens();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.GeneralInfo <em>General Info</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>General Info</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo
	 * @generated
	 */
	EClass getGeneralInfo();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getAuthor <em>Author</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Author</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getAuthor()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_Author();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getCreator <em>Creator</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Creator</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getCreator()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_Creator();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getDescription()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_Description();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getEmail <em>Email</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Email</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getEmail()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_Email();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getModifiedDate <em>Modified Date</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Modified Date</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getModifiedDate()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_ModifiedDate();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getProjectFile <em>Project File</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Project File</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getProjectFile()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_ProjectFile();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getProjectPath <em>Project Path</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Project Path</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getProjectPath()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_ProjectPath();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getSaveDir <em>Save Dir</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Save Dir</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getSaveDir()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_SaveDir();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.GeneralInfo#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see com.inchron.realtime.root.model.GeneralInfo#getVersion()
	 * @see #getGeneralInfo()
	 * @generated
	 */
	EAttribute getGeneralInfo_Version();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.GenericSystem <em>Generic System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Generic System</em>'.
	 * @see com.inchron.realtime.root.model.GenericSystem
	 * @generated
	 */
	EClass getGenericSystem();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.GenericSystem#getRtosConfig <em>Rtos Config</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rtos Config</em>'.
	 * @see com.inchron.realtime.root.model.GenericSystem#getRtosConfig()
	 * @see #getGenericSystem()
	 * @generated
	 */
	EReference getGenericSystem_RtosConfig();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.HyperVisorConfig <em>Hyper Visor Config</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyper Visor Config</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorConfig
	 * @generated
	 */
	EClass getHyperVisorConfig();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.HyperVisorConfig#getHyperVisorSystem <em>Hyper Visor System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Hyper Visor System</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorConfig#getHyperVisorSystem()
	 * @see #getHyperVisorConfig()
	 * @generated
	 */
	EReference getHyperVisorConfig_HyperVisorSystem();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.HyperVisorConfig#getVmSchedulers <em>Vm Schedulers</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Vm Schedulers</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorConfig#getVmSchedulers()
	 * @see #getHyperVisorConfig()
	 * @generated
	 */
	EReference getHyperVisorConfig_VmSchedulers();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.HyperVisorConfig#getVirtualCores <em>Virtual Cores</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Virtual Cores</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorConfig#getVirtualCores()
	 * @see #getHyperVisorConfig()
	 * @generated
	 */
	EReference getHyperVisorConfig_VirtualCores();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.HyperVisorSystemSchedulable <em>Hyper Visor System Schedulable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyper Visor System Schedulable</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorSystemSchedulable
	 * @generated
	 */
	EClass getHyperVisorSystemSchedulable();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.HyperVisorSystemSchedulable#getVirtualSystem <em>Virtual System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Virtual System</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorSystemSchedulable#getVirtualSystem()
	 * @see #getHyperVisorSystemSchedulable()
	 * @generated
	 */
	EReference getHyperVisorSystemSchedulable_VirtualSystem();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.HyperVisorVirtualCoreSchedulable <em>Hyper Visor Virtual Core Schedulable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Hyper Visor Virtual Core Schedulable</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorVirtualCoreSchedulable
	 * @generated
	 */
	EClass getHyperVisorVirtualCoreSchedulable();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.HyperVisorVirtualCoreSchedulable#getVirtualCore <em>Virtual Core</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Virtual Core</em>'.
	 * @see com.inchron.realtime.root.model.HyperVisorVirtualCoreSchedulable#getVirtualCore()
	 * @see #getHyperVisorVirtualCoreSchedulable()
	 * @generated
	 */
	EReference getHyperVisorVirtualCoreSchedulable_VirtualCore();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.LoadResource <em>Load Resource</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Load Resource</em>'.
	 * @see com.inchron.realtime.root.model.LoadResource
	 * @generated
	 */
	EClass getLoadResource();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.MemoryRegion <em>Memory Region</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Memory Region</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion
	 * @generated
	 */
	EClass getMemoryRegion();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getBase <em>Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Base</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getBase()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_Base();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getFile <em>File</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>File</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getFile()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_File();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getFlags <em>Flags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Flags</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getFlags()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_Flags();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getPages <em>Pages</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Pages</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getPages()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_Pages();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getPageSize <em>Page Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Page Size</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getPageSize()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_PageSize();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getSections <em>Sections</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Sections</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getSections()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_Sections();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MemoryRegion#getSharedName <em>Shared Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Shared Name</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegion#getSharedName()
	 * @see #getMemoryRegion()
	 * @generated
	 */
	EAttribute getMemoryRegion_SharedName();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.MessageData <em>Message Data</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Message Data</em>'.
	 * @see com.inchron.realtime.root.model.MessageData
	 * @generated
	 */
	EClass getMessageData();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.MessageData#getSize <em>Size</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Size</em>'.
	 * @see com.inchron.realtime.root.model.MessageData#getSize()
	 * @see #getMessageData()
	 * @generated
	 */
	EAttribute getMessageData_Size();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Mode <em>Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode</em>'.
	 * @see com.inchron.realtime.root.model.Mode
	 * @generated
	 */
	EClass getMode();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Mode#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see com.inchron.realtime.root.model.Mode#getValue()
	 * @see #getMode()
	 * @generated
	 */
	EAttribute getMode_Value();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeCondition <em>Mode Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Condition</em>'.
	 * @see com.inchron.realtime.root.model.ModeCondition
	 * @generated
	 */
	EClass getModeCondition();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ModeCondition#getConjunctions <em>Conjunctions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Conjunctions</em>'.
	 * @see com.inchron.realtime.root.model.ModeCondition#getConjunctions()
	 * @see #getModeCondition()
	 * @generated
	 */
	EReference getModeCondition_Conjunctions();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeConditionEvaluation <em>Mode Condition Evaluation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Condition Evaluation</em>'.
	 * @see com.inchron.realtime.root.model.ModeConditionEvaluation
	 * @generated
	 */
	EClass getModeConditionEvaluation();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ModeConditionEvaluation#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Condition</em>'.
	 * @see com.inchron.realtime.root.model.ModeConditionEvaluation#getCondition()
	 * @see #getModeConditionEvaluation()
	 * @generated
	 */
	EReference getModeConditionEvaluation_Condition();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeConjunction <em>Mode Conjunction</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Conjunction</em>'.
	 * @see com.inchron.realtime.root.model.ModeConjunction
	 * @generated
	 */
	EClass getModeConjunction();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.ModeConjunction#getModes <em>Modes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Modes</em>'.
	 * @see com.inchron.realtime.root.model.ModeConjunction#getModes()
	 * @see #getModeConjunction()
	 * @generated
	 */
	EReference getModeConjunction_Modes();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeGroup <em>Mode Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Group</em>'.
	 * @see com.inchron.realtime.root.model.ModeGroup
	 * @generated
	 */
	EClass getModeGroup();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ModeGroup#getModes <em>Modes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Modes</em>'.
	 * @see com.inchron.realtime.root.model.ModeGroup#getModes()
	 * @see #getModeGroup()
	 * @generated
	 */
	EReference getModeGroup_Modes();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ModeGroup#getInitialMode <em>Initial Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Initial Mode</em>'.
	 * @see com.inchron.realtime.root.model.ModeGroup#getInitialMode()
	 * @see #getModeGroup()
	 * @generated
	 */
	EReference getModeGroup_InitialMode();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Model <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model</em>'.
	 * @see com.inchron.realtime.root.model.Model
	 * @generated
	 */
	EClass getModel();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getBusPeripherals <em>Bus Peripherals</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Bus Peripherals</em>'.
	 * @see com.inchron.realtime.root.model.Model#getBusPeripherals()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_BusPeripherals();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getClocks <em>Clocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Clocks</em>'.
	 * @see com.inchron.realtime.root.model.Model#getClocks()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Clocks();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getCpus <em>Cpus</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cpus</em>'.
	 * @see com.inchron.realtime.root.model.Model#getCpus()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Cpus();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getConnections <em>Connections</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Connections</em>'.
	 * @see com.inchron.realtime.root.model.Model#getConnections()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Connections();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getEventChains <em>Event Chains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Event Chains</em>'.
	 * @see com.inchron.realtime.root.model.Model#getEventChains()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_EventChains();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.Model#getEvents()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Events();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Model#getFmi <em>Fmi</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Fmi</em>'.
	 * @see com.inchron.realtime.root.model.Model#getFmi()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Fmi();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Model#getGeneralInfo <em>General Info</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>General Info</em>'.
	 * @see com.inchron.realtime.root.model.Model#getGeneralInfo()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_GeneralInfo();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getGlobalModeConditions <em>Global Mode Conditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Global Mode Conditions</em>'.
	 * @see com.inchron.realtime.root.model.Model#getGlobalModeConditions()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_GlobalModeConditions();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getGlobalModeGroups <em>Global Mode Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Global Mode Groups</em>'.
	 * @see com.inchron.realtime.root.model.Model#getGlobalModeGroups()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_GlobalModeGroups();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getInterconnects <em>Interconnects</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Interconnects</em>'.
	 * @see com.inchron.realtime.root.model.Model#getInterconnects()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Interconnects();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getMemories <em>Memories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Memories</em>'.
	 * @see com.inchron.realtime.root.model.Model#getMemories()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Memories();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Model#isOmitCallNestingDiagram <em>Omit Call Nesting Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Omit Call Nesting Diagram</em>'.
	 * @see com.inchron.realtime.root.model.Model#isOmitCallNestingDiagram()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_OmitCallNestingDiagram();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Model#isOmitImplicitEventChains <em>Omit Implicit Event Chains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Omit Implicit Event Chains</em>'.
	 * @see com.inchron.realtime.root.model.Model#isOmitImplicitEventChains()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_OmitImplicitEventChains();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Model#isOmitStackDiagram <em>Omit Stack Diagram</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Omit Stack Diagram</em>'.
	 * @see com.inchron.realtime.root.model.Model#isOmitStackDiagram()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_OmitStackDiagram();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getPeripheralPortConnections <em>Peripheral Port Connections</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Peripheral Port Connections</em>'.
	 * @see com.inchron.realtime.root.model.Model#getPeripheralPortConnections()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_PeripheralPortConnections();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getRequirements <em>Requirements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Requirements</em>'.
	 * @see com.inchron.realtime.root.model.Model#getRequirements()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Requirements();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getStimulationScenarios <em>Stimulation Scenarios</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Stimulation Scenarios</em>'.
	 * @see com.inchron.realtime.root.model.Model#getStimulationScenarios()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_StimulationScenarios();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.Model#getDefaultScenario <em>Default Scenario</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Default Scenario</em>'.
	 * @see com.inchron.realtime.root.model.Model#getDefaultScenario()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_DefaultScenario();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getSystems <em>Systems</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Systems</em>'.
	 * @see com.inchron.realtime.root.model.Model#getSystems()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Systems();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Model#getTraceEvents <em>Trace Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Trace Events</em>'.
	 * @see com.inchron.realtime.root.model.Model#getTraceEvents()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_TraceEvents();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModelObject <em>Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Object</em>'.
	 * @see com.inchron.realtime.root.model.ModelObject
	 * @generated
	 */
	EClass getModelObject();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ModelObject#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.inchron.realtime.root.model.ModelObject#getName()
	 * @see #getModelObject()
	 * @generated
	 */
	EAttribute getModelObject_Name();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeSwitch <em>Mode Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Switch</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitch
	 * @generated
	 */
	EClass getModeSwitch();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.ModeSwitch#getDefaultEntry <em>Default Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Default Entry</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitch#getDefaultEntry()
	 * @see #getModeSwitch()
	 * @generated
	 */
	EReference getModeSwitch_DefaultEntry();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ModeSwitch#getEntries <em>Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Entries</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitch#getEntries()
	 * @see #getModeSwitch()
	 * @generated
	 */
	EReference getModeSwitch_Entries();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ModeSwitch#isEvaluateConditionsOnEntry <em>Evaluate Conditions On Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Evaluate Conditions On Entry</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitch#isEvaluateConditionsOnEntry()
	 * @see #getModeSwitch()
	 * @generated
	 */
	EAttribute getModeSwitch_EvaluateConditionsOnEntry();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeSwitchDefault <em>Mode Switch Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Switch Default</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchDefault
	 * @generated
	 */
	EClass getModeSwitchDefault();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ModeSwitchDefault#getGraphEntries <em>Graph Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Graph Entries</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchDefault#getGraphEntries()
	 * @see #getModeSwitchDefault()
	 * @generated
	 */
	EReference getModeSwitchDefault_GraphEntries();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeSwitchEntry <em>Mode Switch Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Switch Entry</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchEntry
	 * @generated
	 */
	EClass getModeSwitchEntry();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ModeSwitchEntry#getCondition <em>Condition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Condition</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchEntry#getCondition()
	 * @see #getModeSwitchEntry()
	 * @generated
	 */
	EReference getModeSwitchEntry_Condition();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ModeSwitchEntry#getGraphEntries <em>Graph Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Graph Entries</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchEntry#getGraphEntries()
	 * @see #getModeSwitchEntry()
	 * @generated
	 */
	EReference getModeSwitchEntry_GraphEntries();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ModeSwitchEntry#isNegated <em>Negated</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Negated</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchEntry#isNegated()
	 * @see #getModeSwitchEntry()
	 * @generated
	 */
	EAttribute getModeSwitchEntry_Negated();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ModeSwitchPoint <em>Mode Switch Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mode Switch Point</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchPoint
	 * @generated
	 */
	EClass getModeSwitchPoint();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ModeSwitchPoint#getMode <em>Mode</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Mode</em>'.
	 * @see com.inchron.realtime.root.model.ModeSwitchPoint#getMode()
	 * @see #getModeSwitchPoint()
	 * @generated
	 */
	EReference getModeSwitchPoint_Mode();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Partition <em>Partition</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Partition</em>'.
	 * @see com.inchron.realtime.root.model.Partition
	 * @generated
	 */
	EClass getPartition();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ProbabilitySwitch <em>Probability Switch</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probability Switch</em>'.
	 * @see com.inchron.realtime.root.model.ProbabilitySwitch
	 * @generated
	 */
	EClass getProbabilitySwitch();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ProbabilitySwitch#getEntries <em>Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Entries</em>'.
	 * @see com.inchron.realtime.root.model.ProbabilitySwitch#getEntries()
	 * @see #getProbabilitySwitch()
	 * @generated
	 */
	EReference getProbabilitySwitch_Entries();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ProbabilitySwitchEntry <em>Probability Switch Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Probability Switch Entry</em>'.
	 * @see com.inchron.realtime.root.model.ProbabilitySwitchEntry
	 * @generated
	 */
	EClass getProbabilitySwitchEntry();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ProbabilitySwitchEntry#getProbability <em>Probability</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Probability</em>'.
	 * @see com.inchron.realtime.root.model.ProbabilitySwitchEntry#getProbability()
	 * @see #getProbabilitySwitchEntry()
	 * @generated
	 */
	EAttribute getProbabilitySwitchEntry_Probability();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ProbabilitySwitchEntry#getGraphEntries <em>Graph Entries</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Graph Entries</em>'.
	 * @see com.inchron.realtime.root.model.ProbabilitySwitchEntry#getGraphEntries()
	 * @see #getProbabilitySwitchEntry()
	 * @generated
	 */
	EReference getProbabilitySwitchEntry_GraphEntries();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Process <em>Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Process</em>'.
	 * @see com.inchron.realtime.root.model.Process
	 * @generated
	 */
	EClass getProcess();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#getActivationLimit <em>Activation Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Activation Limit</em>'.
	 * @see com.inchron.realtime.root.model.Process#getActivationLimit()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_ActivationLimit();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#isActiveAtBoot <em>Active At Boot</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Active At Boot</em>'.
	 * @see com.inchron.realtime.root.model.Process#isActiveAtBoot()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_ActiveAtBoot();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Process#getCallGraph <em>Call Graph</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Call Graph</em>'.
	 * @see com.inchron.realtime.root.model.Process#getCallGraph()
	 * @see #getProcess()
	 * @generated
	 */
	EReference getProcess_CallGraph();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Process#getDeadline <em>Deadline</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deadline</em>'.
	 * @see com.inchron.realtime.root.model.Process#getDeadline()
	 * @see #getProcess()
	 * @generated
	 */
	EReference getProcess_Deadline();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#isExtendedTask <em>Extended Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Extended Task</em>'.
	 * @see com.inchron.realtime.root.model.Process#isExtendedTask()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_ExtendedTask();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Process#getTraceEvents <em>Trace Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Trace Events</em>'.
	 * @see com.inchron.realtime.root.model.Process#getTraceEvents()
	 * @see #getProcess()
	 * @generated
	 */
	EReference getProcess_TraceEvents();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#isIdleTask <em>Idle Task</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Idle Task</em>'.
	 * @see com.inchron.realtime.root.model.Process#isIdleTask()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_IdleTask();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#isIsr <em>Isr</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Isr</em>'.
	 * @see com.inchron.realtime.root.model.Process#isIsr()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_Isr();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#isPreemptable <em>Preemptable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Preemptable</em>'.
	 * @see com.inchron.realtime.root.model.Process#isPreemptable()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_Preemptable();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Process#getStackLimit <em>Stack Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Stack Limit</em>'.
	 * @see com.inchron.realtime.root.model.Process#getStackLimit()
	 * @see #getProcess()
	 * @generated
	 */
	EAttribute getProcess_StackLimit();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.Process#getTriggeringPort <em>Triggering Port</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Triggering Port</em>'.
	 * @see com.inchron.realtime.root.model.Process#getTriggeringPort()
	 * @see #getProcess()
	 * @generated
	 */
	EReference getProcess_TriggeringPort();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ResourceConsumption <em>Resource Consumption</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resource Consumption</em>'.
	 * @see com.inchron.realtime.root.model.ResourceConsumption
	 * @generated
	 */
	EClass getResourceConsumption();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.ResourceConsumption#getDataAccess <em>Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Data Access</em>'.
	 * @see com.inchron.realtime.root.model.ResourceConsumption#getDataAccess()
	 * @see #getResourceConsumption()
	 * @generated
	 */
	EReference getResourceConsumption_DataAccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.ResourceConsumption#getEntryFunction <em>Entry Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entry Function</em>'.
	 * @see com.inchron.realtime.root.model.ResourceConsumption#getEntryFunction()
	 * @see #getResourceConsumption()
	 * @generated
	 */
	EReference getResourceConsumption_EntryFunction();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ResourceConsumption#getStackUsage <em>Stack Usage</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Stack Usage</em>'.
	 * @see com.inchron.realtime.root.model.ResourceConsumption#getStackUsage()
	 * @see #getResourceConsumption()
	 * @generated
	 */
	EAttribute getResourceConsumption_StackUsage();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.ResourceConsumption#getTimeDistribution <em>Time Distribution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Distribution</em>'.
	 * @see com.inchron.realtime.root.model.ResourceConsumption#getTimeDistribution()
	 * @see #getResourceConsumption()
	 * @generated
	 */
	EReference getResourceConsumption_TimeDistribution();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.ResourceConsumption#isUseEntryFunction <em>Use Entry Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Use Entry Function</em>'.
	 * @see com.inchron.realtime.root.model.ResourceConsumption#isUseEntryFunction()
	 * @see #getResourceConsumption()
	 * @generated
	 */
	EAttribute getResourceConsumption_UseEntryFunction();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ResumeAllInterrupts <em>Resume All Interrupts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Resume All Interrupts</em>'.
	 * @see com.inchron.realtime.root.model.ResumeAllInterrupts
	 * @generated
	 */
	EClass getResumeAllInterrupts();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.RtosConfig <em>Rtos Config</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rtos Config</em>'.
	 * @see com.inchron.realtime.root.model.RtosConfig
	 * @generated
	 */
	EClass getRtosConfig();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.RtosConfig#getSchedulables <em>Schedulables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Schedulables</em>'.
	 * @see com.inchron.realtime.root.model.RtosConfig#getSchedulables()
	 * @see #getRtosConfig()
	 * @generated
	 */
	EReference getRtosConfig_Schedulables();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.RtosConfig#getSemaphores <em>Semaphores</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Semaphores</em>'.
	 * @see com.inchron.realtime.root.model.RtosConfig#getSemaphores()
	 * @see #getRtosConfig()
	 * @generated
	 */
	EReference getRtosConfig_Semaphores();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.RtosConfig#getSpinlocks <em>Spinlocks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Spinlocks</em>'.
	 * @see com.inchron.realtime.root.model.RtosConfig#getSpinlocks()
	 * @see #getRtosConfig()
	 * @generated
	 */
	EReference getRtosConfig_Spinlocks();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.RtosConfig#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.RtosConfig#getEvents()
	 * @see #getRtosConfig()
	 * @generated
	 */
	EReference getRtosConfig_Events();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.RtosModel <em>Rtos Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rtos Model</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel
	 * @generated
	 */
	EClass getRtosModel();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getName()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_Name();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#isReloadRtosModel <em>Reload Rtos Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Reload Rtos Model</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#isReloadRtosModel()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_ReloadRtosModel();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getVersion <em>Version</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Version</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getVersion()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_Version();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getRtosProperties <em>Rtos Properties</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rtos Properties</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getRtosProperties()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_RtosProperties();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getReturnType <em>Return Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Return Type</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getReturnType()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_ReturnType();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getLibrary <em>Library</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Library</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getLibrary()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_Library();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getHeader <em>Header</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Header</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getHeader()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_Header();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getNameSpace <em>Name Space</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name Space</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getNameSpace()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_NameSpace();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getUserHeader <em>User Header</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>User Header</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getUserHeader()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_UserHeader();

	/**
	 * Returns the meta object for the attribute list '{@link com.inchron.realtime.root.model.RtosModel#getStateNames <em>State Names</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>State Names</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getStateNames()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_StateNames();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getApiPrefix <em>Api Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Api Prefix</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getApiPrefix()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_ApiPrefix();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.RtosModel#getRtosApiType <em>Rtos Api Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Rtos Api Type</em>'.
	 * @see com.inchron.realtime.root.model.RtosModel#getRtosApiType()
	 * @see #getRtosModel()
	 * @generated
	 */
	EAttribute getRtosModel_RtosApiType();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Schedulable <em>Schedulable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Schedulable</em>'.
	 * @see com.inchron.realtime.root.model.Schedulable
	 * @generated
	 */
	EClass getSchedulable();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.Schedulable#getCpuCores <em>Cpu Cores</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Cpu Cores</em>'.
	 * @see com.inchron.realtime.root.model.Schedulable#getCpuCores()
	 * @see #getSchedulable()
	 * @generated
	 */
	EReference getSchedulable_CpuCores();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Schedulable#getPriority <em>Priority</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority</em>'.
	 * @see com.inchron.realtime.root.model.Schedulable#getPriority()
	 * @see #getSchedulable()
	 * @generated
	 */
	EAttribute getSchedulable_Priority();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Scheduler <em>Scheduler</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scheduler</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler
	 * @generated
	 */
	EClass getScheduler();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Scheduler#getSchedulables <em>Schedulables</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Schedulables</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getSchedulables()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_Schedulables();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Scheduler#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getType()
	 * @see #getScheduler()
	 * @generated
	 */
	EAttribute getScheduler_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Scheduler#getStrategy <em>Strategy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Strategy</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getStrategy()
	 * @see #getScheduler()
	 * @generated
	 */
	EAttribute getScheduler_Strategy();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Scheduler#getTimeSlice <em>Time Slice</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Time Slice</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getTimeSlice()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_TimeSlice();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Scheduler#getTdmaSchedule <em>Tdma Schedule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Tdma Schedule</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getTdmaSchedule()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_TdmaSchedule();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Scheduler#getPeriod <em>Period</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Period</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getPeriod()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_Period();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Scheduler#isSynchronized <em>Synchronized</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Synchronized</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#isSynchronized()
	 * @see #getScheduler()
	 * @generated
	 */
	EAttribute getScheduler_Synchronized();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Scheduler#getMaxRetard <em>Max Retard</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Max Retard</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getMaxRetard()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_MaxRetard();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.Scheduler#getMaxAdvance <em>Max Advance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Max Advance</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getMaxAdvance()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_MaxAdvance();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.Scheduler#getSyncSource <em>Sync Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Sync Source</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getSyncSource()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_SyncSource();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.Scheduler#getCycleStartProcess <em>Cycle Start Process</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Cycle Start Process</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getCycleStartProcess()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_CycleStartProcess();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Scheduler#isPrioritiesPropagated <em>Priorities Propagated</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priorities Propagated</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#isPrioritiesPropagated()
	 * @see #getScheduler()
	 * @generated
	 */
	EAttribute getScheduler_PrioritiesPropagated();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Scheduler#isPriorityInversed <em>Priority Inversed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Priority Inversed</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#isPriorityInversed()
	 * @see #getScheduler()
	 * @generated
	 */
	EAttribute getScheduler_PriorityInversed();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.Scheduler#getCallbacks <em>Callbacks</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Callbacks</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getCallbacks()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_Callbacks();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.Scheduler#getCallbackCoreAffinity <em>Callback Core Affinity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Callback Core Affinity</em>'.
	 * @see com.inchron.realtime.root.model.Scheduler#getCallbackCoreAffinity()
	 * @see #getScheduler()
	 * @generated
	 */
	EReference getScheduler_CallbackCoreAffinity();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SchedulingEntry <em>Scheduling Entry</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Scheduling Entry</em>'.
	 * @see com.inchron.realtime.root.model.SchedulingEntry
	 * @generated
	 */
	EClass getSchedulingEntry();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.SchedulingEntry#getItem <em>Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Item</em>'.
	 * @see com.inchron.realtime.root.model.SchedulingEntry#getItem()
	 * @see #getSchedulingEntry()
	 * @generated
	 */
	EReference getSchedulingEntry_Item();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.SchedulingEntry#getSlotLength <em>Slot Length</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Slot Length</em>'.
	 * @see com.inchron.realtime.root.model.SchedulingEntry#getSlotLength()
	 * @see #getSchedulingEntry()
	 * @generated
	 */
	EReference getSchedulingEntry_SlotLength();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SchedulePoint <em>Schedule Point</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Schedule Point</em>'.
	 * @see com.inchron.realtime.root.model.SchedulePoint
	 * @generated
	 */
	EClass getSchedulePoint();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Semaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Semaphore</em>'.
	 * @see com.inchron.realtime.root.model.Semaphore
	 * @generated
	 */
	EClass getSemaphore();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Semaphore#getInitialValue <em>Initial Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Initial Value</em>'.
	 * @see com.inchron.realtime.root.model.Semaphore#getInitialValue()
	 * @see #getSemaphore()
	 * @generated
	 */
	EAttribute getSemaphore_InitialValue();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Semaphore#getMaxValue <em>Max Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Value</em>'.
	 * @see com.inchron.realtime.root.model.Semaphore#getMaxValue()
	 * @see #getSemaphore()
	 * @generated
	 */
	EAttribute getSemaphore_MaxValue();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SemaphoreAccess <em>Semaphore Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Semaphore Access</em>'.
	 * @see com.inchron.realtime.root.model.SemaphoreAccess
	 * @generated
	 */
	EClass getSemaphoreAccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.SemaphoreAccess#getSemaphore <em>Semaphore</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Semaphore</em>'.
	 * @see com.inchron.realtime.root.model.SemaphoreAccess#getSemaphore()
	 * @see #getSemaphoreAccess()
	 * @generated
	 */
	EReference getSemaphoreAccess_Semaphore();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SemaphoreAccess#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.SemaphoreAccess#getType()
	 * @see #getSemaphoreAccess()
	 * @generated
	 */
	EAttribute getSemaphoreAccess_Type();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SendMessage <em>Send Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Send Message</em>'.
	 * @see com.inchron.realtime.root.model.SendMessage
	 * @generated
	 */
	EClass getSendMessage();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.SendMessage#getMessage <em>Message</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Message</em>'.
	 * @see com.inchron.realtime.root.model.SendMessage#getMessage()
	 * @see #getSendMessage()
	 * @generated
	 */
	EReference getSendMessage_Message();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SetEvent <em>Set Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Set Event</em>'.
	 * @see com.inchron.realtime.root.model.SetEvent
	 * @generated
	 */
	EClass getSetEvent();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.SetEvent#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.SetEvent#getEvents()
	 * @see #getSetEvent()
	 * @generated
	 */
	EReference getSetEvent_Events();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.SetEvent#getTarget <em>Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target</em>'.
	 * @see com.inchron.realtime.root.model.SetEvent#getTarget()
	 * @see #getSetEvent()
	 * @generated
	 */
	EReference getSetEvent_Target();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SetEvent#isForAll <em>For All</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>For All</em>'.
	 * @see com.inchron.realtime.root.model.SetEvent#isForAll()
	 * @see #getSetEvent()
	 * @generated
	 */
	EAttribute getSetEvent_ForAll();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SetEvent#isIsReset <em>Is Reset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Reset</em>'.
	 * @see com.inchron.realtime.root.model.SetEvent#isIsReset()
	 * @see #getSetEvent()
	 * @generated
	 */
	EAttribute getSetEvent_IsReset();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SetGuard <em>Set Guard</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Set Guard</em>'.
	 * @see com.inchron.realtime.root.model.SetGuard
	 * @generated
	 */
	EClass getSetGuard();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.SetGuard#getFunctionCall <em>Function Call</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Function Call</em>'.
	 * @see com.inchron.realtime.root.model.SetGuard#getFunctionCall()
	 * @see #getSetGuard()
	 * @generated
	 */
	EReference getSetGuard_FunctionCall();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SourceFunction <em>Source Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Source Function</em>'.
	 * @see com.inchron.realtime.root.model.SourceFunction
	 * @generated
	 */
	EClass getSourceFunction();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.SourceFunction#getTraceEvents <em>Trace Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Trace Events</em>'.
	 * @see com.inchron.realtime.root.model.SourceFunction#getTraceEvents()
	 * @see #getSourceFunction()
	 * @generated
	 */
	EReference getSourceFunction_TraceEvents();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SpecSettings <em>Spec Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Spec Settings</em>'.
	 * @see com.inchron.realtime.root.model.SpecSettings
	 * @generated
	 */
	EClass getSpecSettings();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SpecSettings#getIncludes <em>Includes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Includes</em>'.
	 * @see com.inchron.realtime.root.model.SpecSettings#getIncludes()
	 * @see #getSpecSettings()
	 * @generated
	 */
	EAttribute getSpecSettings_Includes();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SpecSettings#getMacros <em>Macros</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Macros</em>'.
	 * @see com.inchron.realtime.root.model.SpecSettings#getMacros()
	 * @see #getSpecSettings()
	 * @generated
	 */
	EAttribute getSpecSettings_Macros();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SpecSettings#isPrependSettings <em>Prepend Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prepend Settings</em>'.
	 * @see com.inchron.realtime.root.model.SpecSettings#isPrependSettings()
	 * @see #getSpecSettings()
	 * @generated
	 */
	EAttribute getSpecSettings_PrependSettings();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Spinlock <em>Spinlock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Spinlock</em>'.
	 * @see com.inchron.realtime.root.model.Spinlock
	 * @generated
	 */
	EClass getSpinlock();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SpinlockOperation <em>Spinlock Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Spinlock Operation</em>'.
	 * @see com.inchron.realtime.root.model.SpinlockOperation
	 * @generated
	 */
	EClass getSpinlockOperation();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.SpinlockOperation#getOperation <em>Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Operation</em>'.
	 * @see com.inchron.realtime.root.model.SpinlockOperation#getOperation()
	 * @see #getSpinlockOperation()
	 * @generated
	 */
	EAttribute getSpinlockOperation_Operation();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.SpinlockOperation#getSpinlock <em>Spinlock</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Spinlock</em>'.
	 * @see com.inchron.realtime.root.model.SpinlockOperation#getSpinlock()
	 * @see #getSpinlockOperation()
	 * @generated
	 */
	EReference getSpinlockOperation_Spinlock();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.SuspendAllInterrupts <em>Suspend All Interrupts</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Suspend All Interrupts</em>'.
	 * @see com.inchron.realtime.root.model.SuspendAllInterrupts
	 * @generated
	 */
	EClass getSuspendAllInterrupts();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.System <em>System</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>System</em>'.
	 * @see com.inchron.realtime.root.model.System
	 * @generated
	 */
	EClass getSystem();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.System#getCompilerSettings <em>Compiler Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Compiler Settings</em>'.
	 * @see com.inchron.realtime.root.model.System#getCompilerSettings()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_CompilerSettings();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.System#getComponents <em>Components</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Components</em>'.
	 * @see com.inchron.realtime.root.model.System#getComponents()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_Components();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.System#getModeConditions <em>Mode Conditions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mode Conditions</em>'.
	 * @see com.inchron.realtime.root.model.System#getModeConditions()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_ModeConditions();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.System#getModeGroups <em>Mode Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Mode Groups</em>'.
	 * @see com.inchron.realtime.root.model.System#getModeGroups()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_ModeGroups();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.System#getRtosModel <em>Rtos Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rtos Model</em>'.
	 * @see com.inchron.realtime.root.model.System#getRtosModel()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_RtosModel();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.System#getSpecSettings <em>Spec Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Spec Settings</em>'.
	 * @see com.inchron.realtime.root.model.System#getSpecSettings()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_SpecSettings();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.System#getTranslationUnits <em>Translation Units</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Translation Units</em>'.
	 * @see com.inchron.realtime.root.model.System#getTranslationUnits()
	 * @see #getSystem()
	 * @generated
	 */
	EReference getSystem_TranslationUnits();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.ThreadXSystem <em>Thread XSystem</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Thread XSystem</em>'.
	 * @see com.inchron.realtime.root.model.ThreadXSystem
	 * @generated
	 */
	EClass getThreadXSystem();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.Time <em>Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Time</em>'.
	 * @see com.inchron.realtime.root.model.Time
	 * @generated
	 */
	EClass getTime();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Time#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see com.inchron.realtime.root.model.Time#getValue()
	 * @see #getTime()
	 * @generated
	 */
	EAttribute getTime_Value();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.Time#getUnit <em>Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unit</em>'.
	 * @see com.inchron.realtime.root.model.Time#getUnit()
	 * @see #getTime()
	 * @generated
	 */
	EAttribute getTime_Unit();

	/**
	 * Returns the meta object for the '{@link com.inchron.realtime.root.model.Time#denormalize() <em>Denormalize</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Denormalize</em>' operation.
	 * @see com.inchron.realtime.root.model.Time#denormalize()
	 * @generated
	 */
	EOperation getTime__Denormalize();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.TimeDistribution <em>Time Distribution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Time Distribution</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution
	 * @generated
	 */
	EClass getTimeDistribution();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TimeDistribution#getMin <em>Min</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Min</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getMin()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EReference getTimeDistribution_Min();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TimeDistribution#getMax <em>Max</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Max</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getMax()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EReference getTimeDistribution_Max();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TimeDistribution#getMean <em>Mean</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Mean</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getMean()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EReference getTimeDistribution_Mean();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TimeDistribution#getSigma <em>Sigma</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Sigma</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getSigma()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EReference getTimeDistribution_Sigma();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TimeDistribution#getAlpha <em>Alpha</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Alpha</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getAlpha()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EAttribute getTimeDistribution_Alpha();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TimeDistribution#getBeta <em>Beta</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Beta</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getBeta()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EAttribute getTimeDistribution_Beta();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.TimeDistribution#getDiscreteDistribution <em>Discrete Distribution</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Discrete Distribution</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getDiscreteDistribution()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EReference getTimeDistribution_DiscreteDistribution();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TimeDistribution#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistribution#getType()
	 * @see #getTimeDistribution()
	 * @generated
	 */
	EAttribute getTimeDistribution_Type();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.TimeInterval <em>Time Interval</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Time Interval</em>'.
	 * @see com.inchron.realtime.root.model.TimeInterval
	 * @generated
	 */
	EClass getTimeInterval();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TimeInterval#getLowerLimit <em>Lower Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Lower Limit</em>'.
	 * @see com.inchron.realtime.root.model.TimeInterval#getLowerLimit()
	 * @see #getTimeInterval()
	 * @generated
	 */
	EReference getTimeInterval_LowerLimit();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TimeInterval#getUpperLimit <em>Upper Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Upper Limit</em>'.
	 * @see com.inchron.realtime.root.model.TimeInterval#getUpperLimit()
	 * @see #getTimeInterval()
	 * @generated
	 */
	EReference getTimeInterval_UpperLimit();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TimeInterval#isLowerLimitIncluded <em>Lower Limit Included</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Lower Limit Included</em>'.
	 * @see com.inchron.realtime.root.model.TimeInterval#isLowerLimitIncluded()
	 * @see #getTimeInterval()
	 * @generated
	 */
	EAttribute getTimeInterval_LowerLimitIncluded();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TimeInterval#isUpperLimitIncluded <em>Upper Limit Included</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Upper Limit Included</em>'.
	 * @see com.inchron.realtime.root.model.TimeInterval#isUpperLimitIncluded()
	 * @see #getTimeInterval()
	 * @generated
	 */
	EAttribute getTimeInterval_UpperLimitIncluded();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.TraceEvent <em>Trace Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trace Event</em>'.
	 * @see com.inchron.realtime.root.model.TraceEvent
	 * @generated
	 */
	EClass getTraceEvent();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TraceEvent#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.TraceEvent#getType()
	 * @see #getTraceEvent()
	 * @generated
	 */
	EAttribute getTraceEvent_Type();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.TraceObject <em>Trace Object</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trace Object</em>'.
	 * @see com.inchron.realtime.root.model.TraceObject
	 * @generated
	 */
	EClass getTraceObject();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.TraceObject#getObjectId <em>Object Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Object Id</em>'.
	 * @see com.inchron.realtime.root.model.TraceObject#getObjectId()
	 * @see #getTraceObject()
	 * @generated
	 */
	EAttribute getTraceObject_ObjectId();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.TranslationUnit <em>Translation Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Translation Unit</em>'.
	 * @see com.inchron.realtime.root.model.TranslationUnit
	 * @generated
	 */
	EClass getTranslationUnit();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.TranslationUnit#getSourceFunctions <em>Source Functions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Source Functions</em>'.
	 * @see com.inchron.realtime.root.model.TranslationUnit#getSourceFunctions()
	 * @see #getTranslationUnit()
	 * @generated
	 */
	EReference getTranslationUnit_SourceFunctions();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.TranslationUnit#getSpecSettings <em>Spec Settings</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Spec Settings</em>'.
	 * @see com.inchron.realtime.root.model.TranslationUnit#getSpecSettings()
	 * @see #getTranslationUnit()
	 * @generated
	 */
	EReference getTranslationUnit_SpecSettings();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.TriggerToken <em>Trigger Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Trigger Token</em>'.
	 * @see com.inchron.realtime.root.model.TriggerToken
	 * @generated
	 */
	EClass getTriggerToken();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.UserCodeEventChain <em>User Code Event Chain</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>User Code Event Chain</em>'.
	 * @see com.inchron.realtime.root.model.UserCodeEventChain
	 * @generated
	 */
	EClass getUserCodeEventChain();

	/**
	 * Returns the meta object for the containment reference list '{@link com.inchron.realtime.root.model.UserCodeEventChain#getSteps <em>Steps</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Steps</em>'.
	 * @see com.inchron.realtime.root.model.UserCodeEventChain#getSteps()
	 * @see #getUserCodeEventChain()
	 * @generated
	 */
	EReference getUserCodeEventChain_Steps();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.UserCodeEventChainStep <em>User Code Event Chain Step</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>User Code Event Chain Step</em>'.
	 * @see com.inchron.realtime.root.model.UserCodeEventChainStep
	 * @generated
	 */
	EClass getUserCodeEventChainStep();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.UserCodeEventChainStep#getNumber <em>Number</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Number</em>'.
	 * @see com.inchron.realtime.root.model.UserCodeEventChainStep#getNumber()
	 * @see #getUserCodeEventChainStep()
	 * @generated
	 */
	EAttribute getUserCodeEventChainStep_Number();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.VariableAccess <em>Variable Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Access</em>'.
	 * @see com.inchron.realtime.root.model.VariableAccess
	 * @generated
	 */
	EClass getVariableAccess();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.VariableAccess#getDataAccess <em>Data Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Data Access</em>'.
	 * @see com.inchron.realtime.root.model.VariableAccess#getDataAccess()
	 * @see #getVariableAccess()
	 * @generated
	 */
	EReference getVariableAccess_DataAccess();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableAccess#getElements <em>Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Elements</em>'.
	 * @see com.inchron.realtime.root.model.VariableAccess#getElements()
	 * @see #getVariableAccess()
	 * @generated
	 */
	EAttribute getVariableAccess_Elements();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.VariableReadAccess <em>Variable Read Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Read Access</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess
	 * @generated
	 */
	EClass getVariableReadAccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.VariableReadAccess#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Connection</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess#getConnection()
	 * @see #getVariableReadAccess()
	 * @generated
	 */
	EReference getVariableReadAccess_Connection();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableReadAccess#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess#getType()
	 * @see #getVariableReadAccess()
	 * @generated
	 */
	EAttribute getVariableReadAccess_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableReadAccess#getIndex <em>Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Index</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess#getIndex()
	 * @see #getVariableReadAccess()
	 * @generated
	 */
	EAttribute getVariableReadAccess_Index();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableReadAccess#getMinElements <em>Min Elements</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Min Elements</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess#getMinElements()
	 * @see #getVariableReadAccess()
	 * @generated
	 */
	EAttribute getVariableReadAccess_MinElements();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableReadAccess#getPolicy <em>Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Policy</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess#getPolicy()
	 * @see #getVariableReadAccess()
	 * @generated
	 */
	EAttribute getVariableReadAccess_Policy();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableReadAccess#isDataMustBeNew <em>Data Must Be New</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Data Must Be New</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccess#isDataMustBeNew()
	 * @see #getVariableReadAccess()
	 * @generated
	 */
	EAttribute getVariableReadAccess_DataMustBeNew();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.VariableWriteAccess <em>Variable Write Access</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Variable Write Access</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccess
	 * @generated
	 */
	EClass getVariableWriteAccess();

	/**
	 * Returns the meta object for the reference '{@link com.inchron.realtime.root.model.VariableWriteAccess#getConnection <em>Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Connection</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccess#getConnection()
	 * @see #getVariableWriteAccess()
	 * @generated
	 */
	EReference getVariableWriteAccess_Connection();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.VariableWriteAccess#getDelay <em>Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Delay</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccess#getDelay()
	 * @see #getVariableWriteAccess()
	 * @generated
	 */
	EReference getVariableWriteAccess_Delay();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableWriteAccess#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Type</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccess#getType()
	 * @see #getVariableWriteAccess()
	 * @generated
	 */
	EAttribute getVariableWriteAccess_Type();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.VariableWriteAccess#getPolicy <em>Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Policy</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccess#getPolicy()
	 * @see #getVariableWriteAccess()
	 * @generated
	 */
	EAttribute getVariableWriteAccess_Policy();

	/**
	 * Returns the meta object for class '{@link com.inchron.realtime.root.model.WaitEvent <em>Wait Event</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Wait Event</em>'.
	 * @see com.inchron.realtime.root.model.WaitEvent
	 * @generated
	 */
	EClass getWaitEvent();

	/**
	 * Returns the meta object for the reference list '{@link com.inchron.realtime.root.model.WaitEvent#getEvents <em>Events</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Events</em>'.
	 * @see com.inchron.realtime.root.model.WaitEvent#getEvents()
	 * @see #getWaitEvent()
	 * @generated
	 */
	EReference getWaitEvent_Events();

	/**
	 * Returns the meta object for the containment reference '{@link com.inchron.realtime.root.model.WaitEvent#getTimeout <em>Timeout</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Timeout</em>'.
	 * @see com.inchron.realtime.root.model.WaitEvent#getTimeout()
	 * @see #getWaitEvent()
	 * @generated
	 */
	EReference getWaitEvent_Timeout();

	/**
	 * Returns the meta object for the attribute '{@link com.inchron.realtime.root.model.WaitEvent#isForReset <em>For Reset</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>For Reset</em>'.
	 * @see com.inchron.realtime.root.model.WaitEvent#isForReset()
	 * @see #getWaitEvent()
	 * @generated
	 */
	EAttribute getWaitEvent_ForReset();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.BufferStrategy <em>Buffer Strategy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Buffer Strategy</em>'.
	 * @see com.inchron.realtime.root.model.BufferStrategy
	 * @generated
	 */
	EEnum getBufferStrategy();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.CallbackFunctionType <em>Callback Function Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Callback Function Type</em>'.
	 * @see com.inchron.realtime.root.model.CallbackFunctionType
	 * @generated
	 */
	EEnum getCallbackFunctionType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.CANBusMessageFormat <em>CAN Bus Message Format</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>CAN Bus Message Format</em>'.
	 * @see com.inchron.realtime.root.model.CANBusMessageFormat
	 * @generated
	 */
	EEnum getCANBusMessageFormat();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.DataFlowCommunicationType <em>Data Flow Communication Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Data Flow Communication Type</em>'.
	 * @see com.inchron.realtime.root.model.DataFlowCommunicationType
	 * @generated
	 */
	EEnum getDataFlowCommunicationType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.EventConjunctionOperatorType <em>Event Conjunction Operator Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Event Conjunction Operator Type</em>'.
	 * @see com.inchron.realtime.root.model.EventConjunctionOperatorType
	 * @generated
	 */
	EEnum getEventConjunctionOperatorType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.FrequencyUnit <em>Frequency Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Frequency Unit</em>'.
	 * @see com.inchron.realtime.root.model.FrequencyUnit
	 * @generated
	 */
	EEnum getFrequencyUnit();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.MemoryRegionFlags <em>Memory Region Flags</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Memory Region Flags</em>'.
	 * @see com.inchron.realtime.root.model.MemoryRegionFlags
	 * @generated
	 */
	EEnum getMemoryRegionFlags();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.RtosApiType <em>Rtos Api Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Rtos Api Type</em>'.
	 * @see com.inchron.realtime.root.model.RtosApiType
	 * @generated
	 */
	EEnum getRtosApiType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.RtosProperty <em>Rtos Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Rtos Property</em>'.
	 * @see com.inchron.realtime.root.model.RtosProperty
	 * @generated
	 */
	EEnum getRtosProperty();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.SchedulerStrategy <em>Scheduler Strategy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Scheduler Strategy</em>'.
	 * @see com.inchron.realtime.root.model.SchedulerStrategy
	 * @generated
	 */
	EEnum getSchedulerStrategy();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.SchedulerType <em>Scheduler Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Scheduler Type</em>'.
	 * @see com.inchron.realtime.root.model.SchedulerType
	 * @generated
	 */
	EEnum getSchedulerType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.SemaphoreAccessType <em>Semaphore Access Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Semaphore Access Type</em>'.
	 * @see com.inchron.realtime.root.model.SemaphoreAccessType
	 * @generated
	 */
	EEnum getSemaphoreAccessType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.SpinlockOperationType <em>Spinlock Operation Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Spinlock Operation Type</em>'.
	 * @see com.inchron.realtime.root.model.SpinlockOperationType
	 * @generated
	 */
	EEnum getSpinlockOperationType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.TimeDistributionType <em>Time Distribution Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Time Distribution Type</em>'.
	 * @see com.inchron.realtime.root.model.TimeDistributionType
	 * @generated
	 */
	EEnum getTimeDistributionType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.TimeUnit <em>Time Unit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Time Unit</em>'.
	 * @see com.inchron.realtime.root.model.TimeUnit
	 * @generated
	 */
	EEnum getTimeUnit();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.TraceEventType <em>Trace Event Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Trace Event Type</em>'.
	 * @see com.inchron.realtime.root.model.TraceEventType
	 * @generated
	 */
	EEnum getTraceEventType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.VariableReadAccessPolicy <em>Variable Read Access Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Variable Read Access Policy</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccessPolicy
	 * @generated
	 */
	EEnum getVariableReadAccessPolicy();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.VariableReadAccessType <em>Variable Read Access Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Variable Read Access Type</em>'.
	 * @see com.inchron.realtime.root.model.VariableReadAccessType
	 * @generated
	 */
	EEnum getVariableReadAccessType();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.VariableWriteAccessPolicy <em>Variable Write Access Policy</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Variable Write Access Policy</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccessPolicy
	 * @generated
	 */
	EEnum getVariableWriteAccessPolicy();

	/**
	 * Returns the meta object for enum '{@link com.inchron.realtime.root.model.VariableWriteAccessType <em>Variable Write Access Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for enum '<em>Variable Write Access Type</em>'.
	 * @see com.inchron.realtime.root.model.VariableWriteAccessType
	 * @generated
	 */
	EEnum getVariableWriteAccessType();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ModelFactory getModelFactory();

} //ModelPackage
